/*Header-MicMac-eLiSe-25/06/2007

    MicMac : Multi Image Correspondances par Methodes Automatiques de Correlation
    eLiSe  : ELements of an Image Software Environnement

    www.micmac.ign.fr

   
    Copyright : Institut Geographique National
    Author : Marc Pierrot Deseilligny
    Contributors : Gregoire Maillet, Didier Boldo.

[1] M. Pierrot-Deseilligny, N. Paparoditis.
    "A multiresolution and optimization-based image matching approach:
    An application to surface reconstruction from SPOT5-HRS stereo imagery."
    In IAPRS vol XXXVI-1/W41 in ISPRS Workshop On Topographic Mapping From Space
    (With Special Emphasis on Small Satellites), Ankara, Turquie, 02-2006.

[2] M. Pierrot-Deseilligny, "MicMac, un lociel de mise en correspondance
    d'images, adapte au contexte geograhique" to appears in 
    Bulletin d'information de l'Institut Geographique National, 2007.

Francais :

   MicMac est un logiciel de mise en correspondance d'image adapte 
   au contexte de recherche en information geographique. Il s'appuie sur
   la bibliotheque de manipulation d'image eLiSe. Il est distibue sous la
   licences Cecill-B.  Voir en bas de fichier et  http://www.cecill.info.


English :

    MicMac is an open source software specialized in image matching
    for research in geographic information. MicMac is built on the
    eLiSe image library. MicMac is governed by the  "Cecill-B licence".
    See below and http://www.cecill.info.

Header-MicMac-eLiSe-25/06/2007*/
// File Automatically generated by eLiSe

#include "general/all.h"
#include "private/all.h"
#include "cEqAppuiXDRad5.h"


cEqAppuiXDRad5::cEqAppuiXDRad5():
    cElCompiledFonc(1)
{
   AddIntRef (cIncIntervale("Intr",0,10));
   AddIntRef (cIncIntervale("Orient",10,16));
   Close(false);
}



void cEqAppuiXDRad5::ComputeVal()
{
   double tmp0_ = mCompCoord[3];
   double tmp1_ = mLocXIm-tmp0_;
   double tmp2_ = mCompCoord[4];
   double tmp3_ = mLocYIm-tmp2_;
   double tmp4_ = (tmp1_)*(tmp1_);
   double tmp5_ = (tmp3_)*(tmp3_);
   double tmp6_ = tmp4_+tmp5_;
   double tmp7_ = (tmp6_)*(tmp6_);
   double tmp8_ = tmp7_*(tmp6_);
   double tmp9_ = tmp8_*(tmp6_);
   double tmp10_ = mCompCoord[10];
   double tmp11_ = mCompCoord[11];
   double tmp12_ = cos(tmp11_);
   double tmp13_ = sin(tmp10_);
   double tmp14_ = cos(tmp10_);
   double tmp15_ = sin(tmp11_);
   double tmp16_ = mCompCoord[12];
   double tmp17_ = mCompCoord[13];
   double tmp18_ = mLocXTer-tmp17_;
   double tmp19_ = sin(tmp16_);
   double tmp20_ = -(tmp19_);
   double tmp21_ = -(tmp15_);
   double tmp22_ = cos(tmp16_);
   double tmp23_ = mCompCoord[14];
   double tmp24_ = mLocYTer-tmp23_;
   double tmp25_ = mCompCoord[15];
   double tmp26_ = mLocZTer-tmp25_;

  mVal[0] = ((tmp0_+(tmp1_)*(1+(tmp6_)*mCompCoord[5]+tmp7_*mCompCoord[6]+tmp8_*mCompCoord[7]+tmp9_*mCompCoord[8]+tmp9_*(tmp6_)*mCompCoord[9]))-mCompCoord[1])/mCompCoord[0]-(tmp14_*tmp12_*(tmp18_)+tmp13_*tmp12_*(tmp24_)+tmp15_*(tmp26_))/((-(tmp13_)*tmp20_+tmp14_*tmp21_*tmp22_)*(tmp18_)+(tmp14_*tmp20_+tmp13_*tmp21_*tmp22_)*(tmp24_)+tmp12_*tmp22_*(tmp26_));

}


void cEqAppuiXDRad5::ComputeValDeriv()
{
   double tmp0_ = mCompCoord[3];
   double tmp1_ = mLocXIm-tmp0_;
   double tmp2_ = mCompCoord[4];
   double tmp3_ = mLocYIm-tmp2_;
   double tmp4_ = (tmp1_)*(tmp1_);
   double tmp5_ = (tmp3_)*(tmp3_);
   double tmp6_ = tmp4_+tmp5_;
   double tmp7_ = (tmp6_)*(tmp6_);
   double tmp8_ = tmp7_*(tmp6_);
   double tmp9_ = tmp8_*(tmp6_);
   double tmp10_ = mCompCoord[10];
   double tmp11_ = mCompCoord[11];
   double tmp12_ = cos(tmp11_);
   double tmp13_ = sin(tmp10_);
   double tmp14_ = cos(tmp10_);
   double tmp15_ = sin(tmp11_);
   double tmp16_ = mCompCoord[12];
   double tmp17_ = mCompCoord[13];
   double tmp18_ = mLocXTer-tmp17_;
   double tmp19_ = sin(tmp16_);
   double tmp20_ = -(tmp19_);
   double tmp21_ = -(tmp15_);
   double tmp22_ = cos(tmp16_);
   double tmp23_ = mCompCoord[14];
   double tmp24_ = mLocYTer-tmp23_;
   double tmp25_ = mCompCoord[15];
   double tmp26_ = mLocZTer-tmp25_;
   double tmp27_ = mCompCoord[5];
   double tmp28_ = (tmp6_)*tmp27_;
   double tmp29_ = 1+tmp28_;
   double tmp30_ = mCompCoord[6];
   double tmp31_ = tmp7_*tmp30_;
   double tmp32_ = tmp29_+tmp31_;
   double tmp33_ = mCompCoord[7];
   double tmp34_ = tmp8_*tmp33_;
   double tmp35_ = tmp32_+tmp34_;
   double tmp36_ = mCompCoord[8];
   double tmp37_ = tmp9_*tmp36_;
   double tmp38_ = tmp35_+tmp37_;
   double tmp39_ = tmp9_*(tmp6_);
   double tmp40_ = mCompCoord[9];
   double tmp41_ = tmp39_*tmp40_;
   double tmp42_ = tmp38_+tmp41_;
   double tmp43_ = (tmp1_)*(tmp42_);
   double tmp44_ = tmp0_+tmp43_;
   double tmp45_ = mCompCoord[1];
   double tmp46_ = (tmp44_)-tmp45_;
   double tmp47_ = mCompCoord[0];
   double tmp48_ = ElSquare(tmp47_);
   double tmp49_ = -(1);
   double tmp50_ = tmp49_*(tmp1_);
   double tmp51_ = tmp50_+tmp50_;
   double tmp52_ = (tmp51_)*(tmp6_);
   double tmp53_ = tmp52_+tmp52_;
   double tmp54_ = (tmp53_)*(tmp6_);
   double tmp55_ = (tmp51_)*tmp7_;
   double tmp56_ = tmp54_+tmp55_;
   double tmp57_ = (tmp56_)*(tmp6_);
   double tmp58_ = (tmp51_)*tmp8_;
   double tmp59_ = tmp57_+tmp58_;
   double tmp60_ = tmp49_*(tmp3_);
   double tmp61_ = tmp60_+tmp60_;
   double tmp62_ = (tmp61_)*(tmp6_);
   double tmp63_ = tmp62_+tmp62_;
   double tmp64_ = (tmp63_)*(tmp6_);
   double tmp65_ = (tmp61_)*tmp7_;
   double tmp66_ = tmp64_+tmp65_;
   double tmp67_ = (tmp66_)*(tmp6_);
   double tmp68_ = (tmp61_)*tmp8_;
   double tmp69_ = tmp67_+tmp68_;
   double tmp70_ = tmp14_*tmp12_;
   double tmp71_ = -(tmp13_);
   double tmp72_ = tmp71_*tmp20_;
   double tmp73_ = tmp14_*tmp21_;
   double tmp74_ = tmp73_*tmp22_;
   double tmp75_ = tmp72_+tmp74_;
   double tmp76_ = (tmp75_)*(tmp18_);
   double tmp77_ = tmp14_*tmp20_;
   double tmp78_ = tmp13_*tmp21_;
   double tmp79_ = tmp78_*tmp22_;
   double tmp80_ = tmp77_+tmp79_;
   double tmp81_ = (tmp80_)*(tmp24_);
   double tmp82_ = tmp76_+tmp81_;
   double tmp83_ = tmp12_*tmp22_;
   double tmp84_ = tmp83_*(tmp26_);
   double tmp85_ = tmp82_+tmp84_;
   double tmp86_ = tmp70_*(tmp18_);
   double tmp87_ = tmp13_*tmp12_;
   double tmp88_ = tmp87_*(tmp24_);
   double tmp89_ = tmp86_+tmp88_;
   double tmp90_ = tmp15_*(tmp26_);
   double tmp91_ = tmp89_+tmp90_;
   double tmp92_ = tmp49_*tmp13_;
   double tmp93_ = tmp49_*tmp15_;
   double tmp94_ = -(tmp12_);
   double tmp95_ = ElSquare(tmp85_);
   double tmp96_ = -(tmp22_);
   double tmp97_ = tmp49_*tmp19_;

  mVal[0] = (tmp46_)/tmp47_-(tmp91_)/(tmp85_);

  mCompDer[0][0] = -(tmp46_)/tmp48_;
  mCompDer[0][1] = (tmp49_*tmp47_)/tmp48_;
  mCompDer[0][2] = 0;
  mCompDer[0][3] = ((1+tmp49_*(tmp42_)+((tmp51_)*tmp27_+(tmp53_)*tmp30_+(tmp56_)*tmp33_+(tmp59_)*tmp36_+((tmp59_)*(tmp6_)+(tmp51_)*tmp9_)*tmp40_)*(tmp1_))*tmp47_)/tmp48_;
  mCompDer[0][4] = (((tmp61_)*tmp27_+(tmp63_)*tmp30_+(tmp66_)*tmp33_+(tmp69_)*tmp36_+((tmp69_)*(tmp6_)+(tmp61_)*tmp9_)*tmp40_)*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][5] = ((tmp6_)*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][6] = (tmp7_*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][7] = (tmp8_*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][8] = (tmp9_*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][9] = (tmp39_*(tmp1_)*tmp47_)/tmp48_;
  mCompDer[0][10] = -(((tmp92_*tmp12_*(tmp18_)+tmp70_*(tmp24_))*(tmp85_)-(tmp91_)*((-(tmp14_)*tmp20_+tmp92_*tmp21_*tmp22_)*(tmp18_)+(tmp92_*tmp20_+tmp74_)*(tmp24_)))/tmp95_);
  mCompDer[0][11] = -(((tmp93_*tmp14_*(tmp18_)+tmp93_*tmp13_*(tmp24_)+tmp12_*(tmp26_))*(tmp85_)-(tmp91_)*(tmp94_*tmp14_*tmp22_*(tmp18_)+tmp94_*tmp13_*tmp22_*(tmp24_)+tmp93_*tmp22_*(tmp26_)))/tmp95_);
  mCompDer[0][12] = -(-((tmp91_)*((tmp96_*tmp71_+tmp97_*tmp73_)*(tmp18_)+(tmp96_*tmp14_+tmp97_*tmp78_)*(tmp24_)+tmp97_*tmp12_*(tmp26_)))/tmp95_);
  mCompDer[0][13] = -((tmp49_*tmp70_*(tmp85_)-(tmp91_)*tmp49_*(tmp75_))/tmp95_);
  mCompDer[0][14] = -((tmp49_*tmp87_*(tmp85_)-(tmp91_)*tmp49_*(tmp80_))/tmp95_);
  mCompDer[0][15] = -((tmp93_*(tmp85_)-(tmp91_)*tmp49_*tmp83_)/tmp95_);
}


void cEqAppuiXDRad5::ComputeValDerivHessian()
{
  ELISE_ASSERT(false,"Foncteur cEqAppuiXDRad5 Has no Der Sec");
}

void cEqAppuiXDRad5::SetXIm(double aVal){ mLocXIm = aVal;}
void cEqAppuiXDRad5::SetXTer(double aVal){ mLocXTer = aVal;}
void cEqAppuiXDRad5::SetYIm(double aVal){ mLocYIm = aVal;}
void cEqAppuiXDRad5::SetYTer(double aVal){ mLocYTer = aVal;}
void cEqAppuiXDRad5::SetZTer(double aVal){ mLocZTer = aVal;}



double * cEqAppuiXDRad5::AdrVarLocFromString(const std::string & aName)
{
   if (aName == "XIm") return & mLocXIm;
   if (aName == "XTer") return & mLocXTer;
   if (aName == "YIm") return & mLocYIm;
   if (aName == "YTer") return & mLocYTer;
   if (aName == "ZTer") return & mLocZTer;
   return 0;
}


cElCompiledFonc::cAutoAddEntry cEqAppuiXDRad5::mTheAuto("cEqAppuiXDRad5",cEqAppuiXDRad5::Alloc);


cElCompiledFonc *  cEqAppuiXDRad5::Alloc()
{  return new cEqAppuiXDRad5();
}



/*Footer-MicMac-eLiSe-25/06/2007

Ce logiciel est un programme informatique servant à la mise en
correspondances d'images pour la reconstruction du relief.

Ce logiciel est régi par la licence CeCILL-B soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-B telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL-B, et que vous en avez accepté les
termes.
Footer-MicMac-eLiSe-25/06/2007*/
