/*Header-MicMac-eLiSe-25/06/2007

    MicMac : Multi Image Correspondances par Methodes Automatiques de Correlation
    eLiSe  : ELements of an Image Software Environnement

    www.micmac.ign.fr

   
    Copyright : Institut Geographique National
    Author : Marc Pierrot Deseilligny
    Contributors : Gregoire Maillet, Didier Boldo.

[1] M. Pierrot-Deseilligny, N. Paparoditis.
    "A multiresolution and optimization-based image matching approach:
    An application to surface reconstruction from SPOT5-HRS stereo imagery."
    In IAPRS vol XXXVI-1/W41 in ISPRS Workshop On Topographic Mapping From Space
    (With Special Emphasis on Small Satellites), Ankara, Turquie, 02-2006.

[2] M. Pierrot-Deseilligny, "MicMac, un lociel de mise en correspondance
    d'images, adapte au contexte geograhique" to appears in 
    Bulletin d'information de l'Institut Geographique National, 2007.

Francais :

   MicMac est un logiciel de mise en correspondance d'image adapte 
   au contexte de recherche en information geographique. Il s'appuie sur
   la bibliotheque de manipulation d'image eLiSe. Il est distibue sous la
   licences Cecill-B.  Voir en bas de fichier et  http://www.cecill.info.


English :

    MicMac is an open source software specialized in image matching
    for research in geographic information. MicMac is built on the
    eLiSe image library. MicMac is governed by the  "Cecill-B licence".
    See below and http://www.cecill.info.

Header-MicMac-eLiSe-25/06/2007*/
// File Automatically generated by eLiSe

#include "general/all.h"
#include "private/all.h"
#include "cEqAppuiXNoDist.h"


cEqAppuiXNoDist::cEqAppuiXNoDist():
    cElCompiledFonc(1)
{
   AddIntRef (cIncIntervale("Intr",0,3));
   AddIntRef (cIncIntervale("Orient",3,9));
   Close(false);
}



void cEqAppuiXNoDist::ComputeVal()
{
   double tmp0_ = mCompCoord[3];
   double tmp1_ = mCompCoord[4];
   double tmp2_ = cos(tmp1_);
   double tmp3_ = sin(tmp0_);
   double tmp4_ = cos(tmp0_);
   double tmp5_ = sin(tmp1_);
   double tmp6_ = mCompCoord[5];
   double tmp7_ = mCompCoord[6];
   double tmp8_ = mLocXTer-tmp7_;
   double tmp9_ = sin(tmp6_);
   double tmp10_ = -(tmp9_);
   double tmp11_ = -(tmp5_);
   double tmp12_ = cos(tmp6_);
   double tmp13_ = mCompCoord[7];
   double tmp14_ = mLocYTer-tmp13_;
   double tmp15_ = mCompCoord[8];
   double tmp16_ = mLocZTer-tmp15_;

  mVal[0] = (mLocXIm-mCompCoord[1])/mCompCoord[0]-(tmp4_*tmp2_*(tmp8_)+tmp3_*tmp2_*(tmp14_)+tmp5_*(tmp16_))/((-(tmp3_)*tmp10_+tmp4_*tmp11_*tmp12_)*(tmp8_)+(tmp4_*tmp10_+tmp3_*tmp11_*tmp12_)*(tmp14_)+tmp2_*tmp12_*(tmp16_));

}


void cEqAppuiXNoDist::ComputeValDeriv()
{
   double tmp0_ = mCompCoord[3];
   double tmp1_ = mCompCoord[4];
   double tmp2_ = cos(tmp1_);
   double tmp3_ = sin(tmp0_);
   double tmp4_ = cos(tmp0_);
   double tmp5_ = sin(tmp1_);
   double tmp6_ = mCompCoord[5];
   double tmp7_ = mCompCoord[6];
   double tmp8_ = mLocXTer-tmp7_;
   double tmp9_ = sin(tmp6_);
   double tmp10_ = -(tmp9_);
   double tmp11_ = -(tmp5_);
   double tmp12_ = cos(tmp6_);
   double tmp13_ = mCompCoord[7];
   double tmp14_ = mLocYTer-tmp13_;
   double tmp15_ = mCompCoord[8];
   double tmp16_ = mLocZTer-tmp15_;
   double tmp17_ = mCompCoord[1];
   double tmp18_ = mLocXIm-tmp17_;
   double tmp19_ = mCompCoord[0];
   double tmp20_ = ElSquare(tmp19_);
   double tmp21_ = -(1);
   double tmp22_ = tmp4_*tmp2_;
   double tmp23_ = -(tmp3_);
   double tmp24_ = tmp23_*tmp10_;
   double tmp25_ = tmp4_*tmp11_;
   double tmp26_ = tmp25_*tmp12_;
   double tmp27_ = tmp24_+tmp26_;
   double tmp28_ = (tmp27_)*(tmp8_);
   double tmp29_ = tmp4_*tmp10_;
   double tmp30_ = tmp3_*tmp11_;
   double tmp31_ = tmp30_*tmp12_;
   double tmp32_ = tmp29_+tmp31_;
   double tmp33_ = (tmp32_)*(tmp14_);
   double tmp34_ = tmp28_+tmp33_;
   double tmp35_ = tmp2_*tmp12_;
   double tmp36_ = tmp35_*(tmp16_);
   double tmp37_ = tmp34_+tmp36_;
   double tmp38_ = tmp22_*(tmp8_);
   double tmp39_ = tmp3_*tmp2_;
   double tmp40_ = tmp39_*(tmp14_);
   double tmp41_ = tmp38_+tmp40_;
   double tmp42_ = tmp5_*(tmp16_);
   double tmp43_ = tmp41_+tmp42_;
   double tmp44_ = tmp21_*tmp3_;
   double tmp45_ = tmp21_*tmp5_;
   double tmp46_ = -(tmp2_);
   double tmp47_ = ElSquare(tmp37_);
   double tmp48_ = -(tmp12_);
   double tmp49_ = tmp21_*tmp9_;

  mVal[0] = (tmp18_)/tmp19_-(tmp43_)/(tmp37_);

  mCompDer[0][0] = -(tmp18_)/tmp20_;
  mCompDer[0][1] = (tmp21_*tmp19_)/tmp20_;
  mCompDer[0][2] = 0;
  mCompDer[0][3] = -(((tmp44_*tmp2_*(tmp8_)+tmp22_*(tmp14_))*(tmp37_)-(tmp43_)*((-(tmp4_)*tmp10_+tmp44_*tmp11_*tmp12_)*(tmp8_)+(tmp44_*tmp10_+tmp26_)*(tmp14_)))/tmp47_);
  mCompDer[0][4] = -(((tmp45_*tmp4_*(tmp8_)+tmp45_*tmp3_*(tmp14_)+tmp2_*(tmp16_))*(tmp37_)-(tmp43_)*(tmp46_*tmp4_*tmp12_*(tmp8_)+tmp46_*tmp3_*tmp12_*(tmp14_)+tmp45_*tmp12_*(tmp16_)))/tmp47_);
  mCompDer[0][5] = -(-((tmp43_)*((tmp48_*tmp23_+tmp49_*tmp25_)*(tmp8_)+(tmp48_*tmp4_+tmp49_*tmp30_)*(tmp14_)+tmp49_*tmp2_*(tmp16_)))/tmp47_);
  mCompDer[0][6] = -((tmp21_*tmp22_*(tmp37_)-(tmp43_)*tmp21_*(tmp27_))/tmp47_);
  mCompDer[0][7] = -((tmp21_*tmp39_*(tmp37_)-(tmp43_)*tmp21_*(tmp32_))/tmp47_);
  mCompDer[0][8] = -((tmp45_*(tmp37_)-(tmp43_)*tmp21_*tmp35_)/tmp47_);
}


void cEqAppuiXNoDist::ComputeValDerivHessian()
{
  ELISE_ASSERT(false,"Foncteur cEqAppuiXNoDist Has no Der Sec");
}

void cEqAppuiXNoDist::SetXIm(double aVal){ mLocXIm = aVal;}
void cEqAppuiXNoDist::SetXTer(double aVal){ mLocXTer = aVal;}
void cEqAppuiXNoDist::SetYTer(double aVal){ mLocYTer = aVal;}
void cEqAppuiXNoDist::SetZTer(double aVal){ mLocZTer = aVal;}



double * cEqAppuiXNoDist::AdrVarLocFromString(const std::string & aName)
{
   if (aName == "XIm") return & mLocXIm;
   if (aName == "XTer") return & mLocXTer;
   if (aName == "YTer") return & mLocYTer;
   if (aName == "ZTer") return & mLocZTer;
   return 0;
}


cElCompiledFonc::cAutoAddEntry cEqAppuiXNoDist::mTheAuto("cEqAppuiXNoDist",cEqAppuiXNoDist::Alloc);


cElCompiledFonc *  cEqAppuiXNoDist::Alloc()
{  return new cEqAppuiXNoDist();
}



/*Footer-MicMac-eLiSe-25/06/2007

Ce logiciel est un programme informatique servant à la mise en
correspondances d'images pour la reconstruction du relief.

Ce logiciel est régi par la licence CeCILL-B soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-B telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL-B, et que vous en avez accepté les
termes.
Footer-MicMac-eLiSe-25/06/2007*/
