/*Header-MicMac-eLiSe-25/06/2007

    MicMac : Multi Image Correspondances par Methodes Automatiques de Correlation
    eLiSe  : ELements of an Image Software Environnement

    www.micmac.ign.fr

   
    Copyright : Institut Geographique National
    Author : Marc Pierrot Deseilligny
    Contributors : Gregoire Maillet, Didier Boldo.

[1] M. Pierrot-Deseilligny, N. Paparoditis.
    "A multiresolution and optimization-based image matching approach:
    An application to surface reconstruction from SPOT5-HRS stereo imagery."
    In IAPRS vol XXXVI-1/W41 in ISPRS Workshop On Topographic Mapping From Space
    (With Special Emphasis on Small Satellites), Ankara, Turquie, 02-2006.

[2] M. Pierrot-Deseilligny, "MicMac, un lociel de mise en correspondance
    d'images, adapte au contexte geograhique" to appears in 
    Bulletin d'information de l'Institut Geographique National, 2007.

Francais :

   MicMac est un logiciel de mise en correspondance d'image adapte 
   au contexte de recherche en information geographique. Il s'appuie sur
   la bibliotheque de manipulation d'image eLiSe. Il est distibue sous la
   licences Cecill-B.  Voir en bas de fichier et  http://www.cecill.info.


English :

    MicMac is an open source software specialized in image matching
    for research in geographic information. MicMac is built on the
    eLiSe image library. MicMac is governed by the  "Cecill-B licence".
    See below and http://www.cecill.info.

Header-MicMac-eLiSe-25/06/2007*/
// File Automatically generated by eLiSe

#include "general/all.h"
#include "private/all.h"
#include "cEqCorLI_Multi_1_DRPts3_NonNorm.h"


cEqCorLI_Multi_1_DRPts3_NonNorm::cEqCorLI_Multi_1_DRPts3_NonNorm():
    cElCompiledFonc(1)
{
   AddIntRef (cIncIntervale("OrA",0,6));
   AddIntRef (cIncIntervale("OrB",6,12));
   AddIntRef (cIncIntervale("OrPts",12,36));
   Close(false);
}



void cEqCorLI_Multi_1_DRPts3_NonNorm::ComputeVal()
{
   double tmp0_ = ElSquare(mLocTimeRot);
   double tmp1_ = VCube(mLocTimeRot);
   double tmp2_ = mCompCoord[12];
   double tmp3_ = mCompCoord[13];
   double tmp4_ = tmp3_*mLocTimeRot;
   double tmp5_ = tmp2_+tmp4_;
   double tmp6_ = mCompCoord[14];
   double tmp7_ = tmp6_*tmp0_;
   double tmp8_ = tmp5_+tmp7_;
   double tmp9_ = mCompCoord[15];
   double tmp10_ = tmp9_*tmp1_;
   double tmp11_ = tmp8_+tmp10_;
   double tmp12_ = cos(tmp11_);
   double tmp13_ = mCompCoord[16];
   double tmp14_ = mCompCoord[17];
   double tmp15_ = tmp14_*mLocTimeRot;
   double tmp16_ = tmp13_+tmp15_;
   double tmp17_ = mCompCoord[18];
   double tmp18_ = tmp17_*tmp0_;
   double tmp19_ = tmp16_+tmp18_;
   double tmp20_ = mCompCoord[19];
   double tmp21_ = tmp20_*tmp1_;
   double tmp22_ = tmp19_+tmp21_;
   double tmp23_ = mCompCoord[20];
   double tmp24_ = mCompCoord[21];
   double tmp25_ = tmp24_*mLocTimeRot;
   double tmp26_ = tmp23_+tmp25_;
   double tmp27_ = mCompCoord[22];
   double tmp28_ = tmp27_*tmp0_;
   double tmp29_ = tmp26_+tmp28_;
   double tmp30_ = mCompCoord[23];
   double tmp31_ = tmp30_*tmp1_;
   double tmp32_ = tmp29_+tmp31_;
   double tmp33_ = sin(tmp11_);
   double tmp34_ = -(tmp33_);
   double tmp35_ = sin(tmp32_);
   double tmp36_ = sin(tmp22_);
   double tmp37_ = -(tmp36_);
   double tmp38_ = tmp12_*tmp37_;
   double tmp39_ = cos(tmp32_);
   double tmp40_ = mCompCoord[0];
   double tmp41_ = mCompCoord[1];
   double tmp42_ = cos(tmp41_);
   double tmp43_ = cos(tmp22_);
   double tmp44_ = -(tmp35_);
   double tmp45_ = tmp33_*tmp37_;
   double tmp46_ = sin(tmp40_);
   double tmp47_ = cos(tmp40_);
   double tmp48_ = sin(tmp41_);
   double tmp49_ = mCompCoord[2];
   double tmp50_ = tmp12_*tmp43_;
   double tmp51_ = tmp50_*mLocP3X_A_0;
   double tmp52_ = tmp34_*tmp39_;
   double tmp53_ = tmp38_*tmp35_;
   double tmp54_ = tmp52_+tmp53_;
   double tmp55_ = (tmp54_)*mLocP3Y_A_0;
   double tmp56_ = tmp51_+tmp55_;
   double tmp57_ = tmp34_*tmp44_;
   double tmp58_ = tmp38_*tmp39_;
   double tmp59_ = tmp57_+tmp58_;
   double tmp60_ = (tmp59_)*mLocP3Z_A_0;
   double tmp61_ = tmp56_+tmp60_;
   double tmp62_ = mCompCoord[24];
   double tmp63_ = mCompCoord[25];
   double tmp64_ = tmp63_*mLocTimeRot;
   double tmp65_ = tmp62_+tmp64_;
   double tmp66_ = mCompCoord[26];
   double tmp67_ = tmp66_*tmp0_;
   double tmp68_ = tmp65_+tmp67_;
   double tmp69_ = mCompCoord[27];
   double tmp70_ = tmp69_*tmp1_;
   double tmp71_ = tmp68_+tmp70_;
   double tmp72_ = tmp61_+tmp71_;
   double tmp73_ = mCompCoord[3];
   double tmp74_ = (tmp72_)-tmp73_;
   double tmp75_ = sin(tmp49_);
   double tmp76_ = -(tmp75_);
   double tmp77_ = -(tmp48_);
   double tmp78_ = cos(tmp49_);
   double tmp79_ = tmp33_*tmp43_;
   double tmp80_ = tmp79_*mLocP3X_A_0;
   double tmp81_ = tmp12_*tmp39_;
   double tmp82_ = tmp45_*tmp35_;
   double tmp83_ = tmp81_+tmp82_;
   double tmp84_ = (tmp83_)*mLocP3Y_A_0;
   double tmp85_ = tmp80_+tmp84_;
   double tmp86_ = tmp12_*tmp44_;
   double tmp87_ = tmp45_*tmp39_;
   double tmp88_ = tmp86_+tmp87_;
   double tmp89_ = (tmp88_)*mLocP3Z_A_0;
   double tmp90_ = tmp85_+tmp89_;
   double tmp91_ = mCompCoord[28];
   double tmp92_ = mCompCoord[29];
   double tmp93_ = tmp92_*mLocTimeRot;
   double tmp94_ = tmp91_+tmp93_;
   double tmp95_ = mCompCoord[30];
   double tmp96_ = tmp95_*tmp0_;
   double tmp97_ = tmp94_+tmp96_;
   double tmp98_ = mCompCoord[31];
   double tmp99_ = tmp98_*tmp1_;
   double tmp100_ = tmp97_+tmp99_;
   double tmp101_ = tmp90_+tmp100_;
   double tmp102_ = mCompCoord[4];
   double tmp103_ = (tmp101_)-tmp102_;
   double tmp104_ = tmp36_*mLocP3X_A_0;
   double tmp105_ = tmp43_*tmp35_;
   double tmp106_ = tmp105_*mLocP3Y_A_0;
   double tmp107_ = tmp104_+tmp106_;
   double tmp108_ = tmp43_*tmp39_;
   double tmp109_ = tmp108_*mLocP3Z_A_0;
   double tmp110_ = tmp107_+tmp109_;
   double tmp111_ = mCompCoord[32];
   double tmp112_ = mCompCoord[33];
   double tmp113_ = tmp112_*mLocTimeRot;
   double tmp114_ = tmp111_+tmp113_;
   double tmp115_ = mCompCoord[34];
   double tmp116_ = tmp115_*tmp0_;
   double tmp117_ = tmp114_+tmp116_;
   double tmp118_ = mCompCoord[35];
   double tmp119_ = tmp118_*tmp1_;
   double tmp120_ = tmp117_+tmp119_;
   double tmp121_ = tmp110_+tmp120_;
   double tmp122_ = mCompCoord[5];
   double tmp123_ = (tmp121_)-tmp122_;
   double tmp124_ = -(tmp46_);
   double tmp125_ = tmp47_*tmp77_;
   double tmp126_ = tmp46_*tmp77_;
   double tmp127_ = tmp124_*tmp76_;
   double tmp128_ = tmp125_*tmp78_;
   double tmp129_ = tmp127_+tmp128_;
   double tmp130_ = (tmp129_)*(tmp74_);
   double tmp131_ = tmp47_*tmp76_;
   double tmp132_ = tmp126_*tmp78_;
   double tmp133_ = tmp131_+tmp132_;
   double tmp134_ = (tmp133_)*(tmp103_);
   double tmp135_ = tmp130_+tmp134_;
   double tmp136_ = tmp42_*tmp78_;
   double tmp137_ = tmp136_*(tmp123_);
   double tmp138_ = tmp135_+tmp137_;
   double tmp139_ = mCompCoord[6];
   double tmp140_ = mCompCoord[7];
   double tmp141_ = cos(tmp140_);
   double tmp142_ = sin(tmp139_);
   double tmp143_ = cos(tmp139_);
   double tmp144_ = sin(tmp140_);
   double tmp145_ = mCompCoord[8];
   double tmp146_ = tmp50_*mLocP3X_B_0;
   double tmp147_ = (tmp54_)*mLocP3Y_B_0;
   double tmp148_ = tmp146_+tmp147_;
   double tmp149_ = (tmp59_)*mLocP3Z_B_0;
   double tmp150_ = tmp148_+tmp149_;
   double tmp151_ = tmp150_+tmp71_;
   double tmp152_ = mCompCoord[9];
   double tmp153_ = (tmp151_)-tmp152_;
   double tmp154_ = sin(tmp145_);
   double tmp155_ = -(tmp154_);
   double tmp156_ = -(tmp144_);
   double tmp157_ = cos(tmp145_);
   double tmp158_ = tmp79_*mLocP3X_B_0;
   double tmp159_ = (tmp83_)*mLocP3Y_B_0;
   double tmp160_ = tmp158_+tmp159_;
   double tmp161_ = (tmp88_)*mLocP3Z_B_0;
   double tmp162_ = tmp160_+tmp161_;
   double tmp163_ = tmp162_+tmp100_;
   double tmp164_ = mCompCoord[10];
   double tmp165_ = (tmp163_)-tmp164_;
   double tmp166_ = tmp36_*mLocP3X_B_0;
   double tmp167_ = tmp105_*mLocP3Y_B_0;
   double tmp168_ = tmp166_+tmp167_;
   double tmp169_ = tmp108_*mLocP3Z_B_0;
   double tmp170_ = tmp168_+tmp169_;
   double tmp171_ = tmp170_+tmp120_;
   double tmp172_ = mCompCoord[11];
   double tmp173_ = (tmp171_)-tmp172_;
   double tmp174_ = -(tmp142_);
   double tmp175_ = tmp143_*tmp156_;
   double tmp176_ = tmp142_*tmp156_;
   double tmp177_ = tmp174_*tmp155_;
   double tmp178_ = tmp175_*tmp157_;
   double tmp179_ = tmp177_+tmp178_;
   double tmp180_ = (tmp179_)*(tmp153_);
   double tmp181_ = tmp143_*tmp155_;
   double tmp182_ = tmp176_*tmp157_;
   double tmp183_ = tmp181_+tmp182_;
   double tmp184_ = (tmp183_)*(tmp165_);
   double tmp185_ = tmp180_+tmp184_;
   double tmp186_ = tmp141_*tmp157_;
   double tmp187_ = tmp186_*(tmp173_);
   double tmp188_ = tmp185_+tmp187_;

  mVal[0] = (mLocCste_A_0+mLocCoeffU_A_0*((tmp47_*tmp42_*(tmp74_)+tmp46_*tmp42_*(tmp103_)+tmp48_*(tmp123_))/(tmp138_))+mLocCoeffV_A_0*(((tmp124_*tmp78_+tmp125_*tmp75_)*(tmp74_)+(tmp47_*tmp78_+tmp126_*tmp75_)*(tmp103_)+tmp42_*tmp75_*(tmp123_))/(tmp138_)))-(mLocCste_B_0+mLocCoeffU_B_0*((tmp143_*tmp141_*(tmp153_)+tmp142_*tmp141_*(tmp165_)+tmp144_*(tmp173_))/(tmp188_))+mLocCoeffV_B_0*(((tmp174_*tmp157_+tmp175_*tmp154_)*(tmp153_)+(tmp143_*tmp157_+tmp176_*tmp154_)*(tmp165_)+tmp141_*tmp154_*(tmp173_))/(tmp188_)));

}


void cEqCorLI_Multi_1_DRPts3_NonNorm::ComputeValDeriv()
{
   double tmp0_ = ElSquare(mLocTimeRot);
   double tmp1_ = VCube(mLocTimeRot);
   double tmp2_ = mCompCoord[12];
   double tmp3_ = mCompCoord[13];
   double tmp4_ = tmp3_*mLocTimeRot;
   double tmp5_ = tmp2_+tmp4_;
   double tmp6_ = mCompCoord[14];
   double tmp7_ = tmp6_*tmp0_;
   double tmp8_ = tmp5_+tmp7_;
   double tmp9_ = mCompCoord[15];
   double tmp10_ = tmp9_*tmp1_;
   double tmp11_ = tmp8_+tmp10_;
   double tmp12_ = cos(tmp11_);
   double tmp13_ = mCompCoord[16];
   double tmp14_ = mCompCoord[17];
   double tmp15_ = tmp14_*mLocTimeRot;
   double tmp16_ = tmp13_+tmp15_;
   double tmp17_ = mCompCoord[18];
   double tmp18_ = tmp17_*tmp0_;
   double tmp19_ = tmp16_+tmp18_;
   double tmp20_ = mCompCoord[19];
   double tmp21_ = tmp20_*tmp1_;
   double tmp22_ = tmp19_+tmp21_;
   double tmp23_ = mCompCoord[20];
   double tmp24_ = mCompCoord[21];
   double tmp25_ = tmp24_*mLocTimeRot;
   double tmp26_ = tmp23_+tmp25_;
   double tmp27_ = mCompCoord[22];
   double tmp28_ = tmp27_*tmp0_;
   double tmp29_ = tmp26_+tmp28_;
   double tmp30_ = mCompCoord[23];
   double tmp31_ = tmp30_*tmp1_;
   double tmp32_ = tmp29_+tmp31_;
   double tmp33_ = sin(tmp11_);
   double tmp34_ = -(tmp33_);
   double tmp35_ = sin(tmp32_);
   double tmp36_ = sin(tmp22_);
   double tmp37_ = -(tmp36_);
   double tmp38_ = tmp12_*tmp37_;
   double tmp39_ = cos(tmp32_);
   double tmp40_ = mCompCoord[0];
   double tmp41_ = mCompCoord[1];
   double tmp42_ = cos(tmp41_);
   double tmp43_ = cos(tmp22_);
   double tmp44_ = -(tmp35_);
   double tmp45_ = tmp33_*tmp37_;
   double tmp46_ = sin(tmp40_);
   double tmp47_ = cos(tmp40_);
   double tmp48_ = sin(tmp41_);
   double tmp49_ = mCompCoord[2];
   double tmp50_ = tmp12_*tmp43_;
   double tmp51_ = tmp50_*mLocP3X_A_0;
   double tmp52_ = tmp34_*tmp39_;
   double tmp53_ = tmp38_*tmp35_;
   double tmp54_ = tmp52_+tmp53_;
   double tmp55_ = (tmp54_)*mLocP3Y_A_0;
   double tmp56_ = tmp51_+tmp55_;
   double tmp57_ = tmp34_*tmp44_;
   double tmp58_ = tmp38_*tmp39_;
   double tmp59_ = tmp57_+tmp58_;
   double tmp60_ = (tmp59_)*mLocP3Z_A_0;
   double tmp61_ = tmp56_+tmp60_;
   double tmp62_ = mCompCoord[24];
   double tmp63_ = mCompCoord[25];
   double tmp64_ = tmp63_*mLocTimeRot;
   double tmp65_ = tmp62_+tmp64_;
   double tmp66_ = mCompCoord[26];
   double tmp67_ = tmp66_*tmp0_;
   double tmp68_ = tmp65_+tmp67_;
   double tmp69_ = mCompCoord[27];
   double tmp70_ = tmp69_*tmp1_;
   double tmp71_ = tmp68_+tmp70_;
   double tmp72_ = tmp61_+tmp71_;
   double tmp73_ = mCompCoord[3];
   double tmp74_ = (tmp72_)-tmp73_;
   double tmp75_ = sin(tmp49_);
   double tmp76_ = -(tmp75_);
   double tmp77_ = -(tmp48_);
   double tmp78_ = cos(tmp49_);
   double tmp79_ = tmp33_*tmp43_;
   double tmp80_ = tmp79_*mLocP3X_A_0;
   double tmp81_ = tmp12_*tmp39_;
   double tmp82_ = tmp45_*tmp35_;
   double tmp83_ = tmp81_+tmp82_;
   double tmp84_ = (tmp83_)*mLocP3Y_A_0;
   double tmp85_ = tmp80_+tmp84_;
   double tmp86_ = tmp12_*tmp44_;
   double tmp87_ = tmp45_*tmp39_;
   double tmp88_ = tmp86_+tmp87_;
   double tmp89_ = (tmp88_)*mLocP3Z_A_0;
   double tmp90_ = tmp85_+tmp89_;
   double tmp91_ = mCompCoord[28];
   double tmp92_ = mCompCoord[29];
   double tmp93_ = tmp92_*mLocTimeRot;
   double tmp94_ = tmp91_+tmp93_;
   double tmp95_ = mCompCoord[30];
   double tmp96_ = tmp95_*tmp0_;
   double tmp97_ = tmp94_+tmp96_;
   double tmp98_ = mCompCoord[31];
   double tmp99_ = tmp98_*tmp1_;
   double tmp100_ = tmp97_+tmp99_;
   double tmp101_ = tmp90_+tmp100_;
   double tmp102_ = mCompCoord[4];
   double tmp103_ = (tmp101_)-tmp102_;
   double tmp104_ = tmp36_*mLocP3X_A_0;
   double tmp105_ = tmp43_*tmp35_;
   double tmp106_ = tmp105_*mLocP3Y_A_0;
   double tmp107_ = tmp104_+tmp106_;
   double tmp108_ = tmp43_*tmp39_;
   double tmp109_ = tmp108_*mLocP3Z_A_0;
   double tmp110_ = tmp107_+tmp109_;
   double tmp111_ = mCompCoord[32];
   double tmp112_ = mCompCoord[33];
   double tmp113_ = tmp112_*mLocTimeRot;
   double tmp114_ = tmp111_+tmp113_;
   double tmp115_ = mCompCoord[34];
   double tmp116_ = tmp115_*tmp0_;
   double tmp117_ = tmp114_+tmp116_;
   double tmp118_ = mCompCoord[35];
   double tmp119_ = tmp118_*tmp1_;
   double tmp120_ = tmp117_+tmp119_;
   double tmp121_ = tmp110_+tmp120_;
   double tmp122_ = mCompCoord[5];
   double tmp123_ = (tmp121_)-tmp122_;
   double tmp124_ = -(tmp46_);
   double tmp125_ = tmp47_*tmp77_;
   double tmp126_ = tmp46_*tmp77_;
   double tmp127_ = tmp124_*tmp76_;
   double tmp128_ = tmp125_*tmp78_;
   double tmp129_ = tmp127_+tmp128_;
   double tmp130_ = (tmp129_)*(tmp74_);
   double tmp131_ = tmp47_*tmp76_;
   double tmp132_ = tmp126_*tmp78_;
   double tmp133_ = tmp131_+tmp132_;
   double tmp134_ = (tmp133_)*(tmp103_);
   double tmp135_ = tmp130_+tmp134_;
   double tmp136_ = tmp42_*tmp78_;
   double tmp137_ = tmp136_*(tmp123_);
   double tmp138_ = tmp135_+tmp137_;
   double tmp139_ = mCompCoord[6];
   double tmp140_ = mCompCoord[7];
   double tmp141_ = cos(tmp140_);
   double tmp142_ = sin(tmp139_);
   double tmp143_ = cos(tmp139_);
   double tmp144_ = sin(tmp140_);
   double tmp145_ = mCompCoord[8];
   double tmp146_ = tmp50_*mLocP3X_B_0;
   double tmp147_ = (tmp54_)*mLocP3Y_B_0;
   double tmp148_ = tmp146_+tmp147_;
   double tmp149_ = (tmp59_)*mLocP3Z_B_0;
   double tmp150_ = tmp148_+tmp149_;
   double tmp151_ = tmp150_+tmp71_;
   double tmp152_ = mCompCoord[9];
   double tmp153_ = (tmp151_)-tmp152_;
   double tmp154_ = sin(tmp145_);
   double tmp155_ = -(tmp154_);
   double tmp156_ = -(tmp144_);
   double tmp157_ = cos(tmp145_);
   double tmp158_ = tmp79_*mLocP3X_B_0;
   double tmp159_ = (tmp83_)*mLocP3Y_B_0;
   double tmp160_ = tmp158_+tmp159_;
   double tmp161_ = (tmp88_)*mLocP3Z_B_0;
   double tmp162_ = tmp160_+tmp161_;
   double tmp163_ = tmp162_+tmp100_;
   double tmp164_ = mCompCoord[10];
   double tmp165_ = (tmp163_)-tmp164_;
   double tmp166_ = tmp36_*mLocP3X_B_0;
   double tmp167_ = tmp105_*mLocP3Y_B_0;
   double tmp168_ = tmp166_+tmp167_;
   double tmp169_ = tmp108_*mLocP3Z_B_0;
   double tmp170_ = tmp168_+tmp169_;
   double tmp171_ = tmp170_+tmp120_;
   double tmp172_ = mCompCoord[11];
   double tmp173_ = (tmp171_)-tmp172_;
   double tmp174_ = -(tmp142_);
   double tmp175_ = tmp143_*tmp156_;
   double tmp176_ = tmp142_*tmp156_;
   double tmp177_ = tmp174_*tmp155_;
   double tmp178_ = tmp175_*tmp157_;
   double tmp179_ = tmp177_+tmp178_;
   double tmp180_ = (tmp179_)*(tmp153_);
   double tmp181_ = tmp143_*tmp155_;
   double tmp182_ = tmp176_*tmp157_;
   double tmp183_ = tmp181_+tmp182_;
   double tmp184_ = (tmp183_)*(tmp165_);
   double tmp185_ = tmp180_+tmp184_;
   double tmp186_ = tmp141_*tmp157_;
   double tmp187_ = tmp186_*(tmp173_);
   double tmp188_ = tmp185_+tmp187_;
   double tmp189_ = tmp47_*tmp42_;
   double tmp190_ = tmp189_*(tmp74_);
   double tmp191_ = tmp46_*tmp42_;
   double tmp192_ = tmp191_*(tmp103_);
   double tmp193_ = tmp190_+tmp192_;
   double tmp194_ = tmp48_*(tmp123_);
   double tmp195_ = tmp193_+tmp194_;
   double tmp196_ = -(1);
   double tmp197_ = tmp196_*tmp46_;
   double tmp198_ = -(tmp47_);
   double tmp199_ = tmp197_*tmp77_;
   double tmp200_ = tmp125_*tmp75_;
   double tmp201_ = tmp124_*tmp78_;
   double tmp202_ = tmp201_+tmp200_;
   double tmp203_ = (tmp202_)*(tmp74_);
   double tmp204_ = tmp47_*tmp78_;
   double tmp205_ = tmp126_*tmp75_;
   double tmp206_ = tmp204_+tmp205_;
   double tmp207_ = (tmp206_)*(tmp103_);
   double tmp208_ = tmp203_+tmp207_;
   double tmp209_ = tmp42_*tmp75_;
   double tmp210_ = tmp209_*(tmp123_);
   double tmp211_ = tmp208_+tmp210_;
   double tmp212_ = tmp198_*tmp76_;
   double tmp213_ = tmp199_*tmp78_;
   double tmp214_ = tmp212_+tmp213_;
   double tmp215_ = (tmp214_)*(tmp74_);
   double tmp216_ = tmp197_*tmp76_;
   double tmp217_ = tmp216_+tmp128_;
   double tmp218_ = (tmp217_)*(tmp103_);
   double tmp219_ = tmp215_+tmp218_;
   double tmp220_ = ElSquare(tmp138_);
   double tmp221_ = tmp196_*tmp48_;
   double tmp222_ = -(tmp42_);
   double tmp223_ = tmp222_*tmp47_;
   double tmp224_ = tmp222_*tmp46_;
   double tmp225_ = tmp223_*tmp78_;
   double tmp226_ = tmp225_*(tmp74_);
   double tmp227_ = tmp224_*tmp78_;
   double tmp228_ = tmp227_*(tmp103_);
   double tmp229_ = tmp226_+tmp228_;
   double tmp230_ = tmp221_*tmp78_;
   double tmp231_ = tmp230_*(tmp123_);
   double tmp232_ = tmp229_+tmp231_;
   double tmp233_ = -(tmp78_);
   double tmp234_ = tmp196_*tmp75_;
   double tmp235_ = tmp233_*tmp124_;
   double tmp236_ = tmp234_*tmp125_;
   double tmp237_ = tmp235_+tmp236_;
   double tmp238_ = (tmp237_)*(tmp74_);
   double tmp239_ = tmp233_*tmp47_;
   double tmp240_ = tmp234_*tmp126_;
   double tmp241_ = tmp239_+tmp240_;
   double tmp242_ = (tmp241_)*(tmp103_);
   double tmp243_ = tmp238_+tmp242_;
   double tmp244_ = tmp234_*tmp42_;
   double tmp245_ = tmp244_*(tmp123_);
   double tmp246_ = tmp243_+tmp245_;
   double tmp247_ = tmp196_*(tmp129_);
   double tmp248_ = tmp196_*(tmp133_);
   double tmp249_ = tmp196_*tmp136_;
   double tmp250_ = tmp143_*tmp141_;
   double tmp251_ = tmp250_*(tmp153_);
   double tmp252_ = tmp142_*tmp141_;
   double tmp253_ = tmp252_*(tmp165_);
   double tmp254_ = tmp251_+tmp253_;
   double tmp255_ = tmp144_*(tmp173_);
   double tmp256_ = tmp254_+tmp255_;
   double tmp257_ = tmp196_*tmp142_;
   double tmp258_ = -(tmp143_);
   double tmp259_ = tmp257_*tmp156_;
   double tmp260_ = tmp175_*tmp154_;
   double tmp261_ = tmp174_*tmp157_;
   double tmp262_ = tmp261_+tmp260_;
   double tmp263_ = (tmp262_)*(tmp153_);
   double tmp264_ = tmp143_*tmp157_;
   double tmp265_ = tmp176_*tmp154_;
   double tmp266_ = tmp264_+tmp265_;
   double tmp267_ = (tmp266_)*(tmp165_);
   double tmp268_ = tmp263_+tmp267_;
   double tmp269_ = tmp141_*tmp154_;
   double tmp270_ = tmp269_*(tmp173_);
   double tmp271_ = tmp268_+tmp270_;
   double tmp272_ = tmp258_*tmp155_;
   double tmp273_ = tmp259_*tmp157_;
   double tmp274_ = tmp272_+tmp273_;
   double tmp275_ = (tmp274_)*(tmp153_);
   double tmp276_ = tmp257_*tmp155_;
   double tmp277_ = tmp276_+tmp178_;
   double tmp278_ = (tmp277_)*(tmp165_);
   double tmp279_ = tmp275_+tmp278_;
   double tmp280_ = ElSquare(tmp188_);
   double tmp281_ = tmp196_*tmp144_;
   double tmp282_ = -(tmp141_);
   double tmp283_ = tmp282_*tmp143_;
   double tmp284_ = tmp282_*tmp142_;
   double tmp285_ = tmp283_*tmp157_;
   double tmp286_ = tmp285_*(tmp153_);
   double tmp287_ = tmp284_*tmp157_;
   double tmp288_ = tmp287_*(tmp165_);
   double tmp289_ = tmp286_+tmp288_;
   double tmp290_ = tmp281_*tmp157_;
   double tmp291_ = tmp290_*(tmp173_);
   double tmp292_ = tmp289_+tmp291_;
   double tmp293_ = -(tmp157_);
   double tmp294_ = tmp196_*tmp154_;
   double tmp295_ = tmp293_*tmp174_;
   double tmp296_ = tmp294_*tmp175_;
   double tmp297_ = tmp295_+tmp296_;
   double tmp298_ = (tmp297_)*(tmp153_);
   double tmp299_ = tmp293_*tmp143_;
   double tmp300_ = tmp294_*tmp176_;
   double tmp301_ = tmp299_+tmp300_;
   double tmp302_ = (tmp301_)*(tmp165_);
   double tmp303_ = tmp298_+tmp302_;
   double tmp304_ = tmp294_*tmp141_;
   double tmp305_ = tmp304_*(tmp173_);
   double tmp306_ = tmp303_+tmp305_;
   double tmp307_ = tmp196_*(tmp179_);
   double tmp308_ = tmp196_*(tmp183_);
   double tmp309_ = tmp196_*tmp186_;
   double tmp310_ = tmp196_*tmp33_;
   double tmp311_ = -(tmp12_);
   double tmp312_ = tmp310_*tmp37_;
   double tmp313_ = tmp310_*tmp43_;
   double tmp314_ = tmp313_*mLocP3X_A_0;
   double tmp315_ = tmp311_*tmp39_;
   double tmp316_ = tmp312_*tmp35_;
   double tmp317_ = tmp315_+tmp316_;
   double tmp318_ = (tmp317_)*mLocP3Y_A_0;
   double tmp319_ = tmp314_+tmp318_;
   double tmp320_ = tmp311_*tmp44_;
   double tmp321_ = tmp312_*tmp39_;
   double tmp322_ = tmp320_+tmp321_;
   double tmp323_ = (tmp322_)*mLocP3Z_A_0;
   double tmp324_ = tmp319_+tmp323_;
   double tmp325_ = tmp310_*tmp39_;
   double tmp326_ = tmp325_+tmp53_;
   double tmp327_ = (tmp326_)*mLocP3Y_A_0;
   double tmp328_ = tmp51_+tmp327_;
   double tmp329_ = tmp310_*tmp44_;
   double tmp330_ = tmp329_+tmp58_;
   double tmp331_ = (tmp330_)*mLocP3Z_A_0;
   double tmp332_ = tmp328_+tmp331_;
   double tmp333_ = (tmp324_)*(tmp129_);
   double tmp334_ = (tmp332_)*(tmp133_);
   double tmp335_ = tmp333_+tmp334_;
   double tmp336_ = tmp313_*mLocP3X_B_0;
   double tmp337_ = (tmp317_)*mLocP3Y_B_0;
   double tmp338_ = tmp336_+tmp337_;
   double tmp339_ = (tmp322_)*mLocP3Z_B_0;
   double tmp340_ = tmp338_+tmp339_;
   double tmp341_ = (tmp326_)*mLocP3Y_B_0;
   double tmp342_ = tmp146_+tmp341_;
   double tmp343_ = (tmp330_)*mLocP3Z_B_0;
   double tmp344_ = tmp342_+tmp343_;
   double tmp345_ = (tmp340_)*(tmp179_);
   double tmp346_ = (tmp344_)*(tmp183_);
   double tmp347_ = tmp345_+tmp346_;
   double tmp348_ = -(mLocTimeRot);
   double tmp349_ = tmp348_*tmp33_;
   double tmp350_ = mLocTimeRot*tmp12_;
   double tmp351_ = -(tmp350_);
   double tmp352_ = tmp349_*tmp37_;
   double tmp353_ = tmp350_*tmp37_;
   double tmp354_ = tmp349_*tmp43_;
   double tmp355_ = tmp354_*mLocP3X_A_0;
   double tmp356_ = tmp351_*tmp39_;
   double tmp357_ = tmp352_*tmp35_;
   double tmp358_ = tmp356_+tmp357_;
   double tmp359_ = (tmp358_)*mLocP3Y_A_0;
   double tmp360_ = tmp355_+tmp359_;
   double tmp361_ = tmp351_*tmp44_;
   double tmp362_ = tmp352_*tmp39_;
   double tmp363_ = tmp361_+tmp362_;
   double tmp364_ = (tmp363_)*mLocP3Z_A_0;
   double tmp365_ = tmp360_+tmp364_;
   double tmp366_ = tmp350_*tmp43_;
   double tmp367_ = tmp366_*mLocP3X_A_0;
   double tmp368_ = tmp349_*tmp39_;
   double tmp369_ = tmp353_*tmp35_;
   double tmp370_ = tmp368_+tmp369_;
   double tmp371_ = (tmp370_)*mLocP3Y_A_0;
   double tmp372_ = tmp367_+tmp371_;
   double tmp373_ = tmp349_*tmp44_;
   double tmp374_ = tmp353_*tmp39_;
   double tmp375_ = tmp373_+tmp374_;
   double tmp376_ = (tmp375_)*mLocP3Z_A_0;
   double tmp377_ = tmp372_+tmp376_;
   double tmp378_ = (tmp365_)*(tmp129_);
   double tmp379_ = (tmp377_)*(tmp133_);
   double tmp380_ = tmp378_+tmp379_;
   double tmp381_ = tmp354_*mLocP3X_B_0;
   double tmp382_ = (tmp358_)*mLocP3Y_B_0;
   double tmp383_ = tmp381_+tmp382_;
   double tmp384_ = (tmp363_)*mLocP3Z_B_0;
   double tmp385_ = tmp383_+tmp384_;
   double tmp386_ = tmp366_*mLocP3X_B_0;
   double tmp387_ = (tmp370_)*mLocP3Y_B_0;
   double tmp388_ = tmp386_+tmp387_;
   double tmp389_ = (tmp375_)*mLocP3Z_B_0;
   double tmp390_ = tmp388_+tmp389_;
   double tmp391_ = (tmp385_)*(tmp179_);
   double tmp392_ = (tmp390_)*(tmp183_);
   double tmp393_ = tmp391_+tmp392_;
   double tmp394_ = -(tmp0_);
   double tmp395_ = tmp394_*tmp33_;
   double tmp396_ = tmp0_*tmp12_;
   double tmp397_ = -(tmp396_);
   double tmp398_ = tmp395_*tmp37_;
   double tmp399_ = tmp396_*tmp37_;
   double tmp400_ = tmp395_*tmp43_;
   double tmp401_ = tmp400_*mLocP3X_A_0;
   double tmp402_ = tmp397_*tmp39_;
   double tmp403_ = tmp398_*tmp35_;
   double tmp404_ = tmp402_+tmp403_;
   double tmp405_ = (tmp404_)*mLocP3Y_A_0;
   double tmp406_ = tmp401_+tmp405_;
   double tmp407_ = tmp397_*tmp44_;
   double tmp408_ = tmp398_*tmp39_;
   double tmp409_ = tmp407_+tmp408_;
   double tmp410_ = (tmp409_)*mLocP3Z_A_0;
   double tmp411_ = tmp406_+tmp410_;
   double tmp412_ = tmp396_*tmp43_;
   double tmp413_ = tmp412_*mLocP3X_A_0;
   double tmp414_ = tmp395_*tmp39_;
   double tmp415_ = tmp399_*tmp35_;
   double tmp416_ = tmp414_+tmp415_;
   double tmp417_ = (tmp416_)*mLocP3Y_A_0;
   double tmp418_ = tmp413_+tmp417_;
   double tmp419_ = tmp395_*tmp44_;
   double tmp420_ = tmp399_*tmp39_;
   double tmp421_ = tmp419_+tmp420_;
   double tmp422_ = (tmp421_)*mLocP3Z_A_0;
   double tmp423_ = tmp418_+tmp422_;
   double tmp424_ = (tmp411_)*(tmp129_);
   double tmp425_ = (tmp423_)*(tmp133_);
   double tmp426_ = tmp424_+tmp425_;
   double tmp427_ = tmp400_*mLocP3X_B_0;
   double tmp428_ = (tmp404_)*mLocP3Y_B_0;
   double tmp429_ = tmp427_+tmp428_;
   double tmp430_ = (tmp409_)*mLocP3Z_B_0;
   double tmp431_ = tmp429_+tmp430_;
   double tmp432_ = tmp412_*mLocP3X_B_0;
   double tmp433_ = (tmp416_)*mLocP3Y_B_0;
   double tmp434_ = tmp432_+tmp433_;
   double tmp435_ = (tmp421_)*mLocP3Z_B_0;
   double tmp436_ = tmp434_+tmp435_;
   double tmp437_ = (tmp431_)*(tmp179_);
   double tmp438_ = (tmp436_)*(tmp183_);
   double tmp439_ = tmp437_+tmp438_;
   double tmp440_ = -(tmp1_);
   double tmp441_ = tmp440_*tmp33_;
   double tmp442_ = tmp1_*tmp12_;
   double tmp443_ = -(tmp442_);
   double tmp444_ = tmp441_*tmp37_;
   double tmp445_ = tmp442_*tmp37_;
   double tmp446_ = tmp441_*tmp43_;
   double tmp447_ = tmp446_*mLocP3X_A_0;
   double tmp448_ = tmp443_*tmp39_;
   double tmp449_ = tmp444_*tmp35_;
   double tmp450_ = tmp448_+tmp449_;
   double tmp451_ = (tmp450_)*mLocP3Y_A_0;
   double tmp452_ = tmp447_+tmp451_;
   double tmp453_ = tmp443_*tmp44_;
   double tmp454_ = tmp444_*tmp39_;
   double tmp455_ = tmp453_+tmp454_;
   double tmp456_ = (tmp455_)*mLocP3Z_A_0;
   double tmp457_ = tmp452_+tmp456_;
   double tmp458_ = tmp442_*tmp43_;
   double tmp459_ = tmp458_*mLocP3X_A_0;
   double tmp460_ = tmp441_*tmp39_;
   double tmp461_ = tmp445_*tmp35_;
   double tmp462_ = tmp460_+tmp461_;
   double tmp463_ = (tmp462_)*mLocP3Y_A_0;
   double tmp464_ = tmp459_+tmp463_;
   double tmp465_ = tmp441_*tmp44_;
   double tmp466_ = tmp445_*tmp39_;
   double tmp467_ = tmp465_+tmp466_;
   double tmp468_ = (tmp467_)*mLocP3Z_A_0;
   double tmp469_ = tmp464_+tmp468_;
   double tmp470_ = (tmp457_)*(tmp129_);
   double tmp471_ = (tmp469_)*(tmp133_);
   double tmp472_ = tmp470_+tmp471_;
   double tmp473_ = tmp446_*mLocP3X_B_0;
   double tmp474_ = (tmp450_)*mLocP3Y_B_0;
   double tmp475_ = tmp473_+tmp474_;
   double tmp476_ = (tmp455_)*mLocP3Z_B_0;
   double tmp477_ = tmp475_+tmp476_;
   double tmp478_ = tmp458_*mLocP3X_B_0;
   double tmp479_ = (tmp462_)*mLocP3Y_B_0;
   double tmp480_ = tmp478_+tmp479_;
   double tmp481_ = (tmp467_)*mLocP3Z_B_0;
   double tmp482_ = tmp480_+tmp481_;
   double tmp483_ = (tmp477_)*(tmp179_);
   double tmp484_ = (tmp482_)*(tmp183_);
   double tmp485_ = tmp483_+tmp484_;
   double tmp486_ = -(tmp43_);
   double tmp487_ = tmp486_*tmp12_;
   double tmp488_ = tmp196_*tmp36_;
   double tmp489_ = tmp486_*tmp33_;
   double tmp490_ = tmp488_*tmp12_;
   double tmp491_ = tmp490_*mLocP3X_A_0;
   double tmp492_ = tmp487_*tmp35_;
   double tmp493_ = tmp492_*mLocP3Y_A_0;
   double tmp494_ = tmp491_+tmp493_;
   double tmp495_ = tmp487_*tmp39_;
   double tmp496_ = tmp495_*mLocP3Z_A_0;
   double tmp497_ = tmp494_+tmp496_;
   double tmp498_ = tmp488_*tmp33_;
   double tmp499_ = tmp498_*mLocP3X_A_0;
   double tmp500_ = tmp489_*tmp35_;
   double tmp501_ = tmp500_*mLocP3Y_A_0;
   double tmp502_ = tmp499_+tmp501_;
   double tmp503_ = tmp489_*tmp39_;
   double tmp504_ = tmp503_*mLocP3Z_A_0;
   double tmp505_ = tmp502_+tmp504_;
   double tmp506_ = tmp43_*mLocP3X_A_0;
   double tmp507_ = tmp488_*tmp35_;
   double tmp508_ = tmp507_*mLocP3Y_A_0;
   double tmp509_ = tmp506_+tmp508_;
   double tmp510_ = tmp488_*tmp39_;
   double tmp511_ = tmp510_*mLocP3Z_A_0;
   double tmp512_ = tmp509_+tmp511_;
   double tmp513_ = (tmp497_)*(tmp129_);
   double tmp514_ = (tmp505_)*(tmp133_);
   double tmp515_ = tmp513_+tmp514_;
   double tmp516_ = (tmp512_)*tmp136_;
   double tmp517_ = tmp515_+tmp516_;
   double tmp518_ = tmp490_*mLocP3X_B_0;
   double tmp519_ = tmp492_*mLocP3Y_B_0;
   double tmp520_ = tmp518_+tmp519_;
   double tmp521_ = tmp495_*mLocP3Z_B_0;
   double tmp522_ = tmp520_+tmp521_;
   double tmp523_ = tmp498_*mLocP3X_B_0;
   double tmp524_ = tmp500_*mLocP3Y_B_0;
   double tmp525_ = tmp523_+tmp524_;
   double tmp526_ = tmp503_*mLocP3Z_B_0;
   double tmp527_ = tmp525_+tmp526_;
   double tmp528_ = tmp43_*mLocP3X_B_0;
   double tmp529_ = tmp507_*mLocP3Y_B_0;
   double tmp530_ = tmp528_+tmp529_;
   double tmp531_ = tmp510_*mLocP3Z_B_0;
   double tmp532_ = tmp530_+tmp531_;
   double tmp533_ = (tmp522_)*(tmp179_);
   double tmp534_ = (tmp527_)*(tmp183_);
   double tmp535_ = tmp533_+tmp534_;
   double tmp536_ = (tmp532_)*tmp186_;
   double tmp537_ = tmp535_+tmp536_;
   double tmp538_ = mLocTimeRot*tmp43_;
   double tmp539_ = -(tmp538_);
   double tmp540_ = tmp539_*tmp12_;
   double tmp541_ = tmp348_*tmp36_;
   double tmp542_ = tmp539_*tmp33_;
   double tmp543_ = tmp541_*tmp12_;
   double tmp544_ = tmp543_*mLocP3X_A_0;
   double tmp545_ = tmp540_*tmp35_;
   double tmp546_ = tmp545_*mLocP3Y_A_0;
   double tmp547_ = tmp544_+tmp546_;
   double tmp548_ = tmp540_*tmp39_;
   double tmp549_ = tmp548_*mLocP3Z_A_0;
   double tmp550_ = tmp547_+tmp549_;
   double tmp551_ = tmp541_*tmp33_;
   double tmp552_ = tmp551_*mLocP3X_A_0;
   double tmp553_ = tmp542_*tmp35_;
   double tmp554_ = tmp553_*mLocP3Y_A_0;
   double tmp555_ = tmp552_+tmp554_;
   double tmp556_ = tmp542_*tmp39_;
   double tmp557_ = tmp556_*mLocP3Z_A_0;
   double tmp558_ = tmp555_+tmp557_;
   double tmp559_ = tmp538_*mLocP3X_A_0;
   double tmp560_ = tmp541_*tmp35_;
   double tmp561_ = tmp560_*mLocP3Y_A_0;
   double tmp562_ = tmp559_+tmp561_;
   double tmp563_ = tmp541_*tmp39_;
   double tmp564_ = tmp563_*mLocP3Z_A_0;
   double tmp565_ = tmp562_+tmp564_;
   double tmp566_ = (tmp550_)*(tmp129_);
   double tmp567_ = (tmp558_)*(tmp133_);
   double tmp568_ = tmp566_+tmp567_;
   double tmp569_ = (tmp565_)*tmp136_;
   double tmp570_ = tmp568_+tmp569_;
   double tmp571_ = tmp543_*mLocP3X_B_0;
   double tmp572_ = tmp545_*mLocP3Y_B_0;
   double tmp573_ = tmp571_+tmp572_;
   double tmp574_ = tmp548_*mLocP3Z_B_0;
   double tmp575_ = tmp573_+tmp574_;
   double tmp576_ = tmp551_*mLocP3X_B_0;
   double tmp577_ = tmp553_*mLocP3Y_B_0;
   double tmp578_ = tmp576_+tmp577_;
   double tmp579_ = tmp556_*mLocP3Z_B_0;
   double tmp580_ = tmp578_+tmp579_;
   double tmp581_ = tmp538_*mLocP3X_B_0;
   double tmp582_ = tmp560_*mLocP3Y_B_0;
   double tmp583_ = tmp581_+tmp582_;
   double tmp584_ = tmp563_*mLocP3Z_B_0;
   double tmp585_ = tmp583_+tmp584_;
   double tmp586_ = (tmp575_)*(tmp179_);
   double tmp587_ = (tmp580_)*(tmp183_);
   double tmp588_ = tmp586_+tmp587_;
   double tmp589_ = (tmp585_)*tmp186_;
   double tmp590_ = tmp588_+tmp589_;
   double tmp591_ = tmp0_*tmp43_;
   double tmp592_ = -(tmp591_);
   double tmp593_ = tmp592_*tmp12_;
   double tmp594_ = tmp394_*tmp36_;
   double tmp595_ = tmp592_*tmp33_;
   double tmp596_ = tmp594_*tmp12_;
   double tmp597_ = tmp596_*mLocP3X_A_0;
   double tmp598_ = tmp593_*tmp35_;
   double tmp599_ = tmp598_*mLocP3Y_A_0;
   double tmp600_ = tmp597_+tmp599_;
   double tmp601_ = tmp593_*tmp39_;
   double tmp602_ = tmp601_*mLocP3Z_A_0;
   double tmp603_ = tmp600_+tmp602_;
   double tmp604_ = tmp594_*tmp33_;
   double tmp605_ = tmp604_*mLocP3X_A_0;
   double tmp606_ = tmp595_*tmp35_;
   double tmp607_ = tmp606_*mLocP3Y_A_0;
   double tmp608_ = tmp605_+tmp607_;
   double tmp609_ = tmp595_*tmp39_;
   double tmp610_ = tmp609_*mLocP3Z_A_0;
   double tmp611_ = tmp608_+tmp610_;
   double tmp612_ = tmp591_*mLocP3X_A_0;
   double tmp613_ = tmp594_*tmp35_;
   double tmp614_ = tmp613_*mLocP3Y_A_0;
   double tmp615_ = tmp612_+tmp614_;
   double tmp616_ = tmp594_*tmp39_;
   double tmp617_ = tmp616_*mLocP3Z_A_0;
   double tmp618_ = tmp615_+tmp617_;
   double tmp619_ = (tmp603_)*(tmp129_);
   double tmp620_ = (tmp611_)*(tmp133_);
   double tmp621_ = tmp619_+tmp620_;
   double tmp622_ = (tmp618_)*tmp136_;
   double tmp623_ = tmp621_+tmp622_;
   double tmp624_ = tmp596_*mLocP3X_B_0;
   double tmp625_ = tmp598_*mLocP3Y_B_0;
   double tmp626_ = tmp624_+tmp625_;
   double tmp627_ = tmp601_*mLocP3Z_B_0;
   double tmp628_ = tmp626_+tmp627_;
   double tmp629_ = tmp604_*mLocP3X_B_0;
   double tmp630_ = tmp606_*mLocP3Y_B_0;
   double tmp631_ = tmp629_+tmp630_;
   double tmp632_ = tmp609_*mLocP3Z_B_0;
   double tmp633_ = tmp631_+tmp632_;
   double tmp634_ = tmp591_*mLocP3X_B_0;
   double tmp635_ = tmp613_*mLocP3Y_B_0;
   double tmp636_ = tmp634_+tmp635_;
   double tmp637_ = tmp616_*mLocP3Z_B_0;
   double tmp638_ = tmp636_+tmp637_;
   double tmp639_ = (tmp628_)*(tmp179_);
   double tmp640_ = (tmp633_)*(tmp183_);
   double tmp641_ = tmp639_+tmp640_;
   double tmp642_ = (tmp638_)*tmp186_;
   double tmp643_ = tmp641_+tmp642_;
   double tmp644_ = tmp1_*tmp43_;
   double tmp645_ = -(tmp644_);
   double tmp646_ = tmp645_*tmp12_;
   double tmp647_ = tmp440_*tmp36_;
   double tmp648_ = tmp645_*tmp33_;
   double tmp649_ = tmp647_*tmp12_;
   double tmp650_ = tmp649_*mLocP3X_A_0;
   double tmp651_ = tmp646_*tmp35_;
   double tmp652_ = tmp651_*mLocP3Y_A_0;
   double tmp653_ = tmp650_+tmp652_;
   double tmp654_ = tmp646_*tmp39_;
   double tmp655_ = tmp654_*mLocP3Z_A_0;
   double tmp656_ = tmp653_+tmp655_;
   double tmp657_ = tmp647_*tmp33_;
   double tmp658_ = tmp657_*mLocP3X_A_0;
   double tmp659_ = tmp648_*tmp35_;
   double tmp660_ = tmp659_*mLocP3Y_A_0;
   double tmp661_ = tmp658_+tmp660_;
   double tmp662_ = tmp648_*tmp39_;
   double tmp663_ = tmp662_*mLocP3Z_A_0;
   double tmp664_ = tmp661_+tmp663_;
   double tmp665_ = tmp644_*mLocP3X_A_0;
   double tmp666_ = tmp647_*tmp35_;
   double tmp667_ = tmp666_*mLocP3Y_A_0;
   double tmp668_ = tmp665_+tmp667_;
   double tmp669_ = tmp647_*tmp39_;
   double tmp670_ = tmp669_*mLocP3Z_A_0;
   double tmp671_ = tmp668_+tmp670_;
   double tmp672_ = (tmp656_)*(tmp129_);
   double tmp673_ = (tmp664_)*(tmp133_);
   double tmp674_ = tmp672_+tmp673_;
   double tmp675_ = (tmp671_)*tmp136_;
   double tmp676_ = tmp674_+tmp675_;
   double tmp677_ = tmp649_*mLocP3X_B_0;
   double tmp678_ = tmp651_*mLocP3Y_B_0;
   double tmp679_ = tmp677_+tmp678_;
   double tmp680_ = tmp654_*mLocP3Z_B_0;
   double tmp681_ = tmp679_+tmp680_;
   double tmp682_ = tmp657_*mLocP3X_B_0;
   double tmp683_ = tmp659_*mLocP3Y_B_0;
   double tmp684_ = tmp682_+tmp683_;
   double tmp685_ = tmp662_*mLocP3Z_B_0;
   double tmp686_ = tmp684_+tmp685_;
   double tmp687_ = tmp644_*mLocP3X_B_0;
   double tmp688_ = tmp666_*mLocP3Y_B_0;
   double tmp689_ = tmp687_+tmp688_;
   double tmp690_ = tmp669_*mLocP3Z_B_0;
   double tmp691_ = tmp689_+tmp690_;
   double tmp692_ = (tmp681_)*(tmp179_);
   double tmp693_ = (tmp686_)*(tmp183_);
   double tmp694_ = tmp692_+tmp693_;
   double tmp695_ = (tmp691_)*tmp186_;
   double tmp696_ = tmp694_+tmp695_;
   double tmp697_ = tmp196_*tmp35_;
   double tmp698_ = -(tmp39_);
   double tmp699_ = tmp697_*tmp34_;
   double tmp700_ = tmp39_*tmp38_;
   double tmp701_ = tmp699_+tmp700_;
   double tmp702_ = (tmp701_)*mLocP3Y_A_0;
   double tmp703_ = tmp698_*tmp34_;
   double tmp704_ = tmp697_*tmp38_;
   double tmp705_ = tmp703_+tmp704_;
   double tmp706_ = (tmp705_)*mLocP3Z_A_0;
   double tmp707_ = tmp702_+tmp706_;
   double tmp708_ = tmp697_*tmp12_;
   double tmp709_ = tmp39_*tmp45_;
   double tmp710_ = tmp708_+tmp709_;
   double tmp711_ = (tmp710_)*mLocP3Y_A_0;
   double tmp712_ = tmp698_*tmp12_;
   double tmp713_ = tmp697_*tmp45_;
   double tmp714_ = tmp712_+tmp713_;
   double tmp715_ = (tmp714_)*mLocP3Z_A_0;
   double tmp716_ = tmp711_+tmp715_;
   double tmp717_ = tmp39_*tmp43_;
   double tmp718_ = tmp717_*mLocP3Y_A_0;
   double tmp719_ = tmp697_*tmp43_;
   double tmp720_ = tmp719_*mLocP3Z_A_0;
   double tmp721_ = tmp718_+tmp720_;
   double tmp722_ = (tmp707_)*(tmp129_);
   double tmp723_ = (tmp716_)*(tmp133_);
   double tmp724_ = tmp722_+tmp723_;
   double tmp725_ = (tmp721_)*tmp136_;
   double tmp726_ = tmp724_+tmp725_;
   double tmp727_ = (tmp701_)*mLocP3Y_B_0;
   double tmp728_ = (tmp705_)*mLocP3Z_B_0;
   double tmp729_ = tmp727_+tmp728_;
   double tmp730_ = (tmp710_)*mLocP3Y_B_0;
   double tmp731_ = (tmp714_)*mLocP3Z_B_0;
   double tmp732_ = tmp730_+tmp731_;
   double tmp733_ = tmp717_*mLocP3Y_B_0;
   double tmp734_ = tmp719_*mLocP3Z_B_0;
   double tmp735_ = tmp733_+tmp734_;
   double tmp736_ = (tmp729_)*(tmp179_);
   double tmp737_ = (tmp732_)*(tmp183_);
   double tmp738_ = tmp736_+tmp737_;
   double tmp739_ = (tmp735_)*tmp186_;
   double tmp740_ = tmp738_+tmp739_;
   double tmp741_ = mLocTimeRot*tmp39_;
   double tmp742_ = tmp348_*tmp35_;
   double tmp743_ = -(tmp741_);
   double tmp744_ = tmp742_*tmp34_;
   double tmp745_ = tmp741_*tmp38_;
   double tmp746_ = tmp744_+tmp745_;
   double tmp747_ = (tmp746_)*mLocP3Y_A_0;
   double tmp748_ = tmp743_*tmp34_;
   double tmp749_ = tmp742_*tmp38_;
   double tmp750_ = tmp748_+tmp749_;
   double tmp751_ = (tmp750_)*mLocP3Z_A_0;
   double tmp752_ = tmp747_+tmp751_;
   double tmp753_ = tmp742_*tmp12_;
   double tmp754_ = tmp741_*tmp45_;
   double tmp755_ = tmp753_+tmp754_;
   double tmp756_ = (tmp755_)*mLocP3Y_A_0;
   double tmp757_ = tmp743_*tmp12_;
   double tmp758_ = tmp742_*tmp45_;
   double tmp759_ = tmp757_+tmp758_;
   double tmp760_ = (tmp759_)*mLocP3Z_A_0;
   double tmp761_ = tmp756_+tmp760_;
   double tmp762_ = tmp741_*tmp43_;
   double tmp763_ = tmp762_*mLocP3Y_A_0;
   double tmp764_ = tmp742_*tmp43_;
   double tmp765_ = tmp764_*mLocP3Z_A_0;
   double tmp766_ = tmp763_+tmp765_;
   double tmp767_ = (tmp752_)*(tmp129_);
   double tmp768_ = (tmp761_)*(tmp133_);
   double tmp769_ = tmp767_+tmp768_;
   double tmp770_ = (tmp766_)*tmp136_;
   double tmp771_ = tmp769_+tmp770_;
   double tmp772_ = (tmp746_)*mLocP3Y_B_0;
   double tmp773_ = (tmp750_)*mLocP3Z_B_0;
   double tmp774_ = tmp772_+tmp773_;
   double tmp775_ = (tmp755_)*mLocP3Y_B_0;
   double tmp776_ = (tmp759_)*mLocP3Z_B_0;
   double tmp777_ = tmp775_+tmp776_;
   double tmp778_ = tmp762_*mLocP3Y_B_0;
   double tmp779_ = tmp764_*mLocP3Z_B_0;
   double tmp780_ = tmp778_+tmp779_;
   double tmp781_ = (tmp774_)*(tmp179_);
   double tmp782_ = (tmp777_)*(tmp183_);
   double tmp783_ = tmp781_+tmp782_;
   double tmp784_ = (tmp780_)*tmp186_;
   double tmp785_ = tmp783_+tmp784_;
   double tmp786_ = tmp0_*tmp39_;
   double tmp787_ = tmp394_*tmp35_;
   double tmp788_ = -(tmp786_);
   double tmp789_ = tmp787_*tmp34_;
   double tmp790_ = tmp786_*tmp38_;
   double tmp791_ = tmp789_+tmp790_;
   double tmp792_ = (tmp791_)*mLocP3Y_A_0;
   double tmp793_ = tmp788_*tmp34_;
   double tmp794_ = tmp787_*tmp38_;
   double tmp795_ = tmp793_+tmp794_;
   double tmp796_ = (tmp795_)*mLocP3Z_A_0;
   double tmp797_ = tmp792_+tmp796_;
   double tmp798_ = tmp787_*tmp12_;
   double tmp799_ = tmp786_*tmp45_;
   double tmp800_ = tmp798_+tmp799_;
   double tmp801_ = (tmp800_)*mLocP3Y_A_0;
   double tmp802_ = tmp788_*tmp12_;
   double tmp803_ = tmp787_*tmp45_;
   double tmp804_ = tmp802_+tmp803_;
   double tmp805_ = (tmp804_)*mLocP3Z_A_0;
   double tmp806_ = tmp801_+tmp805_;
   double tmp807_ = tmp786_*tmp43_;
   double tmp808_ = tmp807_*mLocP3Y_A_0;
   double tmp809_ = tmp787_*tmp43_;
   double tmp810_ = tmp809_*mLocP3Z_A_0;
   double tmp811_ = tmp808_+tmp810_;
   double tmp812_ = (tmp797_)*(tmp129_);
   double tmp813_ = (tmp806_)*(tmp133_);
   double tmp814_ = tmp812_+tmp813_;
   double tmp815_ = (tmp811_)*tmp136_;
   double tmp816_ = tmp814_+tmp815_;
   double tmp817_ = (tmp791_)*mLocP3Y_B_0;
   double tmp818_ = (tmp795_)*mLocP3Z_B_0;
   double tmp819_ = tmp817_+tmp818_;
   double tmp820_ = (tmp800_)*mLocP3Y_B_0;
   double tmp821_ = (tmp804_)*mLocP3Z_B_0;
   double tmp822_ = tmp820_+tmp821_;
   double tmp823_ = tmp807_*mLocP3Y_B_0;
   double tmp824_ = tmp809_*mLocP3Z_B_0;
   double tmp825_ = tmp823_+tmp824_;
   double tmp826_ = (tmp819_)*(tmp179_);
   double tmp827_ = (tmp822_)*(tmp183_);
   double tmp828_ = tmp826_+tmp827_;
   double tmp829_ = (tmp825_)*tmp186_;
   double tmp830_ = tmp828_+tmp829_;
   double tmp831_ = tmp1_*tmp39_;
   double tmp832_ = tmp440_*tmp35_;
   double tmp833_ = -(tmp831_);
   double tmp834_ = tmp832_*tmp34_;
   double tmp835_ = tmp831_*tmp38_;
   double tmp836_ = tmp834_+tmp835_;
   double tmp837_ = (tmp836_)*mLocP3Y_A_0;
   double tmp838_ = tmp833_*tmp34_;
   double tmp839_ = tmp832_*tmp38_;
   double tmp840_ = tmp838_+tmp839_;
   double tmp841_ = (tmp840_)*mLocP3Z_A_0;
   double tmp842_ = tmp837_+tmp841_;
   double tmp843_ = tmp832_*tmp12_;
   double tmp844_ = tmp831_*tmp45_;
   double tmp845_ = tmp843_+tmp844_;
   double tmp846_ = (tmp845_)*mLocP3Y_A_0;
   double tmp847_ = tmp833_*tmp12_;
   double tmp848_ = tmp832_*tmp45_;
   double tmp849_ = tmp847_+tmp848_;
   double tmp850_ = (tmp849_)*mLocP3Z_A_0;
   double tmp851_ = tmp846_+tmp850_;
   double tmp852_ = tmp831_*tmp43_;
   double tmp853_ = tmp852_*mLocP3Y_A_0;
   double tmp854_ = tmp832_*tmp43_;
   double tmp855_ = tmp854_*mLocP3Z_A_0;
   double tmp856_ = tmp853_+tmp855_;
   double tmp857_ = (tmp842_)*(tmp129_);
   double tmp858_ = (tmp851_)*(tmp133_);
   double tmp859_ = tmp857_+tmp858_;
   double tmp860_ = (tmp856_)*tmp136_;
   double tmp861_ = tmp859_+tmp860_;
   double tmp862_ = (tmp836_)*mLocP3Y_B_0;
   double tmp863_ = (tmp840_)*mLocP3Z_B_0;
   double tmp864_ = tmp862_+tmp863_;
   double tmp865_ = (tmp845_)*mLocP3Y_B_0;
   double tmp866_ = (tmp849_)*mLocP3Z_B_0;
   double tmp867_ = tmp865_+tmp866_;
   double tmp868_ = tmp852_*mLocP3Y_B_0;
   double tmp869_ = tmp854_*mLocP3Z_B_0;
   double tmp870_ = tmp868_+tmp869_;
   double tmp871_ = (tmp864_)*(tmp179_);
   double tmp872_ = (tmp867_)*(tmp183_);
   double tmp873_ = tmp871_+tmp872_;
   double tmp874_ = (tmp870_)*tmp186_;
   double tmp875_ = tmp873_+tmp874_;
   double tmp876_ = mLocTimeRot*(tmp129_);
   double tmp877_ = mLocTimeRot*(tmp179_);
   double tmp878_ = tmp0_*(tmp129_);
   double tmp879_ = tmp0_*(tmp179_);
   double tmp880_ = tmp1_*(tmp129_);
   double tmp881_ = tmp1_*(tmp179_);
   double tmp882_ = mLocTimeRot*(tmp133_);
   double tmp883_ = mLocTimeRot*(tmp183_);
   double tmp884_ = tmp0_*(tmp133_);
   double tmp885_ = tmp0_*(tmp183_);
   double tmp886_ = tmp1_*(tmp133_);
   double tmp887_ = tmp1_*(tmp183_);
   double tmp888_ = mLocTimeRot*tmp136_;
   double tmp889_ = mLocTimeRot*tmp186_;
   double tmp890_ = tmp0_*tmp136_;
   double tmp891_ = tmp0_*tmp186_;
   double tmp892_ = tmp1_*tmp136_;
   double tmp893_ = tmp1_*tmp186_;

  mVal[0] = (mLocCste_A_0+mLocCoeffU_A_0*((tmp195_)/(tmp138_))+mLocCoeffV_A_0*((tmp211_)/(tmp138_)))-(mLocCste_B_0+mLocCoeffU_B_0*((tmp256_)/(tmp188_))+mLocCoeffV_B_0*((tmp271_)/(tmp188_)));

  mCompDer[0][0] = (((tmp197_*tmp42_*(tmp74_)+tmp189_*(tmp103_))*(tmp138_)-(tmp195_)*(tmp219_))/tmp220_)*mLocCoeffU_A_0+((((tmp198_*tmp78_+tmp199_*tmp75_)*(tmp74_)+(tmp197_*tmp78_+tmp200_)*(tmp103_))*(tmp138_)-(tmp211_)*(tmp219_))/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][1] = (((tmp221_*tmp47_*(tmp74_)+tmp221_*tmp46_*(tmp103_)+tmp42_*(tmp123_))*(tmp138_)-(tmp195_)*(tmp232_))/tmp220_)*mLocCoeffU_A_0+(((tmp223_*tmp75_*(tmp74_)+tmp224_*tmp75_*(tmp103_)+tmp221_*tmp75_*(tmp123_))*(tmp138_)-(tmp211_)*(tmp232_))/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][2] = (-((tmp195_)*(tmp246_))/tmp220_)*mLocCoeffU_A_0+((((tmp234_*tmp124_+tmp78_*tmp125_)*(tmp74_)+(tmp234_*tmp47_+tmp78_*tmp126_)*(tmp103_)+tmp78_*tmp42_*(tmp123_))*(tmp138_)-(tmp211_)*(tmp246_))/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][3] = ((tmp196_*tmp189_*(tmp138_)-(tmp195_)*tmp247_)/tmp220_)*mLocCoeffU_A_0+((tmp196_*(tmp202_)*(tmp138_)-(tmp211_)*tmp247_)/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][4] = ((tmp196_*tmp191_*(tmp138_)-(tmp195_)*tmp248_)/tmp220_)*mLocCoeffU_A_0+((tmp196_*(tmp206_)*(tmp138_)-(tmp211_)*tmp248_)/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][5] = ((tmp221_*(tmp138_)-(tmp195_)*tmp249_)/tmp220_)*mLocCoeffU_A_0+((tmp196_*tmp209_*(tmp138_)-(tmp211_)*tmp249_)/tmp220_)*mLocCoeffV_A_0;
  mCompDer[0][6] = -((((tmp257_*tmp141_*(tmp153_)+tmp250_*(tmp165_))*(tmp188_)-(tmp256_)*(tmp279_))/tmp280_)*mLocCoeffU_B_0+((((tmp258_*tmp157_+tmp259_*tmp154_)*(tmp153_)+(tmp257_*tmp157_+tmp260_)*(tmp165_))*(tmp188_)-(tmp271_)*(tmp279_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][7] = -((((tmp281_*tmp143_*(tmp153_)+tmp281_*tmp142_*(tmp165_)+tmp141_*(tmp173_))*(tmp188_)-(tmp256_)*(tmp292_))/tmp280_)*mLocCoeffU_B_0+(((tmp283_*tmp154_*(tmp153_)+tmp284_*tmp154_*(tmp165_)+tmp281_*tmp154_*(tmp173_))*(tmp188_)-(tmp271_)*(tmp292_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][8] = -((-((tmp256_)*(tmp306_))/tmp280_)*mLocCoeffU_B_0+((((tmp294_*tmp174_+tmp157_*tmp175_)*(tmp153_)+(tmp294_*tmp143_+tmp157_*tmp176_)*(tmp165_)+tmp157_*tmp141_*(tmp173_))*(tmp188_)-(tmp271_)*(tmp306_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][9] = -(((tmp196_*tmp250_*(tmp188_)-(tmp256_)*tmp307_)/tmp280_)*mLocCoeffU_B_0+((tmp196_*(tmp262_)*(tmp188_)-(tmp271_)*tmp307_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][10] = -(((tmp196_*tmp252_*(tmp188_)-(tmp256_)*tmp308_)/tmp280_)*mLocCoeffU_B_0+((tmp196_*(tmp266_)*(tmp188_)-(tmp271_)*tmp308_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][11] = -(((tmp281_*(tmp188_)-(tmp256_)*tmp309_)/tmp280_)*mLocCoeffU_B_0+((tmp196_*tmp269_*(tmp188_)-(tmp271_)*tmp309_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][12] = (((((tmp324_)*tmp189_+(tmp332_)*tmp191_)*(tmp138_)-(tmp195_)*(tmp335_))/tmp220_)*mLocCoeffU_A_0+((((tmp324_)*(tmp202_)+(tmp332_)*(tmp206_))*(tmp138_)-(tmp211_)*(tmp335_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp340_)*tmp250_+(tmp344_)*tmp252_)*(tmp188_)-(tmp256_)*(tmp347_))/tmp280_)*mLocCoeffU_B_0+((((tmp340_)*(tmp262_)+(tmp344_)*(tmp266_))*(tmp188_)-(tmp271_)*(tmp347_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][13] = (((((tmp365_)*tmp189_+(tmp377_)*tmp191_)*(tmp138_)-(tmp195_)*(tmp380_))/tmp220_)*mLocCoeffU_A_0+((((tmp365_)*(tmp202_)+(tmp377_)*(tmp206_))*(tmp138_)-(tmp211_)*(tmp380_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp385_)*tmp250_+(tmp390_)*tmp252_)*(tmp188_)-(tmp256_)*(tmp393_))/tmp280_)*mLocCoeffU_B_0+((((tmp385_)*(tmp262_)+(tmp390_)*(tmp266_))*(tmp188_)-(tmp271_)*(tmp393_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][14] = (((((tmp411_)*tmp189_+(tmp423_)*tmp191_)*(tmp138_)-(tmp195_)*(tmp426_))/tmp220_)*mLocCoeffU_A_0+((((tmp411_)*(tmp202_)+(tmp423_)*(tmp206_))*(tmp138_)-(tmp211_)*(tmp426_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp431_)*tmp250_+(tmp436_)*tmp252_)*(tmp188_)-(tmp256_)*(tmp439_))/tmp280_)*mLocCoeffU_B_0+((((tmp431_)*(tmp262_)+(tmp436_)*(tmp266_))*(tmp188_)-(tmp271_)*(tmp439_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][15] = (((((tmp457_)*tmp189_+(tmp469_)*tmp191_)*(tmp138_)-(tmp195_)*(tmp472_))/tmp220_)*mLocCoeffU_A_0+((((tmp457_)*(tmp202_)+(tmp469_)*(tmp206_))*(tmp138_)-(tmp211_)*(tmp472_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp477_)*tmp250_+(tmp482_)*tmp252_)*(tmp188_)-(tmp256_)*(tmp485_))/tmp280_)*mLocCoeffU_B_0+((((tmp477_)*(tmp262_)+(tmp482_)*(tmp266_))*(tmp188_)-(tmp271_)*(tmp485_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][16] = (((((tmp497_)*tmp189_+(tmp505_)*tmp191_+(tmp512_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp517_))/tmp220_)*mLocCoeffU_A_0+((((tmp497_)*(tmp202_)+(tmp505_)*(tmp206_)+(tmp512_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp517_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp522_)*tmp250_+(tmp527_)*tmp252_+(tmp532_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp537_))/tmp280_)*mLocCoeffU_B_0+((((tmp522_)*(tmp262_)+(tmp527_)*(tmp266_)+(tmp532_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp537_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][17] = (((((tmp550_)*tmp189_+(tmp558_)*tmp191_+(tmp565_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp570_))/tmp220_)*mLocCoeffU_A_0+((((tmp550_)*(tmp202_)+(tmp558_)*(tmp206_)+(tmp565_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp570_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp575_)*tmp250_+(tmp580_)*tmp252_+(tmp585_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp590_))/tmp280_)*mLocCoeffU_B_0+((((tmp575_)*(tmp262_)+(tmp580_)*(tmp266_)+(tmp585_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp590_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][18] = (((((tmp603_)*tmp189_+(tmp611_)*tmp191_+(tmp618_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp623_))/tmp220_)*mLocCoeffU_A_0+((((tmp603_)*(tmp202_)+(tmp611_)*(tmp206_)+(tmp618_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp623_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp628_)*tmp250_+(tmp633_)*tmp252_+(tmp638_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp643_))/tmp280_)*mLocCoeffU_B_0+((((tmp628_)*(tmp262_)+(tmp633_)*(tmp266_)+(tmp638_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp643_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][19] = (((((tmp656_)*tmp189_+(tmp664_)*tmp191_+(tmp671_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp676_))/tmp220_)*mLocCoeffU_A_0+((((tmp656_)*(tmp202_)+(tmp664_)*(tmp206_)+(tmp671_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp676_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp681_)*tmp250_+(tmp686_)*tmp252_+(tmp691_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp696_))/tmp280_)*mLocCoeffU_B_0+((((tmp681_)*(tmp262_)+(tmp686_)*(tmp266_)+(tmp691_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp696_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][20] = (((((tmp707_)*tmp189_+(tmp716_)*tmp191_+(tmp721_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp726_))/tmp220_)*mLocCoeffU_A_0+((((tmp707_)*(tmp202_)+(tmp716_)*(tmp206_)+(tmp721_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp726_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp729_)*tmp250_+(tmp732_)*tmp252_+(tmp735_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp740_))/tmp280_)*mLocCoeffU_B_0+((((tmp729_)*(tmp262_)+(tmp732_)*(tmp266_)+(tmp735_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp740_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][21] = (((((tmp752_)*tmp189_+(tmp761_)*tmp191_+(tmp766_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp771_))/tmp220_)*mLocCoeffU_A_0+((((tmp752_)*(tmp202_)+(tmp761_)*(tmp206_)+(tmp766_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp771_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp774_)*tmp250_+(tmp777_)*tmp252_+(tmp780_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp785_))/tmp280_)*mLocCoeffU_B_0+((((tmp774_)*(tmp262_)+(tmp777_)*(tmp266_)+(tmp780_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp785_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][22] = (((((tmp797_)*tmp189_+(tmp806_)*tmp191_+(tmp811_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp816_))/tmp220_)*mLocCoeffU_A_0+((((tmp797_)*(tmp202_)+(tmp806_)*(tmp206_)+(tmp811_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp816_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp819_)*tmp250_+(tmp822_)*tmp252_+(tmp825_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp830_))/tmp280_)*mLocCoeffU_B_0+((((tmp819_)*(tmp262_)+(tmp822_)*(tmp266_)+(tmp825_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp830_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][23] = (((((tmp842_)*tmp189_+(tmp851_)*tmp191_+(tmp856_)*tmp48_)*(tmp138_)-(tmp195_)*(tmp861_))/tmp220_)*mLocCoeffU_A_0+((((tmp842_)*(tmp202_)+(tmp851_)*(tmp206_)+(tmp856_)*tmp209_)*(tmp138_)-(tmp211_)*(tmp861_))/tmp220_)*mLocCoeffV_A_0)-(((((tmp864_)*tmp250_+(tmp867_)*tmp252_+(tmp870_)*tmp144_)*(tmp188_)-(tmp256_)*(tmp875_))/tmp280_)*mLocCoeffU_B_0+((((tmp864_)*(tmp262_)+(tmp867_)*(tmp266_)+(tmp870_)*tmp269_)*(tmp188_)-(tmp271_)*(tmp875_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][24] = (((tmp189_*(tmp138_)-(tmp195_)*(tmp129_))/tmp220_)*mLocCoeffU_A_0+(((tmp202_)*(tmp138_)-(tmp211_)*(tmp129_))/tmp220_)*mLocCoeffV_A_0)-(((tmp250_*(tmp188_)-(tmp256_)*(tmp179_))/tmp280_)*mLocCoeffU_B_0+(((tmp262_)*(tmp188_)-(tmp271_)*(tmp179_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][25] = (((mLocTimeRot*tmp189_*(tmp138_)-(tmp195_)*tmp876_)/tmp220_)*mLocCoeffU_A_0+((mLocTimeRot*(tmp202_)*(tmp138_)-(tmp211_)*tmp876_)/tmp220_)*mLocCoeffV_A_0)-(((mLocTimeRot*tmp250_*(tmp188_)-(tmp256_)*tmp877_)/tmp280_)*mLocCoeffU_B_0+((mLocTimeRot*(tmp262_)*(tmp188_)-(tmp271_)*tmp877_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][26] = (((tmp0_*tmp189_*(tmp138_)-(tmp195_)*tmp878_)/tmp220_)*mLocCoeffU_A_0+((tmp0_*(tmp202_)*(tmp138_)-(tmp211_)*tmp878_)/tmp220_)*mLocCoeffV_A_0)-(((tmp0_*tmp250_*(tmp188_)-(tmp256_)*tmp879_)/tmp280_)*mLocCoeffU_B_0+((tmp0_*(tmp262_)*(tmp188_)-(tmp271_)*tmp879_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][27] = (((tmp1_*tmp189_*(tmp138_)-(tmp195_)*tmp880_)/tmp220_)*mLocCoeffU_A_0+((tmp1_*(tmp202_)*(tmp138_)-(tmp211_)*tmp880_)/tmp220_)*mLocCoeffV_A_0)-(((tmp1_*tmp250_*(tmp188_)-(tmp256_)*tmp881_)/tmp280_)*mLocCoeffU_B_0+((tmp1_*(tmp262_)*(tmp188_)-(tmp271_)*tmp881_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][28] = (((tmp191_*(tmp138_)-(tmp195_)*(tmp133_))/tmp220_)*mLocCoeffU_A_0+(((tmp206_)*(tmp138_)-(tmp211_)*(tmp133_))/tmp220_)*mLocCoeffV_A_0)-(((tmp252_*(tmp188_)-(tmp256_)*(tmp183_))/tmp280_)*mLocCoeffU_B_0+(((tmp266_)*(tmp188_)-(tmp271_)*(tmp183_))/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][29] = (((mLocTimeRot*tmp191_*(tmp138_)-(tmp195_)*tmp882_)/tmp220_)*mLocCoeffU_A_0+((mLocTimeRot*(tmp206_)*(tmp138_)-(tmp211_)*tmp882_)/tmp220_)*mLocCoeffV_A_0)-(((mLocTimeRot*tmp252_*(tmp188_)-(tmp256_)*tmp883_)/tmp280_)*mLocCoeffU_B_0+((mLocTimeRot*(tmp266_)*(tmp188_)-(tmp271_)*tmp883_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][30] = (((tmp0_*tmp191_*(tmp138_)-(tmp195_)*tmp884_)/tmp220_)*mLocCoeffU_A_0+((tmp0_*(tmp206_)*(tmp138_)-(tmp211_)*tmp884_)/tmp220_)*mLocCoeffV_A_0)-(((tmp0_*tmp252_*(tmp188_)-(tmp256_)*tmp885_)/tmp280_)*mLocCoeffU_B_0+((tmp0_*(tmp266_)*(tmp188_)-(tmp271_)*tmp885_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][31] = (((tmp1_*tmp191_*(tmp138_)-(tmp195_)*tmp886_)/tmp220_)*mLocCoeffU_A_0+((tmp1_*(tmp206_)*(tmp138_)-(tmp211_)*tmp886_)/tmp220_)*mLocCoeffV_A_0)-(((tmp1_*tmp252_*(tmp188_)-(tmp256_)*tmp887_)/tmp280_)*mLocCoeffU_B_0+((tmp1_*(tmp266_)*(tmp188_)-(tmp271_)*tmp887_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][32] = (((tmp48_*(tmp138_)-(tmp195_)*tmp136_)/tmp220_)*mLocCoeffU_A_0+((tmp209_*(tmp138_)-(tmp211_)*tmp136_)/tmp220_)*mLocCoeffV_A_0)-(((tmp144_*(tmp188_)-(tmp256_)*tmp186_)/tmp280_)*mLocCoeffU_B_0+((tmp269_*(tmp188_)-(tmp271_)*tmp186_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][33] = (((mLocTimeRot*tmp48_*(tmp138_)-(tmp195_)*tmp888_)/tmp220_)*mLocCoeffU_A_0+((mLocTimeRot*tmp209_*(tmp138_)-(tmp211_)*tmp888_)/tmp220_)*mLocCoeffV_A_0)-(((mLocTimeRot*tmp144_*(tmp188_)-(tmp256_)*tmp889_)/tmp280_)*mLocCoeffU_B_0+((mLocTimeRot*tmp269_*(tmp188_)-(tmp271_)*tmp889_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][34] = (((tmp0_*tmp48_*(tmp138_)-(tmp195_)*tmp890_)/tmp220_)*mLocCoeffU_A_0+((tmp0_*tmp209_*(tmp138_)-(tmp211_)*tmp890_)/tmp220_)*mLocCoeffV_A_0)-(((tmp0_*tmp144_*(tmp188_)-(tmp256_)*tmp891_)/tmp280_)*mLocCoeffU_B_0+((tmp0_*tmp269_*(tmp188_)-(tmp271_)*tmp891_)/tmp280_)*mLocCoeffV_B_0);
  mCompDer[0][35] = (((tmp1_*tmp48_*(tmp138_)-(tmp195_)*tmp892_)/tmp220_)*mLocCoeffU_A_0+((tmp1_*tmp209_*(tmp138_)-(tmp211_)*tmp892_)/tmp220_)*mLocCoeffV_A_0)-(((tmp1_*tmp144_*(tmp188_)-(tmp256_)*tmp893_)/tmp280_)*mLocCoeffU_B_0+((tmp1_*tmp269_*(tmp188_)-(tmp271_)*tmp893_)/tmp280_)*mLocCoeffV_B_0);
}


void cEqCorLI_Multi_1_DRPts3_NonNorm::ComputeValDerivHessian()
{
  ELISE_ASSERT(false,"Foncteur cEqCorLI_Multi_1_DRPts3_NonNorm Has no Der Sec");
}

void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCoeffU_A_0(double aVal){ mLocCoeffU_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCoeffU_B_0(double aVal){ mLocCoeffU_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCoeffV_A_0(double aVal){ mLocCoeffV_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCoeffV_B_0(double aVal){ mLocCoeffV_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCste_A_0(double aVal){ mLocCste_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetCste_B_0(double aVal){ mLocCste_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3X_A_0(double aVal){ mLocP3X_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3X_B_0(double aVal){ mLocP3X_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3Y_A_0(double aVal){ mLocP3Y_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3Y_B_0(double aVal){ mLocP3Y_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3Z_A_0(double aVal){ mLocP3Z_A_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetP3Z_B_0(double aVal){ mLocP3Z_B_0 = aVal;}
void cEqCorLI_Multi_1_DRPts3_NonNorm::SetTimeRot(double aVal){ mLocTimeRot = aVal;}



double * cEqCorLI_Multi_1_DRPts3_NonNorm::AdrVarLocFromString(const std::string & aName)
{
   if (aName == "CoeffU_A_0") return & mLocCoeffU_A_0;
   if (aName == "CoeffU_B_0") return & mLocCoeffU_B_0;
   if (aName == "CoeffV_A_0") return & mLocCoeffV_A_0;
   if (aName == "CoeffV_B_0") return & mLocCoeffV_B_0;
   if (aName == "Cste_A_0") return & mLocCste_A_0;
   if (aName == "Cste_B_0") return & mLocCste_B_0;
   if (aName == "P3X_A_0") return & mLocP3X_A_0;
   if (aName == "P3X_B_0") return & mLocP3X_B_0;
   if (aName == "P3Y_A_0") return & mLocP3Y_A_0;
   if (aName == "P3Y_B_0") return & mLocP3Y_B_0;
   if (aName == "P3Z_A_0") return & mLocP3Z_A_0;
   if (aName == "P3Z_B_0") return & mLocP3Z_B_0;
   if (aName == "TimeRot") return & mLocTimeRot;
   return 0;
}


cElCompiledFonc::cAutoAddEntry cEqCorLI_Multi_1_DRPts3_NonNorm::mTheAuto("cEqCorLI_Multi_1_DRPts3_NonNorm",cEqCorLI_Multi_1_DRPts3_NonNorm::Alloc);


cElCompiledFonc *  cEqCorLI_Multi_1_DRPts3_NonNorm::Alloc()
{  return new cEqCorLI_Multi_1_DRPts3_NonNorm();
}



/*Footer-MicMac-eLiSe-25/06/2007

Ce logiciel est un programme informatique servant à la mise en
correspondances d'images pour la reconstruction du relief.

Ce logiciel est régi par la licence CeCILL-B soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-B telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL-B, et que vous en avez accepté les
termes.
Footer-MicMac-eLiSe-25/06/2007*/
