/*Header-MicMac-eLiSe-25/06/2007

    MicMac : Multi Image Correspondances par Methodes Automatiques de Correlation
    eLiSe  : ELements of an Image Software Environnement

    www.micmac.ign.fr

   
    Copyright : Institut Geographique National
    Author : Marc Pierrot Deseilligny
    Contributors : Gregoire Maillet, Didier Boldo.

[1] M. Pierrot-Deseilligny, N. Paparoditis.
    "A multiresolution and optimization-based image matching approach:
    An application to surface reconstruction from SPOT5-HRS stereo imagery."
    In IAPRS vol XXXVI-1/W41 in ISPRS Workshop On Topographic Mapping From Space
    (With Special Emphasis on Small Satellites), Ankara, Turquie, 02-2006.

[2] M. Pierrot-Deseilligny, "MicMac, un lociel de mise en correspondance
    d'images, adapte au contexte geograhique" to appears in 
    Bulletin d'information de l'Institut Geographique National, 2007.

Francais :

   MicMac est un logiciel de mise en correspondance d'image adapte 
   au contexte de recherche en information geographique. Il s'appuie sur
   la bibliotheque de manipulation d'image eLiSe. Il est distibue sous la
   licences Cecill-B.  Voir en bas de fichier et  http://www.cecill.info.


English :

    MicMac is an open source software specialized in image matching
    for research in geographic information. MicMac is built on the
    eLiSe image library. MicMac is governed by the  "Cecill-B licence".
    See below and http://www.cecill.info.

Header-MicMac-eLiSe-25/06/2007*/
// File Automatically generated by eLiSe
#ifndef _cEqCorrelGrid_49_Im2Var_h_
#define _cEqCorrelGrid_49_Im2Var_h_

#include "general/all.h"
#include "private/all.h"


class cEqCorrelGrid_49_Im2Var: public cElCompiledFonc
{
   public :

      cEqCorrelGrid_49_Im2Var();
      void ComputeVal();
      void ComputeValDeriv();
      void ComputeValDerivHessian();
      double * AdrVarLocFromString(const std::string &);
      void SetDGr2Dz0(double);
      void SetDGr2Dz1(double);
      void SetDGr2Dz10(double);
      void SetDGr2Dz11(double);
      void SetDGr2Dz12(double);
      void SetDGr2Dz13(double);
      void SetDGr2Dz14(double);
      void SetDGr2Dz15(double);
      void SetDGr2Dz16(double);
      void SetDGr2Dz17(double);
      void SetDGr2Dz18(double);
      void SetDGr2Dz19(double);
      void SetDGr2Dz2(double);
      void SetDGr2Dz20(double);
      void SetDGr2Dz21(double);
      void SetDGr2Dz22(double);
      void SetDGr2Dz23(double);
      void SetDGr2Dz24(double);
      void SetDGr2Dz25(double);
      void SetDGr2Dz26(double);
      void SetDGr2Dz27(double);
      void SetDGr2Dz28(double);
      void SetDGr2Dz29(double);
      void SetDGr2Dz3(double);
      void SetDGr2Dz30(double);
      void SetDGr2Dz31(double);
      void SetDGr2Dz32(double);
      void SetDGr2Dz33(double);
      void SetDGr2Dz34(double);
      void SetDGr2Dz35(double);
      void SetDGr2Dz36(double);
      void SetDGr2Dz37(double);
      void SetDGr2Dz38(double);
      void SetDGr2Dz39(double);
      void SetDGr2Dz4(double);
      void SetDGr2Dz40(double);
      void SetDGr2Dz41(double);
      void SetDGr2Dz42(double);
      void SetDGr2Dz43(double);
      void SetDGr2Dz44(double);
      void SetDGr2Dz45(double);
      void SetDGr2Dz46(double);
      void SetDGr2Dz47(double);
      void SetDGr2Dz48(double);
      void SetDGr2Dz5(double);
      void SetDGr2Dz6(double);
      void SetDGr2Dz7(double);
      void SetDGr2Dz8(double);
      void SetDGr2Dz9(double);
      void SetGr1_0(double);
      void SetGr1_1(double);
      void SetGr1_10(double);
      void SetGr1_11(double);
      void SetGr1_12(double);
      void SetGr1_13(double);
      void SetGr1_14(double);
      void SetGr1_15(double);
      void SetGr1_16(double);
      void SetGr1_17(double);
      void SetGr1_18(double);
      void SetGr1_19(double);
      void SetGr1_2(double);
      void SetGr1_20(double);
      void SetGr1_21(double);
      void SetGr1_22(double);
      void SetGr1_23(double);
      void SetGr1_24(double);
      void SetGr1_25(double);
      void SetGr1_26(double);
      void SetGr1_27(double);
      void SetGr1_28(double);
      void SetGr1_29(double);
      void SetGr1_3(double);
      void SetGr1_30(double);
      void SetGr1_31(double);
      void SetGr1_32(double);
      void SetGr1_33(double);
      void SetGr1_34(double);
      void SetGr1_35(double);
      void SetGr1_36(double);
      void SetGr1_37(double);
      void SetGr1_38(double);
      void SetGr1_39(double);
      void SetGr1_4(double);
      void SetGr1_40(double);
      void SetGr1_41(double);
      void SetGr1_42(double);
      void SetGr1_43(double);
      void SetGr1_44(double);
      void SetGr1_45(double);
      void SetGr1_46(double);
      void SetGr1_47(double);
      void SetGr1_48(double);
      void SetGr1_5(double);
      void SetGr1_6(double);
      void SetGr1_7(double);
      void SetGr1_8(double);
      void SetGr1_9(double);
      void SetGr2of0_0(double);
      void SetGr2of0_1(double);
      void SetGr2of0_10(double);
      void SetGr2of0_11(double);
      void SetGr2of0_12(double);
      void SetGr2of0_13(double);
      void SetGr2of0_14(double);
      void SetGr2of0_15(double);
      void SetGr2of0_16(double);
      void SetGr2of0_17(double);
      void SetGr2of0_18(double);
      void SetGr2of0_19(double);
      void SetGr2of0_2(double);
      void SetGr2of0_20(double);
      void SetGr2of0_21(double);
      void SetGr2of0_22(double);
      void SetGr2of0_23(double);
      void SetGr2of0_24(double);
      void SetGr2of0_25(double);
      void SetGr2of0_26(double);
      void SetGr2of0_27(double);
      void SetGr2of0_28(double);
      void SetGr2of0_29(double);
      void SetGr2of0_3(double);
      void SetGr2of0_30(double);
      void SetGr2of0_31(double);
      void SetGr2of0_32(double);
      void SetGr2of0_33(double);
      void SetGr2of0_34(double);
      void SetGr2of0_35(double);
      void SetGr2of0_36(double);
      void SetGr2of0_37(double);
      void SetGr2of0_38(double);
      void SetGr2of0_39(double);
      void SetGr2of0_4(double);
      void SetGr2of0_40(double);
      void SetGr2of0_41(double);
      void SetGr2of0_42(double);
      void SetGr2of0_43(double);
      void SetGr2of0_44(double);
      void SetGr2of0_45(double);
      void SetGr2of0_46(double);
      void SetGr2of0_47(double);
      void SetGr2of0_48(double);
      void SetGr2of0_5(double);
      void SetGr2of0_6(double);
      void SetGr2of0_7(double);
      void SetGr2of0_8(double);
      void SetGr2of0_9(double);


      static cAutoAddEntry  mTheAuto;
      static cElCompiledFonc *  Alloc();
   private :

      double mLocDGr2Dz0;
      double mLocDGr2Dz1;
      double mLocDGr2Dz10;
      double mLocDGr2Dz11;
      double mLocDGr2Dz12;
      double mLocDGr2Dz13;
      double mLocDGr2Dz14;
      double mLocDGr2Dz15;
      double mLocDGr2Dz16;
      double mLocDGr2Dz17;
      double mLocDGr2Dz18;
      double mLocDGr2Dz19;
      double mLocDGr2Dz2;
      double mLocDGr2Dz20;
      double mLocDGr2Dz21;
      double mLocDGr2Dz22;
      double mLocDGr2Dz23;
      double mLocDGr2Dz24;
      double mLocDGr2Dz25;
      double mLocDGr2Dz26;
      double mLocDGr2Dz27;
      double mLocDGr2Dz28;
      double mLocDGr2Dz29;
      double mLocDGr2Dz3;
      double mLocDGr2Dz30;
      double mLocDGr2Dz31;
      double mLocDGr2Dz32;
      double mLocDGr2Dz33;
      double mLocDGr2Dz34;
      double mLocDGr2Dz35;
      double mLocDGr2Dz36;
      double mLocDGr2Dz37;
      double mLocDGr2Dz38;
      double mLocDGr2Dz39;
      double mLocDGr2Dz4;
      double mLocDGr2Dz40;
      double mLocDGr2Dz41;
      double mLocDGr2Dz42;
      double mLocDGr2Dz43;
      double mLocDGr2Dz44;
      double mLocDGr2Dz45;
      double mLocDGr2Dz46;
      double mLocDGr2Dz47;
      double mLocDGr2Dz48;
      double mLocDGr2Dz5;
      double mLocDGr2Dz6;
      double mLocDGr2Dz7;
      double mLocDGr2Dz8;
      double mLocDGr2Dz9;
      double mLocGr1_0;
      double mLocGr1_1;
      double mLocGr1_10;
      double mLocGr1_11;
      double mLocGr1_12;
      double mLocGr1_13;
      double mLocGr1_14;
      double mLocGr1_15;
      double mLocGr1_16;
      double mLocGr1_17;
      double mLocGr1_18;
      double mLocGr1_19;
      double mLocGr1_2;
      double mLocGr1_20;
      double mLocGr1_21;
      double mLocGr1_22;
      double mLocGr1_23;
      double mLocGr1_24;
      double mLocGr1_25;
      double mLocGr1_26;
      double mLocGr1_27;
      double mLocGr1_28;
      double mLocGr1_29;
      double mLocGr1_3;
      double mLocGr1_30;
      double mLocGr1_31;
      double mLocGr1_32;
      double mLocGr1_33;
      double mLocGr1_34;
      double mLocGr1_35;
      double mLocGr1_36;
      double mLocGr1_37;
      double mLocGr1_38;
      double mLocGr1_39;
      double mLocGr1_4;
      double mLocGr1_40;
      double mLocGr1_41;
      double mLocGr1_42;
      double mLocGr1_43;
      double mLocGr1_44;
      double mLocGr1_45;
      double mLocGr1_46;
      double mLocGr1_47;
      double mLocGr1_48;
      double mLocGr1_5;
      double mLocGr1_6;
      double mLocGr1_7;
      double mLocGr1_8;
      double mLocGr1_9;
      double mLocGr2of0_0;
      double mLocGr2of0_1;
      double mLocGr2of0_10;
      double mLocGr2of0_11;
      double mLocGr2of0_12;
      double mLocGr2of0_13;
      double mLocGr2of0_14;
      double mLocGr2of0_15;
      double mLocGr2of0_16;
      double mLocGr2of0_17;
      double mLocGr2of0_18;
      double mLocGr2of0_19;
      double mLocGr2of0_2;
      double mLocGr2of0_20;
      double mLocGr2of0_21;
      double mLocGr2of0_22;
      double mLocGr2of0_23;
      double mLocGr2of0_24;
      double mLocGr2of0_25;
      double mLocGr2of0_26;
      double mLocGr2of0_27;
      double mLocGr2of0_28;
      double mLocGr2of0_29;
      double mLocGr2of0_3;
      double mLocGr2of0_30;
      double mLocGr2of0_31;
      double mLocGr2of0_32;
      double mLocGr2of0_33;
      double mLocGr2of0_34;
      double mLocGr2of0_35;
      double mLocGr2of0_36;
      double mLocGr2of0_37;
      double mLocGr2of0_38;
      double mLocGr2of0_39;
      double mLocGr2of0_4;
      double mLocGr2of0_40;
      double mLocGr2of0_41;
      double mLocGr2of0_42;
      double mLocGr2of0_43;
      double mLocGr2of0_44;
      double mLocGr2of0_45;
      double mLocGr2of0_46;
      double mLocGr2of0_47;
      double mLocGr2of0_48;
      double mLocGr2of0_5;
      double mLocGr2of0_6;
      double mLocGr2of0_7;
      double mLocGr2of0_8;
      double mLocGr2of0_9;
};
#endif // _cEqCorrelGrid_49_Im2Var_h_

/*Footer-MicMac-eLiSe-25/06/2007

Ce logiciel est un programme informatique servant à la mise en
correspondances d'images pour la reconstruction du relief.

Ce logiciel est régi par la licence CeCILL-B soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-B telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL-B, et que vous en avez accepté les
termes.
Footer-MicMac-eLiSe-25/06/2007*/
