function __fish_using_command
  set cmd (commandline -opc)

  # number of params supplied
  set -l arg_count (count $cmd)

  if [ (count $cmd) -lt (count $argv) ]
    return 1
  end

  if [ (count $argv) -eq 1 ]
    if [ (count $cmd) -eq 1 ]
        return 0
    end
    return 1
  end

  # browse required params
  for i in (seq (count $argv))
      if [ $cmd[$i] != $argv[$i] ]
          return 1
      end
  end

  return 0

end


complete -c mm3d -n "__fish_using_command mm3d" -f -a "AllDev" -d "Force development of all tif/xif file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Ann" -d "matches points of interest of two images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "AperiCloud" -d "Visualization of camera in ply file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Apero" -d "Compute external and internal orientations"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Apero2Meshlab" -d "Convert Orientation from Apero-Micmac workflow to a meshlab-compatible format"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Apero2NVM" -d "Matthieu"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Apero2PMVS" -d "Convert Orientation from Apero-Micmac workflow to PMVS format"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "AperoChImSecMM" -d "Select secondary images for MicMac"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Arsenic" -d "IN DEV : Radiometric equalization from tie points"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Aspro" -d "Init External orientation of calibrated camera from GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "BAR" -d "Bascule robutse"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Bascule" -d "Generate orientations coherent with some physical information on the scene"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "BatchFDC" -d "Tool for batching a set of commands"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Blinis" -d "Block Initialisation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "C3DC" -d "Automatic Matching from Culture 3D Cloud project"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CalibFinale" -d "Compute Final Radial distortion model"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CalibInit" -d "Compute Initial Radial distortion model"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Campari" -d "Interface to Apero, for compensation of heterogeneous measures"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CASA" -d "Analytic Surface Estimation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CatImSaisie" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CenterBascule" -d "Relative to absolute using embedded GPS"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ChantierClip" -d "Clip Chantier"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CheckDependencies" -d "check dependencies to third-party tools"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ChgSysCo" -d "Change coordinate system of orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CleanPatByOri" -d "Clean a pattern of image by Ori-XXX folder"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ClipIm" -d "Clip Chantier"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CmpCalib" -d "Compare two calibrations"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CmpIm" -d "Basic tool for images comparison"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CmpOri" -d "Compare two sets of orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "cod" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CoherEpip" -d "Test coherence between conjugate epipolar depth-map"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Compens" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ContrastFilter" -d "Some contrast filtering"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Convert2GenBundle" -d "Import RPC or other to MicMac format, for adjustment, matching ..."
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ConvertCalib" -d "Conversion of calibration from one model 2 the other"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ConvertIm" -d "Tool for convertion inside tiff-format"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ConvertPolygone" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "CreateEpip" -d "Create epipolar images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Dequant" -d "Tool for dequantifying an image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Devlop" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Digeo" -d "In development- Will compute tie points"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "DIV" -d "Videos development (require ffmpeg)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Donuts" -d "Cyl to Torus (Donuts like)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Drunk" -d "Images distortion removing tool"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ElDcraw" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ExtractAppui3D" -d "Extract points from a 3D appui points xml file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ExtractMesure2D" -d "Extract points from a 2D measures xml file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "FFTKugelhupf" -d "Version of Kugelhupf using FFT, expecetd faster when it works (if ever ...)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "FieldDep3d" -d "To export results of matching as 3D shifting"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "FusionDepl" -d "Fusion carte de deplacement"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GCPBascule" -d "Relative to absolute using GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GCPConvert" -d "Convert GCP from Txt 2 XML"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GCPCtrl" -d "Control accuracy with GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GCPVisib" -d "Print a list of GCP visibility in images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GenCode" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Genepi" -d "Generate 3D/2d synthetical points from orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GenerateBorderCam" -d "Generate the polygone of image contour undistorded"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Genere_Header_TiffFile" -d "Generate Header for internal tiling format"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "genmail" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GenPairsFile" -d "Generate pairs files between one image and a pattern"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GenXML2Cpp" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GrapheHom" -d "Compute XML-Visibility graph from approximate orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Gri2Bin" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "GrShade" -d "Compute shading from depth image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Homol2GND" -d "Creates fake ground points for aerotriangulation wedge"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "HomolFilterMasq" -d "Tool for filter homologous points according to masq"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "HomolMergePDVUnik" -d "Tool for merge homologous point from unik point of view"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Im2XYZ" -d "tool to transform a 2D point (text file) to their 3D cloud homologous"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ImMire" -d "For generation of some synthetic calibration image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Impaint" -d "Basic Impainting"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ImRandGray" -d "Generate Random Gray Textured Images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Init11P" -d "Init Internal & External from GCP using 11-parameters algo"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "InitOriLinear" -d "Initialize orientation for linear acquisition"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Kugelhupf" -d "Semi-automatic fiducial points determination"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Liquor" -d "Orientation specialized for linear acquisition"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "LumRas" -d "Compute image mixing with raking light"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MakeGrid" -d "Generate orientations in a grid format"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Malt" -d "Simplified matching (interface to MicMac)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MapCmd" -d "Transforms a command working on a single file in a command working on a set of files"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Martini" -d "New orientation initialisation (uncomplete, still in dev...)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MartiniGin" -d "New orientation initialisation (uncomplete, still in dev...)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MasqMaker" -d "Create Mask form image values"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MergeDepthMap" -d "Merging of individual, stackable, depth maps"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MergeHomol" -d "Merge Homol dir"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MergePly" -d "Merge ply files"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MeshProjOnImg" -d "Reproject mesh on image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MICMAC" -d "Computes image matching from oriented images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MICMACSaisieLiaisons" -d "Low level version of SEL, not recommended"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MM1P" -d "Matching One Pair of images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MM2DPosSism" -d "Simplified interface for post 2D post sismic deformation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMByP" -d "Matching By Pair of images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMCalcSzWCor" -d "Compute Image of Size of correlation windows (Atomic tool, for adaptive window in geom image)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMHomCorOri" -d "Tool to compute homologues for correcting orientation in epip matching"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMInitialModel" -d "Initial Model for MicMac"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMMergeCloud" -d "Merging of low resol cloud, in preparation 2 MicMac"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMPyram" -d "Computes pyram for micmac (internal use)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMTestAllAuto" -d "Full automatic version for 1 view point, test mode"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMTestOrient" -d "Tool for testing quality of orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MMXmlXif" -d "Generate Xml from Xif (internal use mainly)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "mmxv" -d "Interface to xv (due to problem in tiff lib)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Morito" -d "Merge set of Orientations with common values"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MpDcraw" -d "Interface to dcraw"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MPDtest" -d "My own test"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "MyRename" -d "File renaming using posix regular expression"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "NewTapas" -d "Replace OldTapas - now same as Tapas"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Nuage2Ply" -d "Convert depth map into point cloud"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "NuageBascule" -d "To Change geometry of depth map"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "OldTapas" -d "Interface to Apero to compute external and internal orientations"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Ori2Xml" -d "Convert historical"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "OriConvert" -d "Convert Orientation from Txt 2 XML"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "OriExport" -d "Export orientation from XML to XML or TXT with specified convention"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "OriRedTieP" -d "Tie points filtering, using Martini results"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PanelIm" -d "Tool for creating a panel of images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Pasta" -d "Compute external calibration and radial basic internal calibration"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PastDevlop" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Pastis" -d "Tie points detection"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PatFromOri" -d "Get pattern of images from Ori folder"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PHO_MI" -d "Filter homologue points from initial orientation to reduce number of observations"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PIMs" -d "Per Image Matchings"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PIMs2Mnt" -d "Generate Mnt from Per Image Matchings"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PIMs2Ply" -d "Generate Ply from Per Image Matchings"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "PointeInitPolyg" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Porto" -d "Generates a global ortho-photo"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Prep4masq" -d "Generates files for making Masks (if SaisieMasq unavailable)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Ratafia" -d "Some stuff to be described later"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "RechCibleDRad" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "RechCibleInit" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "RedTieP" -d "Test tie points filtering"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Reduc2MM" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ReducHom" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "RepLocBascule" -d "Tool to define a local repair without changing the orientation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ReprojImg" -d "Reproject an image into geometry of another"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ReSampFid" -d "Resampling using one fiducial mark"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieAppuisInit" -d "Interactive tool for initial capture of GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieAppuisInitQT" -d "Interactive tool for initial capture of GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieAppuisPredic" -d "Interactive tool for assisted capture of GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieAppuisPredicQT" -d "Interactive tool for assisted capture of GCP"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieBasc" -d "Interactive tool to capture information on the scene"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieBascQT" -d "Interactive tool to capture information on the scene"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieBoxQT" -d "Interactive tool to capture 2D box"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieCyl" -d "Interactive tool to capture information on the scene for cylinders"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieCylQT" -d "Interactive tool to capture information on the scene for cylinders"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieMasq" -d "Interactive tool to capture masq"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisieMasqQT" -d "Interactive tool to capture masq"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SaisiePts" -d "Tool to capture GCP (low level, not recommended)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Sake" -d "Simplified MicMac interface for satellite images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SateLib" -d "Library of satellite images meta-data handling - early work in progress!"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SBGlobBascule" -d "Tool for scene based global bascule"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ScaleIm" -d "Tool for image scaling"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ScaleNuage" -d "Tool for scaling internal representation of point cloud"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Schnaps" -d "Reduction of homologue points in image geometry"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "ScriptCalib" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SEL" -d "Tool to visualize tie points"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SetExif" -d "Modification of exif file (requires exiv2)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SetGpsExif" -d "Add GPS infos in images exif meta-data (requires exiv2)"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Sift" -d "Tool for extracting points of interest using"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SimplePredict" -d "Project ground points on oriented cameras"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SMDM" -d "Simplified Merging of individual, stackable, depth maps"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SplitMPO" -d "tool to develop MPO stereo format in pair of images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "StackFlatField" -d "Basic Flat Field estimation by image stacking"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "StatIm" -d "Tool for basic stat on an image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SupMntIm" -d "Tool for superposition of Mnt Im & level curve"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "SysCoordPolyn" -d "Tool for creating a polynomial coordinate system from a set of known pair of coordinate"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Tapas" -d "NEW version !! Compatible . Call OldTapas if problem specific to this version"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Tapioca" -d "Interface to Pastis for tie point detection and matching"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Tarama" -d "Compute a rectified image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Tawny" -d "Interface to Porto to generate ortho-image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Tequila" -d "Texture mesh"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestBundleInter" -d "Block Initialisation"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestCam" -d "Test camera orientation convention"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestChantier" -d "Test global acquisition"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestCmds" -d "Test MM3D commands on micmac_data sets"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestDistM2C" -d "Basic Test for problematic camera"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestKey" -d "Test Keys for Sets and Assoc"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestLib" -d "To call the program illustrating the library"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestMTD" -d "Test meta data of image"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestNameCalib" -d "Test Name of calibration"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestPbRPC" -d "Test possible Problems on RPC"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TestRegEx" -d "Test regular expression"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TiePAll" -d "matches points of interest of two images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TiePByMesh" -d "Raffiner pts homologue par mesh"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TiePLine" -d "matches points of interest of two images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TiePMS" -d "matches points of interest of two images"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TifDev" -d "Develop raw-jpg-tif, in suitable tiff file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "tiff_info" -d "Tool for giving information about a tiff file"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TiPunch" -d "Compute mesh"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "to8Bits" -d "Tool for converting 16 or 32 bit image in a 8 bit image."
complete -c mm3d -n "__fish_using_command mm3d" -f -a "TripleSec" -d "Test Non Regression"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Undist" -d "Tool for removing images distortion"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "vic" -d "Do some stuff"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Vino" -d "Image Viewer"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "VisuRedHom" -d "Create a visualisation of residual on tie points"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Vodka" -d "IN DEV : Compute the vignette correction parameters from tie points"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "VV" -d "A very simplified tool for 3D model of visage out of video, just for fun"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "XifGps2Txt" -d "Export embedded EXIF GPS data 2 Txt"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "XifGps2Xml" -d "Create MicMac-Xml struct from GPS embedded in EXIF"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "XLib" -d "Xeres Lib - early work in progress!"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "XYZ2Im" -d "tool to transform a 3D point (text file) to their 2D proj in cam or cloud"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "Zlimit" -d "Crop Depth image (or DEM) in Z"
complete -c mm3d -n "__fish_using_command mm3d" -f -a "help" -d "Prints this message or the help of the given subcommand(s)"
complete -c mm3d -n "__fish_using_command mm3d AllDev" -l 8BGR -d "Generate 8-bits gray images, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d AllDev" -l 16BGr -d "Generate 16-bits gray images, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d AllDev" -l 8BCoul -d "Generate 8-bits coul images, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d AllDev" -l XmlXiff -d "Generate Xml Xif file, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l ExpTxt -d "Point in txt format ? (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l Out -d "Result (Def=AperiCloud.ply) (string)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l Bin -d "Ply in binary mode (Def=true) (INT)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l RGB -d "Use RGB image to texturate points (Def=true) (INT)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l SeuilEc -d "Max residual (Def=10) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l LimBsH -d "Limit ratio base to height (Def=1e-2) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l WithPoints -d "Do we add point cloud? (Def=true)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l CalPerIm -d "If a calibration per image was used (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l Focs -d "Interval of Focal (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l WithCam -d "With Camera (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l StepIm -d "If image in camera are wanted, indicate reduction factor (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l ColCadre -d "Col of camera rect Def= 255 0 0 (Red), R<0  if none (Pt3di)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l ColRay -d "Col of camera rect Def=  0 255 0 (Green), R<0 if none (Pt3di)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l SH -d "Set of Hom, Def=||, give MasqFiltered for result of HomolFilterMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l KeyName -d "Key to compute printed string (Def contain only digit, NONE if unused) (string)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l ProfCam -d "Depth of pyramid representing camera (Def=0.3) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l NameBundle -d "Name of input GCP to add bundle intersection schema (string)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l RabDrBundle -d "Lenght to add in budle drawing (Def=0.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperiCloud" -l GCPCtrl -d "[GCPTerr.xml,GCPIm.xml,Scale]-> true 3D coordinates+image observations+residual vector scaling factor (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Apero2Meshlab" -l UnDist -d "Undistort images using Drunk (bool)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l Nom -d "NVM file name (string)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l Out -d "Output folder (end with /) (string)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l ExpTxt -d "Point in txt format ? (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l ExpApeCloud -d "Exporte Ply? (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l ExpTiePt -d "Export list of Tie Points uncorrected of the distortion ?(Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Apero2NVM" -l KpImCen -d "Dont add a little rotation for pass from Image Centre to PP ?(To be right fix LibPP=0 in tapas before)(Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l ExpTxt -d "Use tie points in text format (def = false, use dat format) (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l Out -d "Output destination (Def= same as Orientation-parameter) (string)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l CalPerIm -d "If a calibration per image was used (Def=False) (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l PatExp -d "Pattern to limit export (Def=.* , i.e. all are exported) (string)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l Focs -d "Interval of Focal (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l PenPerIm -d "Penality per image, to limite size, def = 0.3 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l TetaOpt -d "Optimal angle of stereoscopy, in radian, def=0.17 (+or- 10 degree) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l Masq3D -d "Masq3D for tie points selection (string)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l VecDep -d "Fixed Vec of deplacement (adapted to video like acquisition)  (vector<int>)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l OnlyVecDep -d "Only vec dep (internal purpose)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d AperoChImSecMM" -l ExpImSec -d "Export Im Sec (Def= true)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l Out -d "Output folder (end with /) and/or prefix (end with another char) (string)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l InVig -d "Input vignette folder (for example : Vignette/ ) (string)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l ResolModel -d "Resol of input model (Def=16) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l TPA -d "Tie Point Accuracy (Higher is better, lower gives more points Def=16) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l NbIte -d "Number of iteration of the process (default=5) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Arsenic" -l ThreshDisp -d "Disparity threshold between the tie points (Def=1.4 for 40%) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d BAR" -l NbTir -d "Nombre de tirage du Ransac (INT)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l ImPl -d "  * [Name=ImPl] vector<std::string (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l ExpTxt -d "  * [Name=ExpTxt] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l PostPlan -d "  * [Name=PostPlan] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l AllPl -d "  * [Name=AllPl] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l UserKeyPlan -d "  * [Name=UserKeyPlan] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l P1Rep -d "P1Rep (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l P2Rep -d "P2Rep (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l AxeRep -d "  * [Name=AxeRep] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l ImRep -d "  * [Name=ImRep] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l Teta -d "Angle (degree) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l MesureIm -d "Image measure file (string)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l OrthoCyl -d "Generate a local repair of orthocyl mode (bool)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l DistFS -d "Distance between to fix scale, if not given no scaling (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l Norm -d "Target normal for the plane (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l SNorm -d "|Symbolic Normal| (must be X, Y or Z) (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Bascule" -l LimBsH -d "Limit ratio base to high (Def=1e-2) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d BatchFDC" -l File -d "  * [Name=File] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d BatchFDC" -l Exe -d "  * [Name=Exe] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l Masq3D -d "3D masq for point selection (string)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l Out -d "final result (Def=C3DC.ply) (string)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l SzNorm -d "Sz of param for normal evaluation (<=0 if none, Def=2 means 5x5)  (INT)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l PlyCoul -d "Colour in ply ? (Def = true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l Tuning -d "Will disappear one day ... (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l Purge -d "Purge result, (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l DownScale -d "DownScale of Final result, Def depends on mode (REAL)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l ZoomF -d "Zoom final, Def depends on mode (INT)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l UseGpu -d "Use cuda (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l DefCor -d "Def correlation, context depend (REAL)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l ZReg -d "Regularisation, context depend (REAL)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l ExpTxt -d "Use txt tie points for determining image pairs (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l FilePair -d "Explicit pairs of images (as in Tapioca) (string)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l DebugMMByP -d "Debug MMByPair ... (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l Bin -d "Generate Binary or Ascii (Def=true, Binary) (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l ExpImSec -d "Export Images Secondair, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d C3DC" -l OffsetPly -d "Ply offset to overcome 32 bits problem (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l GCP -d "[GrMes.xml,GrUncertainty,ImMes.xml,ImUnc] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l EmGPS -d "Embedded GPS [Gps-Dir,GpsUnc, ?GpsAlti?], GpsAlti if != Plani (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l GpsLa -d "Gps Lever Arm, in combination with EmGPS (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l SigmaTieP -d "Sigma use for TieP weighting (Def=1) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l FactElimTieP -d "Fact elimination of tie point (prop to SigmaTieP, Def=5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l CPI1 -d "Calib Per Im, Firt time (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l CPI2 -d "Calib Per Im, After first time, reUsing Calib Per Im As input (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l FocFree -d "Foc Free (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l PPFree -d "Principal Point Free (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l AffineFree -d "Affine Parameter (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l AllFree -d "Affine Parameter (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l DetGCP -d "Detail on GCP (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l Visc -d "Viscosity in Levenberg-Marquardt like resolution (Def=1.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l ExpTxt -d "Export in text format (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l ImMinMax -d "Im max and min to avoid tricky pat (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l DegAdd -d "When specified, degree of additionnal parameter (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l DegFree -d "When specified degree of freedom of parameters generiqs (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l DRMax -d "When specified degree of freedom of radial parameters (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l PoseFigee -d "Does the external orientation of the cameras are frozen or free (Def=false, i.e. camera poses are free) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l FrozenPoses -d "List of frozen poses (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l AcceptGB -d "Accepte new Generik Bundle image, Def=true, set false for perfect backward compatibility (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l MulRTA -d "Rolling Test Appuis , multiplier  (vector<double>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l NameRTA -d "Name for save results of Rolling Test Appuis , Def=SauvRTA.xml (string)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l GCPRTA -d "Internal Use, GCP for RTA  (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l SH -d "Set of Hom, Def=||, give MasqFiltered for result of HomolFilterMasq, set NONE if unused (string)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l NbIterEnd -d "Number of iteration at end, Def = 4 (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l BlocGlob -d "Param for Glob bloc compute [File,SigmaCenter,SigmaRot,?MulFinal,?Export] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l DistBlocGlob -d "Param for Dist Glob bloc compute [File,SigmaDist,?MulFinal,?Export] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l OptBlocG -d "[SigmaTr,SigmaRot] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l BlocTimeRel -d "Param for Time Reliative bloc compute [File,SigmaCenter,SigmaRot,?MulFinal,?Export] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l NbLiais -d "Param for relative weighting for tie points (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l PdsGBRot -d "Weighting of the global rotation constraint (Generic bundle Def=0.002) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l PdsGBId -d "Weighting of the global deformation constraint (Generic bundle Def=0.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l PdsGBIter -d "Weighting of the change of the global rotation constraint between iterations (Generic bundle Def=1e-6) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l ExportSensib -d "Export sensiblity (accuracy) estimator : correlation , varaiance, inverse matrix variance ...  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l UseGaussJ -d "Use GaussJ instead of Cholesky (Def depend of others)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l NormEq -d "Flag for Norm Eq, 1->Sc, 2-Tr, Def=3 (All), tuning purpose  (INT)"
complete -c mm3d -n "__fish_using_command mm3d Campari" -l ContrCalCamCons -d "Constraint on calibration for conseq camera [Key,Simga]  (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d CASA" -l Out -d "Name of result (Def=TheCyl.xml) (string)"
complete -c mm3d -n "__fish_using_command mm3d CASA" -l N2 -d "Name of optional second cloud (string)"
complete -c mm3d -n "__fish_using_command mm3d CASA" -l N3 -d "Name of optional third cloud (string)"
complete -c mm3d -n "__fish_using_command mm3d CASA" -l N4 -d "Name of optional fourth cloud (string)"
complete -c mm3d -n "__fish_using_command mm3d CASA" -l PtsOri -d "[Pts2D.xml,Ori], points and Orientation (used for sizing) to specify surface (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d CenterBascule" -l L1 -d "L1 minimization vs L2; (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CenterBascule" -l CalcV -d "Use speed to estimate time delay (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ChantierClip" -l PrefCliped -d "def= Cliped (string)"
complete -c mm3d -n "__fish_using_command mm3d ChantierClip" -l OriOut -d "Out Orientation, def = input (string)"
complete -c mm3d -n "__fish_using_command mm3d ChantierClip" -l MinSz -d "Min sz to select cliped def = 500 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ChgSysCo" -l FR -d "Force orientation matrix to be pure rotation (Def = true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CleanPatByOri" -l Show -d "Display Pattern to use in cmd line ; Def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d CleanPatByOri" -l Out -d "Output Folder Name for Images NOT will be used (string)"
complete -c mm3d -n "__fish_using_command mm3d ClipIm" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l Teta01 -d "  * [Name=Teta01] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l Teta02 -d "  * [Name=Teta02] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l Teta12 -d "  * [Name=Teta12] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l L1 -d "  * [Name=L1] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l SzW -d "  * [Name=SzW] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l DynV -d "  * [Name=DynV] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l Out -d "Result (Def=Name1_ecarts.txt) (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l DispW -d "Display window (bool)"
complete -c mm3d -n "__fish_using_command mm3d CmpCalib" -l XmlG -d "Generate Xml (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l FileDiff -d "Difference image output file (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l Dyn -d "Dynamic of difference (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l Brd -d "Border to eliminate (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l OkSzDif -d "Process files with different sizes (bool)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l Mul2 -d "Multiplier of file2 (Def 1.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l UseFOM -d "Consider file as DTSM and use XML FileOriMnt (bool)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l ColDif -d "Color file of diff using Red/Blue for sign (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l 16Bit -d "Output file in 16bits (bool)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l XmlG -d "Generate Xml (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpIm" -l Hist -d "Generate histogram stats (bool)"
complete -c mm3d -n "__fish_using_command mm3d CmpOri" -l DirOri2 -d "Orientation 2 (string)"
complete -c mm3d -n "__fish_using_command mm3d CmpOri" -l XmlG -d "Generate Xml (string)"
complete -c mm3d -n "__fish_using_command mm3d cod" -l dc -d "  * [Name=dc] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Dir -d "  * [Name=Dir] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Box -d "  * [Name=Box] Box2d (Box2di)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l SzDec -d "  * [Name=SzDec] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Brd -d "  * [Name=Brd] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l SigP -d "Standard error in pixel (Def=1.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l RegCh -d "Check regularity of DSM (avoid with vegetation) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l FBH -d "Filter on homogeneous border (to avoid sky background) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l YBox -d "  * [Name=YBox] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Regul -d "Regularisation for mask (Def = 0.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l RedM -d "Reduce factor for mask (Def = 2.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l DoMS -d "Do symetric mask (Def  = false) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l DoM -d "Do Mask, def = false (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l UAM -d "Use Auto Mask (def = same as DoM) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Visu -d "  * [Name=Visu] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Zoom -d "  * [Name=Zoom] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l NumPx -d "  * [Name=NumPx] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l NumMasq -d "  * [Name=NumMasq] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Prefix -d "Prefix to result name, Def= AR (string)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Step -d "  * [Name=Step] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l ByE -d "  * [Name=ByE] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l ByP -d "  * [Name=ByP] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l InParal -d "Run command in parallel, Def=true, tuning (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l InternalCalledByP -d "  * [Name=InternalCalledByP] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l InternalPostfixP -d "  * [Name=InternalPostfixP] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l ExpFin -d "For final export (generate distortion indicator) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l BSHReject -d "Value for low Basr to Ratio leading do rejection (Def=0.02) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l FactBSHOk -d "Multiplier so that BSHOk= FactBSHOk * BSHReject (Def=2) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Debug -d "Tuning .... (bool)"
complete -c mm3d -n "__fish_using_command mm3d CoherEpip" -l Masq3D -d "3D masq to enhance filtering (string)"
complete -c mm3d -n "__fish_using_command mm3d ContrastFilter" -l Out -d "Name of Result (string)"
complete -c mm3d -n "__fish_using_command mm3d ContrastFilter" -l Gray -d "Gray image , def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d ContrastFilter" -l Masq -d "Masq of image (string)"
complete -c mm3d -n "__fish_using_command mm3d Convert2GenBundle" -l ChSys -d "Change coordinate file (MicMac XML convention) (string)"
complete -c mm3d -n "__fish_using_command mm3d Convert2GenBundle" -l Degre -d "Degre of polynomial correction (Def=2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Convert2GenBundle" -l Type -d "Type of sensor (see eTypeImporGenBundle) (string)"
complete -c mm3d -n "__fish_using_command mm3d Convert2GenBundle" -l PertubAng -d "Type of sensor (see eTypeImporGenBundle) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l NbXY -d "Number of point of the Grid (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l NbProf -d "Number of depth (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l DRMax -d "Max degree of radial dist (def=depend Output calibration) (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l DegGen -d "Max degree of generik polynom (def=depend Output calibration) (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l PPFree -d "Principal point free (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l CDFree -d "Distorsion center free (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l FocFree -d "Focal free (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ConvertCalib" -l DecFree -d "Decentrik free (def=true when appliable) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Ext -d "  * [Name=Ext] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l SzOut -d "Size out (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l P0 -d "  * [Name=P0] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Type -d "TypeMNT (string)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Col -d "Col (string)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l ReducXY -d "  * [Name=ReducXY] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l ReducX -d "  * [Name=ReducX] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l ReducY -d "  * [Name=ReducY] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Visu -d "  * [Name=Visu] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l SzTifTile -d "  * [Name=SzTifTile] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l SzTileInterne -d "  * [Name=SzTileInterne] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Dyn -d "  * [Name=Dyn] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l KCh -d "  * [Name=KCh] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l NoTile -d "  * [Name=NoTile] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l Permut -d "Permut (vector<int>)"
complete -c mm3d -n "__fish_using_command mm3d ConvertIm" -l F2 -d "  * [Name=F2] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Scale -d "  * [Name=Scale] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Dir -d "directory (Def=current) (string)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Gray -d "One channel gray level image (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l 16B -d "Maintain 16 Bits images if avalaible (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l InParal -d "Compute in parallel (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l DoIm -d "Compute image (def=true !!) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l NameH -d "Extension to compute Hom point in epi coord (def=none) (string)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Degre -d "Degre of polynom to correct epi (def=9) (INT)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l FG -d "Force generik epip even with stenope cam (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Kern -d "Kernel of interpol,0 Bilin, 1 Bicub, other SinC (fix size of apodisation window), Def=5 (INT)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l AttrMasq -d "Atribut for masq toto-> toto_AttrMasq.tif, NONE if unused, Def=Ori (string)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l PostIm -d "Attribut for Im  (string)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l ExpTxt -d "Use txt tie points (Def false, e.g. use dat format) (bool)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Dir1 -d "Direction of Epip one (when Ori=NONE) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l Dir2 -d "Direction of Epip one (when Ori=NONE) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d CreateEpip" -l NbBloc -d "Sz of Bloc (mostly tuning) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l P0 -d "  * [Name=P0] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l Sz -d "  * [Name=Sz] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l SzMaxDalles -d "  * [Name=SzMaxDalles] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l SzRecDalles -d "  * [Name=SzRecDalles] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l TraitSpecCuv -d "  * [Name=TraitSpecCuv] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l Dyn -d "  * [Name=Dyn] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Dequant" -l Offs -d "  * [Name=Offs] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l 8B -d "  * [Name=8B] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l Gray -d "  * [Name=Gray] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l Post -d "  * [Name=Post] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l ConsCol -d "  * [Name=ConsCol] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l NameOut -d "  * [Name=NameOut] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Devlop" -l Split -d "  * [Name=Split] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l Rate -d "Rate final Def=4 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l ParamSzSift -d "Parameter used for sift development, def=-1 (Highest) (INT)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l PatNumber -d "Pat number (reduce number for test) (string)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l DoV2I -d "Do the development of video 2 images, def true iff no image to corresp pattern (bool)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l NDig -d "Nb digit for numbering out images (Def=5) (INT)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l Foc -d "Set focale in xif, def=F35 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l Cam -d "Set Cam in xif (string)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l PercImInit -d "Pecentage of images a priori sele (REAL)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l MinMax -d "Min Max numbers (reduce number for test) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l Tuning -d "as it says ...  (bool)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l TheSzDecoup -d "Sz of a priori split, |expert| level , Def=300  (INT)"
complete -c mm3d -n "__fish_using_command mm3d DIV" -l OverLap -d "Target overlap between images  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Donuts" -l Out -d "Out Put, Def = Tore (string)"
complete -c mm3d -n "__fish_using_command mm3d Donuts" -l Show -d "Show details (bool)"
complete -c mm3d -n "__fish_using_command mm3d Donuts" -l Check -d "Show details (bool)"
complete -c mm3d -n "__fish_using_command mm3d Drunk" -l Out -d "Output folder (end with /) and/or prefix (end with another char) (string)"
complete -c mm3d -n "__fish_using_command mm3d Drunk" -l Talk -d "Turn on-off commentaries (bool)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l TargetHalfSize -d "Target half size in pixels (Def= computed from mask or 150) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l Masq -d "Masq extension for ref image, Def=NONE (means unused), USE OF MASK IS STRONGLY RECOMMANDED !!!! (string)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l SearchIncertitude -d "Def 3*Targ HalfSz (INT)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l SzFFT -d "Sz of initial fft research, power of recomanded, Def=256 or 128 depending other (INT)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l Debug -d "Debugin/Tuning option (bool)"
complete -c mm3d -n "__fish_using_command mm3d FFTKugelhupf" -l ValSim -d "Validation by similitude/affinity (Def size depent, affinity if NbPoint>=6) (bool)"
complete -c mm3d -n "__fish_using_command mm3d FieldDep3d" -l SeuilG -d "Threshold for gradient weighting (REAL)"
complete -c mm3d -n "__fish_using_command mm3d FusionDepl" -l YYYYY -d "XXXXXXX (string)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l L1 -d "L1 minimisation vs L2 (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l CPI -d "when Calib Per Image has to be used (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l ShowU -d "Show unused point (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l ShowD -d "Show details (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l PatNLD -d "Pattern for Non linear deformation, with aerial like geometry (def,unused) (string)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l NLDegX -d "Non Linear monoms for X, when PatNLD, (Def =[1,X,Y]) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l NLDegY -d "Non Linear monoms for Y, when PatNLD, (Def =[1,X,Y]) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l NLDegZ -d "Non Linear monoms for Z, when PatNLD, (Def =[1,X,X2]) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l NLFR -d "Non Linear : Force True Rot (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPBascule" -l NLShow -d "Non Linear : Show Details (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPConvert" -l Out -d "Xml Out File (string)"
complete -c mm3d -n "__fish_using_command mm3d GCPConvert" -l ChSys -d "Change coordinate file (string)"
complete -c mm3d -n "__fish_using_command mm3d GCPConvert" -l MulCo -d "Multiplier of result (for development and testing use) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GCPConvert" -l MulInc -d "Multiplier also incertitude ? (for development and testing use) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPCtrl" -l CPI -d "when Calib Per Image has to be used (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPCtrl" -l ShowU -d "Show unused point (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d GCPVisib" -l Out -d "Output filename (string)"
complete -c mm3d -n "__fish_using_command mm3d Genepi" -l NbXY -d "Number of point of the Grid (INT)"
complete -c mm3d -n "__fish_using_command mm3d Genepi" -l NbProf -d "Number of depth (INT)"
complete -c mm3d -n "__fish_using_command mm3d GenerateBorderCam" -l Int -d "Interior to limit size with bad distorsion, Def=1.0 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GenerateBorderCam" -l Out -d "File for result, Def= Border-Input (string)"
complete -c mm3d -n "__fish_using_command mm3d Genere_Header_TiffFile" -l Out -d "Name of result (string)"
complete -c mm3d -n "__fish_using_command mm3d genmail" -l NbByF -d "  * [Name=NbByF] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d genmail" -l SingleFile -d "If specified, all but this one will considered as black-list files (string)"
complete -c mm3d -n "__fish_using_command mm3d genmail" -l Dests -d "Selected dest (for ex [fr] if only french) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d GenPairsFile" -l Out -d "Output .xml file ; Def=NameCple.xml (string)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l TagC -d "  * [Name=TagC] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l TagOri -d "  * [Name=TagOri] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l AltiSol -d "  * [Name=AltiSol] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l Dist -d "  * [Name=Dist] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l Rab -d "  * [Name=Rab] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l Terr -d "todo (bool)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l Sym -d "todo (bool)"
complete -c mm3d -n "__fish_using_command mm3d GrapheHom" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l FileCol -d "Color file (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Visu -d "  * [Name=Visu] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l P0 -d "  * [Name=P0] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Sz -d "  * [Name=Sz] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l FZ -d "  * [Name=FZ] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l DynMed -d "  * [Name=DynMed] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Anisotropie -d "  * [Name=Anisotropie] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l NbDir -d "  * [Name=NbDir] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Brd -d "  * [Name=Brd] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l TypeMnt -d "Type (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l TypeShade -d "Type (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Dequant -d "  * [Name=Dequant] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l HypsoDyn -d "  * [Name=HypsoDyn] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l HypsoSat -d "  * [Name=HypsoSat] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l SzMaxDalles -d "  * [Name=SzMaxDalles] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l SzRecDalles -d "  * [Name=SzRecDalles] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l ModeOmbre -d "in (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Mask -d "Mask file (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l DericheFact -d "  * [Name=DericheFact] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l NbIterF -d "  * [Name=NbIterF] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l FactExp -d "  * [Name=FactExp] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Dyn -d "  * [Name=Dyn] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l PdsF -d "[CielVu,Local,Grad,Med] (vector<double>)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l ModeColor -d "Color mode (string)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l NbMed -d "  * [Name=NbMed] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l NbIterMed -d "  * [Name=NbIterMed] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l TetaH -d "  * [Name=TetaH] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d GrShade" -l Azimut -d "  * [Name=Azimut] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Homol2GND" -l SH -d "Input Homol directory suffix (without |Homol|) (string)"
complete -c mm3d -n "__fish_using_command mm3d Homol2GND" -l nbPts -d "Number of out points (default=4) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Homol2GND" -l out -d "out filename base (defaut |homol2gnd_out|) (string)"
complete -c mm3d -n "__fish_using_command mm3d Homol2GND" -l ptsName -d "fake points basename (defaut |fakePt|) (string)"
complete -c mm3d -n "__fish_using_command mm3d Homol2GND" -l ExpTxt -d "Ascii format for in and out, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l PostPlan -d "Post to plan, Def : toto ->toto_Masq.tif like with SaisieMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l GlobalMasq -d "Global Masq to add to all image (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l KeyCalculMasq -d "For tuning masq per image (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l KeyEquivNoMasq -d "When given if KENM(i1)==KENM(i2), don't masq (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l Resol -d "Sub Resolution for masq storing, Def=10 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l ANM -d "Accept no mask, def = true if MasqGlob and false else (bool)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l ExpTxt -d "Ascii format for in and out, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l PostIn -d "Post for Input dir Hom, Def= (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l PostOut -d "Post for Output dir Hom, Def=MasqFiltered (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l OriMasq3D -d "Orientation for Masq 3D (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l Masq3D -d "File of Masq3D, Def=AperiCloud_ (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l SelecTer -d "[Per,Prop] Period of tiling on ground selection, Prop=proporion of selected (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d HomolFilterMasq" -l DistId -d "Supress pair such that d(P1,P2) < DistId, def unused (REAL)"
complete -c mm3d -n "__fish_using_command mm3d HomolMergePDVUnik" -l PostIn -d "Post for Input dir Hom, Def= (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolMergePDVUnik" -l PostOut -d "Post for Output dir Hom, Def=MasqFusion (string)"
complete -c mm3d -n "__fish_using_command mm3d HomolMergePDVUnik" -l ExpTxt -d "Ascii format for in and out, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d HomolMergePDVUnik" -l DirN -d "Supplementary dirs 2 merge (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Im2XYZ" -l FilterInput -d "To generate a file of input superposable to output (string)"
complete -c mm3d -n "__fish_using_command mm3d Im2XYZ" -l PointIsImRef -d "Point must be corrected from cloud resolution def = true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Im2XYZ" -l InputImWithZ -d "Input Im point with Z (for Im2XYZ) def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d ImMire" -l Sz -d "Image size, def =[1600,1000] (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d ImMire" -l Out -d "Result (Def depend of Mode) (string)"
complete -c mm3d -n "__fish_using_command mm3d ImMire" -l DoC -d "Add Circle (bool)"
complete -c mm3d -n "__fish_using_command mm3d Impaint" -l Out -d "Name of Result (string)"
complete -c mm3d -n "__fish_using_command mm3d Impaint" -l 2Fill -d "Masq of point 2 fill, def = all (string)"
complete -c mm3d -n "__fish_using_command mm3d ImRandGray" -l VRand -d "Vector of noise [Sz1,Pds1,Sz2,Pds2, ...] (vector<double>)"
complete -c mm3d -n "__fish_using_command mm3d ImRandGray" -l InitR -d "Init Random at each run  (bool)"
complete -c mm3d -n "__fish_using_command mm3d ImRandGray" -l MacroIm -d "Deterministic Macro Image (Def=None) (string)"
complete -c mm3d -n "__fish_using_command mm3d ImRandGray" -l PdsMI -d "Pds of Macro Image when used (Def=1) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Init11P" -l FM -d "Fraser Mode, use all affine parmeters (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Init11P" -l Filter -d "Filter for Image (Def=.*) (string)"
complete -c mm3d -n "__fish_using_command mm3d InitOriLinear" -l PatTurn -d "Vector of images when the serie change acquisition direction pose1,pose2... (string)"
complete -c mm3d -n "__fish_using_command mm3d InitOriLinear" -l PatAngle -d "Vector of turn angle apha1,alpha2,... (string)"
complete -c mm3d -n "__fish_using_command mm3d InitOriLinear" -l WithIdent -d "Initialize with orientation identique (default = false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d InitOriLinear" -l Axe -d "Which axe to calcul rotation about (string)"
complete -c mm3d -n "__fish_using_command mm3d InitOriLinear" -l Plan -d "Force using vector [0,0,1] to initialize (garantie all poses will be in a same plan) - (default = false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Kugelhupf" -l TargetHalfSize -d "Target half size in pixels (Def=64) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Kugelhupf" -l SearchIncertitude -d "Search incertitude in pixels (Def=5) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Kugelhupf" -l SearchStep -d "Search step in pixels (Def=0.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Kugelhupf" -l Threshold -d "Limit to accept a correlation (Def=0.90) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Liquor" -l SzInit -d "Sz of initial interval (Def=50) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Liquor" -l OverLap -d "Prop overlap (Def=0.1)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MakeGrid" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Master -d " Master image must exist iff Mode=GeomImage, AUTO for Using result of AperoChImSecMM (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l SzW -d "Correlation Window Size (1 means 3x3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l CorMS -d "New Multi Scale correlation option, def=false, available in image geometry (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ForDeform -d "Set paramaters when ortho are used for deformation (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l UseGpu -d "Use Cuda acceleration, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Regul -d "Regularization factor (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DirMEC -d "Subdirectory where the results will be stored (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DirOF -d "Subdirectory for ortho (def in Ortho- (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l UseTA -d "Use TA as Masq when it exists (Def is true) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ZoomF -d "Final zoom, (Def 2 in ortho,1 in MNE) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ZoomI -d "Initial Zoom, (Def depends on number of images) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ZPas -d "Quantification step in equivalent pixel (def=0.4) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Exe -d "Execute command (Def is true !!) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Repere -d "Local system of coordinates (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l NbVI -d "Number of Visible Images required (Def = 3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l HrOr -d "Compute High Resolution Ortho (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l LrOr -d "Compute Low Resolution Ortho (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DirTA -d "Directory of TA (for mask) (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Purge -d "Purge the directory of Results before compute (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DoMEC -d "Do the Matching (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DoOrtho -d "Do the Ortho (Def=mDoMEC) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l UnAnam -d "Compute the un-anamorphosed DTM and ortho (Def context dependent) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l 2Ortho -d "Do both anamorphosed ans un-anamorphosed ortho (when applyable)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ZInc -d "Incertitude on Z (in proportion of average depth, def=0.3)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l DefCor -d "Default Correlation in un correlated pixels (Def=0.2)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l CostTrans -d "Cost to change from correlation to uncorrelation (Def=2.0)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Etape0 -d "First Step (Def=1)  (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l AffineLast -d "Affine Last Etape with Step Z/2 (Def=true)  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ResolOrtho -d "Resolution of ortho, relatively to images (Def=1.0; 0.5 means smaller images, i.e. decrease the resolution)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ImMNT -d "Filter to select images used for matching (Def All, usable with ortho)  (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ImOrtho -d "Filter to select images used for ortho (Def All)  (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ZMoy -d "Average value of Z (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Spherik -d "If true the surface for rectification is a sphere (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l WMI -d "Mininum width of reduced images (to fix ZoomInit) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l MasqIm -d "Masq per Im; Def None; Use |Masq| for standard result of SaisieMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l MasqImGlob -d "Glob Masq per Im : if uses, give full name of masq (for ex toto.tif)  (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l IncMax -d "Maximum incidence of image (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l BoxClip -d "To Clip Computation, normalized image coordinates ([0,0,1,1] means full box) (Box2dr)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l BoxTerrain -d "([Xmin,Ymin,Xmax,Ymax]) (Box2dr)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ResolTerrain -d "Ground Resol (Def automatically computed) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l RRI -d "Ratio Resol Image (f.e. if set to 0.8 and image resol is 2.0, will be computed at 1.6) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l RoundResol -d "Use rounding of resolution (def context dependent,tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l GCC -d "Generate export for Cube Correlation (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l EZA -d "Export Z Absolute (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Equiv -d "Equivalent classes, as a set of pattern, def=None (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l MOri -d "Mode Orientation (GRID or RTO) if not XML frame camera (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l MaxFlow -d "Use MaxFlow(MinCut) instead of 2D ProgDyn (SGM), slower sometime better, Def=false  (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l SzRec -d "Sz of overlap between computation tiles, Def=50; for some rare side effects (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l Masq3D -d "Name of 3D Masq (string)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l NbProc -d "Nb Proc Used (INT)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l PSIBN -d "Penal for Automatic Selection of Images to Best Nadir (Def=-1, dont use) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l InternalNoIncid -d "Internal Use (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l PtDebug -d "Internal Use (Point of debuging) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l ForceZFais -d "Force Z Faisecau evan with stenope camera (bool)"
complete -c mm3d -n "__fish_using_command mm3d Malt" -l VSND -d "Value Special No Data (INT)"
complete -c mm3d -n "__fish_using_command mm3d Martini" -l OriCalib -d "Orientation for calibration  (string)"
complete -c mm3d -n "__fish_using_command mm3d Martini" -l Exe -d "Execute commands, def=true (if false, only print) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Martini" -l SH -d "Prefix Homologue , Def=|| (string)"
complete -c mm3d -n "__fish_using_command mm3d Martini" -l ExtName -d "User's added Prefix , Def=|| (string)"
complete -c mm3d -n "__fish_using_command mm3d Martini" -l ModeNO -d "Mode Def=Std (string)"
complete -c mm3d -n "__fish_using_command mm3d MartiniGin" -l OriCalib -d "Orientation for calibration  (string)"
complete -c mm3d -n "__fish_using_command mm3d MartiniGin" -l Exe -d "Execute commands, def=true (if false, only print) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MartiniGin" -l SH -d "Prefix Homologue , Def=|| (string)"
complete -c mm3d -n "__fish_using_command mm3d MartiniGin" -l ExtName -d "User's added Prefix , Def=|| (string)"
complete -c mm3d -n "__fish_using_command mm3d MartiniGin" -l ModeNO -d "Mode Def=Std (string)"
complete -c mm3d -n "__fish_using_command mm3d MasqMaker" -l MasqSup -d "Supplementary mask (string)"
complete -c mm3d -n "__fish_using_command mm3d MasqMaker" -l SzW -d "SzW for masking (def=0) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MergePly" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d MergePly" -l Bin -d "Generate Binary or Ascii file (Def=true, Binary) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MeshProjOnImg" -l zoomF -d "1 -> sz origin, 0.2 -> 1/5 size - default = 0.2 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MeshProjOnImg" -l oriTri -d "consider orientation of triangle/cam (bool)"
complete -c mm3d -n "__fish_using_command mm3d MeshProjOnImg" -l click -d "true => draw each triangle by each click - default = false (bool)"
complete -c mm3d -n "__fish_using_command mm3d MeshProjOnImg" -l ptsInteret -d "pack pts d'interet - give it with 1 img only (string)"
complete -c mm3d -n "__fish_using_command mm3d MeshProjOnImg" -l SH -d "pack homol - give it with 2 image only (string)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l Exe -d "Execute Commands, else only print them (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l Show -d "Show Commande (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l Zoom0 -d "Zoom Init (Def=64) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l ZoomF -d "Zoom Final (Def=1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l CreateE -d " Create Epipolar (def = true when appliable) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l 2Way -d "Match in 2 Way (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l CMS -d "Multi Scale Correl (Def=ByEpip) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DoMR -d "Do re-entering masq (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l SigmaP -d "Sigma Pixel for coherence (Def=1.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l BoxIm -d "Box of calc in Epip, tuning purpose (Def=All image) (Box2di)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l Purge -d "Purge directory, tuning (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l PurgeAtEnd -d "Purge Final Resul (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l InParal -d "Do it in parallel (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l BascMTD -d "Metadata of file to bascule (Def No Basc) (string)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l RIE -d ",Inverse re-sampling from epipolar (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DoHom -d "Do Hom in epolar (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DegCE -d "Degree of epipolar correction when Qual Orient is not high (Def=4) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l QualOr -d "Quality orient (in High, Average, Low, Def= Low) (string)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DoPly -d "Generate Ply (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l ScalePly -d "Dowsize of generated Ply (Def=4) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DoOMF -d "Do Only Masq Final (tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DCE -d "Debug Create Etpi (tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l HasVeg -d "Has vegetation, Def= false (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l HasSBG -d "Has Sky Background , Def= true (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l Masq3D -d "Masq 3D to filter points (string)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l UseGpu -d "Use cuda (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l DefCor -d "Def cor (Def=0.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l ZReg -d "Regularisation factor (Def=0.05) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM1P" -l ExpTxt -d "Use txt tie points for generating epipolar geometry (Def false, e.g. use dat format) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Masq -d "Mask of focus zone (def=none) (string)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Teta -d "Direction of seism if any (in radian) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Exe -d "Execute command , def=true (tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l SzW -d "Size of window (Def=4, mean 9x9) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Reg -d "Regularization (Def=0.3) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Dequant -d "Dequantify (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l Inc -d "Initial uncertainty (Def=2.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l SsResolOpt -d "Merging factor (Def=4) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l DirMEC -d "Subdirectory where the results will be stored (Def='MEC/') (string)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l PxMoy -d "Px-Moy , Def=(0,0) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d MM2DPosSism" -l ZoomInit -d "Initial Zoom, Def=1 (can be long of Inc>2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Zoom0 -d "Zoom Init, Def=64 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ZoomF -d "Zoom Final, Def=1 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Delaunay -d "Add Delaunay edges in pair to match, Def=true on ground (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l FilePair -d "Add a File containing explicit image pair (as in Tapioca, a <SauvegardeNamedRel> struct ... (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l MMImSec -d "Add pair from AperoChImSecMM,  Def=true in mode Statue (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ImLine -d "Add pair for successive images, based on the numeric value in the image name, Def=true in mode Forest (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ByStrip -d "Pair in same strip, first () : strip, second () : num in strip (or reverse with StripIsFisrt) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l StripIsFisrt -d "If true : first expr is strip, second is num in strip Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l DeltaStrip -d "Delta in same strip (Def=1,apply with mPairByStrip) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Sym -d "Symetrise all pair (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Show -d "Show details (def = false)) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Inc -d "Uncertainty interval for matching (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l TetaStrip -d "If used, cut strip when dir of vector > 45 degree from TetaStrip (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l SMD -d "Skip Matching When Already Done (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Do -d "Step to Do in [Apero-Ch-Im,Pyram,MetaData,Correl,Reech,Fusion,inspect], Def |APMCFR| (i.e. All Step) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ByMM1P -d "Do match using new MM1P, def = true (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ImOfBox -d "Image to define box for MTD (test purpose to limit size of result) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l BoxOfIm -d "Associated to ImOfBox, def = full (Box2di)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ParMMI -d "If true each MM if // (| expert| option, Def=false currently) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l QualOr -d "Quality orient (in High, Average, Low, Def= Low with statue) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l RIEPar -d "Internal use (debug Reech Inv Epip) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l TimesExe -d "Internal use (debug Reech Inv Epip) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l DCE -d "Debug Create Epip (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l DebugMMByP -d "Debug this programm (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l DoOMF -d "Do Only Masq Final (tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l HasVeg -d "Scene contains vegetation (Def=true on Ground) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l HasSBG -d "Scene has sky (or homogeneous) background (Def=false on Ground) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Masters -d "If specified, only pair containing a master will be selected (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Masq3D -d "If specified the 3D masq (string)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l CalPerIm -d "true id Calib per Im were used, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l PenPerIm -d "Penality Per Image in choice im sec (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l Purge -d "Purge unused temporay files (Def=true, may be incomplete during some times) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l UseGpu -d "Use cuda (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l DefCor -d "Def corr (context condepend 0.5 Statue, 0.2 Forest) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ZReg -d "Z Regul (context condepend,  0.05 Statue, 0.02 Forest) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ExpTxt -d "Use txt tie points for determining image pairs and/or computing epipolar geometry (Def false, e.g. use dat format) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMByP" -l ExpImSec -d "Export ImSec def=true (put false if set elsewhere) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMCalcSzWCor" -l P0 -d "Origin (Def=(0,0)) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d MMCalcSzWCor" -l Sz -d "Size (Def full size of tiff file) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d MMCalcSzWCor" -l Wsz -d "Size of window (Def no window) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d MMCalcSzWCor" -l Out -d "Out (string)"
complete -c mm3d -n "__fish_using_command mm3d MMHomCorOri" -l Match -d "Do matching (Def = true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMHomCorOri" -l ZoomF -d "Zoom Final (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l Visu -d "Interactif Visualization (tuning purpose, program will stop at breakpoint) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l DoPly -d "Generate ply ,for tuning purpose (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l Zoom -d "Zoom of computed models (Def=8) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l ReduceExp -d "Down scaling of cloud , XML and ply (Def=3) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l Do2Z -d "Excute a first step at 2*Zoom (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l DoMatch -d "Do |classical| MicMac at end (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l Masq3D -d "3D masq when exist (Def=true) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l ExportEnv -d "Export Max Min surfaces (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l DoPyram -d "Do Pyram (set false when //izing)   (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMInitialModel" -l SzW -d "Correlation Window Size (Def=1 means 3x3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMMergeCloud" -l Key -d "Key Assoc Im->Nuage (string)"
complete -c mm3d -n "__fish_using_command mm3d MMMergeCloud" -l NbCelGraph -d "Nb Cell/Im To limit computation time, def=15 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMMergeCloud" -l PercRecMin -d "Percent of point for graph (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMPyram" -l ImSec -d "Output destination (Def= same as Orientation-parameter) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMTestAllAuto" -l ZoomF -d "Zoom Final, def=2 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l Dir -d "Directory, Def=./ (string)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l Zoom0 -d "Zoom init, pow of 2  in [128,8], Def depend of size (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l ZoomF -d "Zoom init,  pow of 2  in [4,1], Def=2 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l PB -d "Push broom sensor (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l GB -d "Gen Bundle Mode (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l MOri -d "Mode Orientation (GRID or RTO), Mandatory in PB (string)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l ZMoy -d "Average Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l ZInc -d "Incertitude on Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l ShowCom -d "Show MicMac command (tuning purpose) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l ExportDepl -d "Export result as displacement maps (bool)"
complete -c mm3d -n "__fish_using_command mm3d MMTestOrient" -l DirMEC -d "Output directory (Def GeoI-Px/) (string)"
complete -c mm3d -n "__fish_using_command mm3d MMXmlXif" -l toto -d "  * [Name=toto] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Morito" -l WithOutLayer -d "Is robust estimation requires or simply L2 (Def=false, other not supported now) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Morito" -l Dir -d "Global directory, Def=./ (string)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l Exe -d "  * [Name=Exe] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l IC -d "  * [Name=IC] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l Purge -d "  * [Name=Purge] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l Add -d "  * [Name=Add] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l Rev -d "  * [Name=Rev] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l DOIDE -d "  * [Name=DOIDE] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l MkF -d "  * [Name=MkF] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l MkAdd -d "  * [Name=MkAdd] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d MpDcraw" -l IsRelancedByThis -d "  * [Name=IsRelancedByThis] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l Exe -d "  * [Name=Exe] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l Niv -d "  * [Name=Niv] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l F -d "  * [Name=F] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l FD -d "  * [Name=FD] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l AddFoc -d "  * [Name=AddFoc] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l Mod -d "When spcified add Num of Image % Mod  (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l File2M -d "  * [Name=File2M] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l Full -d "  * [Name=Full] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l LastFirst -d "Treat the last image first (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l PrfNum -d "Add a numerical growing prefix, must be diff from 0 (INT)"
complete -c mm3d -n "__fish_using_command mm3d MyRename" -l PatSub -d "  * [Name=PatSub] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l ExpTxt -d "Export in text format (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l Out -d "Directory of Output Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l InCal -d "Directory of Input Internal Orientation (Calibration) (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l InOri -d "Directory of Input External Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l DoC -d "Do Compensation (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l ForCalib -d "Is for calibration (Change def value of LMV and prop diag)? (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l Focs -d "Keep images with focal length inside range [A,B] (A,B in mm) (Def=keep all) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l VitesseInit -d "  * [Name=VitesseInit] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l PPRel -d "Principal point shift (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l Decentre -d "Principal point is shifted (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l PropDiag -d "Hemi-spherik fisheye diameter to diagonal ratio (REAL)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l SauvAutom -d "Save intermediary results to, Set NONE if dont want any (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l ImInit -d "Force first image (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l MOI -d "MOI (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l DBF -d "Debug (internal use : DebugPbCondFaisceau=true)  (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l Debug -d "Partial file for debug (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l DegRadMax -d "Max degree of radial, default model dependent (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l DegGen -d "Max degree of general polynome, default model dependent (generally 0 or 1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LibAff -d "Free affine parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LibDec -d "Free decentric parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LibPP -d "Free principal point, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LibCP -d "Free distorsion center, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LibFoc -d "Free focal, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l RapTxt -d "RapTxt (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l LinkPPaPPs -d "Link PPa and PPs (double) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l FrozenPoses -d "List of frozen poses (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l FreeCalibInit -d "Free calibs as soon as created (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l FrozenCalibs -d "List of frozen calibration (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l FreeCalibs -d "List of free calibration (pattern, Def=|.*|) (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l SH -d "Set of Hom, Def=||, give MasqFiltered for result of HomolFilterMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l RefineAll -d "More refinement at all step, safer and more accurate, but slower, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l ImMinMax -d "Image min and max (may avoid tricky pattern ...) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l EcMax -d "Final threshold for residual, def = 5.0  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l EcInit -d "Inital threshold for residual def = [100,5.0]  (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l CondMaxPano -d "Precaution for conditionning with Panoramic images, Def=1e4 (old was 0)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l SinglePos -d "Pattern of single Pos Calib to save [Pose,Calib] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l RankInitF -d "Order of focal initialisation, ref id distotion =2, Def=3  (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l RankInitPP -d "Order of Principal point initialisation, ref id distotion =2, Def=4 (INT)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l RegulDist -d "Parameter fo RegulDist [Val,Grad,Hessian,NbCase,SeuilNb] (vector<double>)"
complete -c mm3d -n "__fish_using_command mm3d NewTapas" -l MulLVM -d "Multipier Levenberg Markard (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Sz -d "Sz (to crop) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l P0 -d "Origin (to crop) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Out -d "Name of result (default toto.xml => toto.ply) (string)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Scale -d "Do change the scale of result (def=1, 2 mean smaller) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Attr -d "Image to colour the point, or [R,G,B] when constant colour (string)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Comments -d "Commentary to add in the ply file (Def=None) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Bin -d "Generate Binary or Ascii (Def=1, Binary) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Mask -d "Supplementary mask image (string)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l SeuilMask -d "Theshold for supplementary mask (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Dyn -d "Dynamic of attribute (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l DoPly -d "Do Ply, def = true (INT)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l DoXYZ -d "Do XYZ, export as RGB image where R=X,G=Y,B=Z (INT)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Normale -d "Add normale (Def=false, usable for Poisson) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l NormByC -d "Replace normal (Def=0, 2=optical center 1=point to center vector) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l ExagZ -d "To exagerate the depth, Def=1.0 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l RatioAttrCarte -d "  * [Name=RatioAttrCarte] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Mesh -d "Do mesh (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l 64B -d "To generate 64 Bits ply, Def=false, WARN = do not work properly with meshlab or cloud compare (bool)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l Offs -d "Offset in points to limit 32 Bits accuracy problem (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l NeighMask -d "Mask for neighboors when larger than point selection (for normals computation) (string)"
complete -c mm3d -n "__fish_using_command mm3d Nuage2Ply" -l ForceRGB -d "Force RGB even with gray image (Def=true because of bug in QT) (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l ByP -d "By process in parallel, Def = true (faster and avoid memory overflow) (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l AutoResize -d "Clip input  to minimal size, Def = true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l AutoClipIn -d "Clip result to minimal size (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l BoxIn -d "Box input (Box2di)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l SzDecoup -d "Size of split for parallel (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l InternallCalledByP -d "Internal purpose: dont use (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l InternalATopo -d "Internal purpose: dont use (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l InternallSuplOut -d "Internal purpose: dont use (string)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l ShowCom -d "Show command, def = false (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l Debug -d "Debug ... (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l TileFile -d "Tile for Big File, def= no tiling for file < 4 Giga Byte (INT)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l Paral -d "Do in parallel, tuning purpose, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l SeuilE -d "Threshold for stretching (def = 5.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d NuageBascule" -l SaveImEtrir -d "Save image streching , tuning (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l ExpTxt -d "Export in text format (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l Out -d "Directory of Output Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l InCal -d "Directory of Input Internal Orientation (Calibration) (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l InOri -d "Directory of Input External Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l DoC -d "Do Compensation (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l ForCalib -d "Is for calibration (Change def value of LMV and prop diag)? (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l Focs -d "Keep images with focal length inside range [A,B] (A,B in mm) (Def=keep all) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l VitesseInit -d "  * [Name=VitesseInit] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l PPRel -d "Principal point shift (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l Decentre -d "Principal point is shifted (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l PropDiag -d "Hemi-spherik fisheye diameter to diagonal ratio (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l SauvAutom -d "Save intermediary results to (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l ImInit -d "Force first image (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l MOI -d "MOI (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l DBF -d "Debug (internal use : DebugPbCondFaisceau=true)  (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l Debug -d "Partial file for debug (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l DegRadMax -d "Max degree of radial, default model dependent (INT)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LibAff -d "Free affine parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LibDec -d "Free decentric parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LibPP -d "Free principal point, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LibCP -d "Free distortion center, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LibFoc -d "Free focal, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l RapTxt -d "RapTxt (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l LinkPPaPPs -d "Link PPa and PPs (double) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l FrozenPoses -d "List of frozen poses (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l SH -d "Set of Hom, Def=||, give MasqFiltered for result of HomolFilterMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d OldTapas" -l MulLVM -d "Multiplier Levenber Markard (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Ori2Xml" -l toto -d "todo (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l ChSys -d "Change coordinate file (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Calib -d "External XML calibration file (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l AddCalib -d "Try to add calibration, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l ConvOri -d "Orientation convention (like eConvAngPhotoMGrade ...) (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l PrePost -d "[Prefix,Postfix] to generate name of image from id (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l KN2I -d "Key 2 compute Name Image from Id in file (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l DN -d "Neighbooring distance for Image Graph (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l ImC -d "Image |Center| for computing AltiSol (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l NbImC -d "Number of neighboors around Image |Center| (Def=50) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l RedSizeSC -d "Reduced Size of image to use for Tapioca for AltiSol (Def=1000) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Reexp -d "Reexport as Matrix (internal set up) (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Regul -d "Regularisation cost (Cost of hole), Def=5.0 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l RegNewBr -d "cost of creating a new branch (Def=0.4, prop to Regul) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Reliab -d "Threshold for reliable speed, Def=0.75 (prop to Regul) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l CalcV -d "Compute speed (def = false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Delay -d "Delay to take into account after speed estimate (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l TFC -d "Teta from cap : compute orientation from speed) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l RefOri -d "Ref Orientation (internal purpose) (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l SiftR -d "Resolution of sift point for Tapioca ,when ImC, (Def No Sift) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l SiftLR -d "Low Resolution of sift point for MultisCale ,when ImC (Def no multicale) (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l NameCple -d "Name of XML file to save couples (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Delaunay -d "Add delaunay arc when save couple (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l DelaunayCross -d "Complete delaunay with some crossing trick arc when save couple (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Cpt -d "============ [CptMin,CptMax] for tuning purpose ======= (vector<int>)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l UOC -d "Use Only Center (tuning) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l MTD1 -d "Compute Metadata only for first image (tuning) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Line -d "Nb neighbour in the same line (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l CBF -d "Export calib as a link to existing file (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l AltiSol -d "Average altitude of ground (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l Prof -d "Average Prof of images (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l OffsetXY -d "Offset to substract from X,Y (To avoid possible round off error) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l CalOFC -d "When specified compute initial orientation from centers (in Ori-GenFromC) Ori- (string)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l OkNoIm -d "Do not create error if image does not exist (def = false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriConvert" -l SzW -d "Size for visualisation (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriExport" -l AddF -d "Add format as first line of header, def= false (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriExport" -l ModeExp -d "Mode export, def=WPK (Omega Phi Kapa) (string)"
complete -c mm3d -n "__fish_using_command mm3d OriExport" -l OnlyCenters -d "Export only camera centers, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriExport" -l OnlyAngles -d "Export only camera angles, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l OriCalib -d "Calibration folder if any (string)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l Prec2P -d "Threshold of precision for 2 Points (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l KBox -d "Internal use (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l SzTile -d "Size of Tiles in Pixel Def=2000 (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l DistPMul -d "Typical dist between pmult Def=200.000000 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l MVG -d "Multiplier VonGruber, Def=1.500000 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l Paral -d "Do it paral, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l VerifNM -d "(Internal) Verification of Virtual Name Manager (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l FromRG -d "(Internal) called by ratagia at top level (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l FromRB -d "(Internal) called by ratagia at box level (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l LevelOr -d "(Internal when call by ratafia) level of orientation (INT)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l Debug -d "Debug, tunging purpose (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l DCA -d "Do Complete Arc (Def=ModeIm) (bool)"
complete -c mm3d -n "__fish_using_command mm3d OriRedTieP" -l UseP -d "Use precdente point to avoir redondance, Def=true, only for tuning (bool)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l Border -d "Border between images (INT)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l NbL -d "Number of line (def to have NbLine=NbCol) (INT)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l Res -d "Result, default Panel.tif (string)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l Scale -d "Scale of Image, def=10  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l Fond -d "Background colour (vector<int>)"
complete -c mm3d -n "__fish_using_command mm3d PanelIm" -l Gray -d "Force result to gray image (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pasta" -l ExpTxt -d "  * [Name=ExpTxt] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pasta" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d PastDevlop" -l Sz1 -d "  * [Name=Sz1] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d PastDevlop" -l Sz2 -d "  * [Name=Sz2] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d PastDevlop" -l Coul8B -d "  * [Name=Coul8B] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l Exe -d "  * [Name=Exe] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l IC -d "  * [Name=IC] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l Purge -d "  * [Name=Purge] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l Add -d "  * [Name=Add] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l Rev -d "  * [Name=Rev] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l DOIDE -d "  * [Name=DOIDE] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l MkF -d "  * [Name=MkF] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l MkAdd -d "  * [Name=MkAdd] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d Pastis" -l IsRelancedByThis -d "  * [Name=IsRelancedByThis] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d PatFromOri" -l Show -d "Display Pattern to use in cmd line ; Def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l HomolIn -d "Name of input Homol foler, Homol par default (string)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l ExpTxt -d "Ascii format for in and out, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l HomolOut -d "Output corrected Homologues folder (string)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l Strategie -d "Strategie de filtre les points homols (string)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l Dist -d "Distant to verify reprojection point (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l DistHom -d "Distant to verify triplet (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l PropDiag -d "For fisheye lens (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l CorelThres -d "Threshold for corellation value  [-1 1] (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l SizeVignette -d "Size of Corellation Vignette [default = 5] (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l DispVignette -d "Display imagette before do corellation [defalut=false] (bool)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l By1Img -d "Decide result is good if it's good in 1 of collection 3eme image [defalut=true] (bool)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l TauxGood -d "Decide result is good if it's good in TauxGood% of collection 3eme image [defalut=0.5] (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PHO_MI" -l Autour -d "Search autour for better decide correlation [default= 0 pixels] (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l Masq3D -d "3D masq for point selection (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l Tuning -d "Will disappear one day ... (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l Purge -d "Purge result, (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l ZoomF -d "Zoom final, Def depends on mode (INT)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l UseGpu -d "Use cuda (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l DefCor -d "Def correlation, context depend (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l ZReg -d "Regularisation, context depend (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l ExpTxt -d "Use txt tie points for determining image pairs (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l FilePair -d "Explicit pairs of images (as in Tapioca) (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l DebugMMByP -d "Debug MMByPair ... (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l ExpImSec -d "Export Images Secondair, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l OffsetPly -d "Ply offset to overcome 32 bits problem (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d PIMs" -l SzW -d "Correlation Window Size (Def=1 means 3x3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l DS -d "Downscale, Def=1.0 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l ZReg -d "Regularisation, context depend (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l Repere -d "Repair (Euclid or Cyl) (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l Pat -d "Pattern, def = all existing clouds (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l DoMnt -d " Compute DTM , def=true (use false to return only ortho) (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l DoOrtho -d "Generate ortho photo,  def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l MasqImGlob -d "Global Masq for ortho: if used, give full name of masq (e.g. MasqGlob.tif)  (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l Debug -d "Debug !!! (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l UseTA -d "Use TA as filter when exist (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l RI -d "Resol Im, def=1  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Mnt" -l SeuilE -d "Seuil d'etirement des triangle, Def=5 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Ply" -l DS -d "Dowscale, Def=1.0 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Ply" -l Out -d "Ply File Results (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Ply" -l Pat -d "Pattern for selecting images (Def=All image in files) (string)"
complete -c mm3d -n "__fish_using_command mm3d PIMs2Ply" -l OffsetPly -d "Ply offset to overcome 32 bits problem (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l OriCalib -d "Calibration folder if any (string)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l LevelOR -d "Level Or, 0=None,1=Pair,2=Glob, (Def=1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l NbP -d "Nb Process, def use all (INT)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l RecMax -d "Max overlap acceptable in two parallely processed images (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l ShowP -d "Show Partition (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l SzPixDec -d "Sz of decoupe in pixel (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l TEO -d "Test Execution OriRedTieP () (bool)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l Out -d "Folder dest => Def=-Ratafia (string)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l DistPMul -d "Average dist (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l MVG -d "Multiplier VonGruber, Def=2.000000 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l Paral -d "Do it in parallel (bool)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l DCA -d "Do Complete Arc (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l UseP -d "Use prec to avoid redundancy (Def=true), tuning only (bool)"
complete -c mm3d -n "__fish_using_command mm3d Ratafia" -l ProbaSel -d "tuning only, generate a random selection at the end (REAL)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l NumPointsX -d "Target number of tie-points between 2 images in x axis of image space, def=12 (INT)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l NumPointsY -d "Target number of tie-points between 2 images in y axis of image space, def=12 (INT)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l Adaptive -d "Use adaptive grids, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l SubcommandIndex -d "Internal use (INT)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l ExpSubCom -d "Export the subcommands instead of executing them, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l ExpTxt -d "Export homol point in Ascii, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l SortByNum -d "Sort images by number of tie-points, determining the order in which the subcommands are executed, def=0 (sort by file name) (bool)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l Desc -d "Use descending order in the sorting of images, def=0 (ascending) (bool)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l WeightAccGain -d "Weight of median accuracy with respect to multiplicity (NumPairs) when computing Gain of multi-tie-point, i.e. K in formula Gain=NumPairs*(1/1 + (K*Acc/AccMed)^2) (if K=0 then Gain is NumPairs), def=0.5 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d RedTieP" -l MinNumHomol -d "Minimum number of tie-points for an image pair not to be excluded, def=20 (INT)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l ImpTxt -d "Import in text format(def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l ExpTxt -d "Export in text format(def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l ExtH -d "Extension for homol, like SrRes, def=||) (string)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l NbMinHom -d "Nb Min Pts For Homography Computation def=20 (INT)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l SeuilQual -d "Quality Theshold for homography (Def=20.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ReducHom" -l RatioQualMoy -d "Ratio to validate / average qual (def=4.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d RepLocBascule" -l ExpTxt -d "Are tie points in ascii mode ? (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d RepLocBascule" -l PostPlan -d "Postfix for plane name, (Def=_Masq) (string)"
complete -c mm3d -n "__fish_using_command mm3d RepLocBascule" -l OrthoCyl -d "Is the coordinate system in ortho-cylindric mode? (bool)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l AutoMask -d "AutoMask filename (string)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l DepthRepImage -d "Image to reproject DEM file (xml), def=not used (string)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l KeepGreen -d "Keep original picture green (only for colorization), def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l LutSqrt -d "Use LUT sqrt (only for colorization), def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l Out -d "Output image name (tif), def=Reproj.tif (string)"
complete -c mm3d -n "__fish_using_command mm3d ReprojImg" -l CoulourImgScale -d "CoulourImgScale (int, if color image is bigger than ori to reproject), def=1 (INT)"
complete -c mm3d -n "__fish_using_command mm3d ReSampFid" -l BoxCh -d "Box in Chambre (generally in mm) (Box2dr)"
complete -c mm3d -n "__fish_using_command mm3d ReSampFid" -l Kern -d "Kernel of interpol,0 Bilin, 1 Bicub, other SinC (fix size of apodisation window), Def=5 (INT)"
complete -c mm3d -n "__fish_using_command mm3d ReSampFid" -l AttrMasq -d "Atribut for masq toto-> toto_AttrMasq.tif, NONE if unused, Def=NONE (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l SzW -d "Sz of window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l NbF -d "Nb of sub window (Def depends of number of images with max of 2x2) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l NameAuto -d " Prefix for automatic point creation (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l Pref2Add -d " Prefix to add during import (for bug correction ?) (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l ForceGray -d " Force gray image, def =true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l OriMode -d "Orientation type (GRID) (Def=Std) (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l ZMoy -d "Average Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l ZInc -d "Incertitude on Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInit" -l InputSec -d "PIMs filter used for visibility (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l SzW -d "Sz of window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l NbF -d "Nb of sub window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l NameAuto -d "Prefix for automatic point creation (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l ForceGray -d "Force gray image, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l OriMode -d "Orientation type (GRID) (Def=Std) (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l ZMoy -d "Average Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisInitQT" -l ZInc -d "Incertitude on Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l SzW -d "Size of global window (Def 800 800) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l NbF -d "Number of Sub Window (Def 2 2) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l WBlur -d "Size IN GROUND GEOMETRY of bluring for target (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l Type -d "in [MaxLoc,MinLoc,GeoCube] (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l ForceGray -d "Force gray image, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l OriMode -d "Orientation type (GRID) (Def=Std) (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l ZMoy -d "Average Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l ZInc -d "Incertitude on Z, Mandatory in PB (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l Masq3D -d "3D Masq used for visibility (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l PIMsF -d "PIMs filter used for visibility (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredic" -l InputSec -d "For inmporting Other Inputs (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredicQT" -l SzW -d "Sz of window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredicQT" -l NbF -d "Nb of sub window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredicQT" -l WBlur -d "Size IN GROUND GEOMETRY of bluring for target (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredicQT" -l Type -d "in [MaxLoc,MinLoc,GeoCube] (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieAppuisPredicQT" -l ForceGray -d "Force gray image, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBasc" -l SzW -d "Total size of windows (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBasc" -l NbF -d "Number of Windows (def depend of number of images (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBasc" -l ForceGray -d " Force gray image, def =true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBascQT" -l SzW -d "Total size of windows (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBascQT" -l NbF -d "Number of Windows (def depend of number of images (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBascQT" -l ForceGray -d " Force gray image, def =true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBoxQT" -l SzW -d "* [Name=SzW] integer	: set window width (default=800 (integer	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBoxQT" -l Post -d "* [Name=Post] string	: change postfix output file (default=_Masq (string	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBoxQT" -l Name -d "* [Name=Name] string	: set output filename (default=input+_Masq (string	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieBoxQT" -l Gama -d "* [Name=Gama] REAL	: apply gamma to imag (REAL	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCyl" -l SzW -d "Total size of windows (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCyl" -l NbF -d "Number of Windows (def depend of number of images (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCyl" -l ForceGray -d " Force gray image, def =true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCylQT" -l SzW -d "Total size of windows (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCylQT" -l NbF -d "Number of Windows (def depend of number of images (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieCylQT" -l ForceGray -d " Force gray image, def =true (bool)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasq" -l SzW -d "  * [Name=SzW] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasq" -l Post -d "  * [Name=Post] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasq" -l Name -d "Name of result, default toto->toto_Masq.tif (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasq" -l Gama -d "  * [Name=Gama] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasq" -l Attr -d "  * [Name=Attr] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasqQT" -l SzW -d "* [Name=SzW] Pt2di	: set window size (default=[900,700] (Pt2di	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasqQT" -l Post -d "* [Name=Post] string	: change postfix output file (default=_Masq (string	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasqQT" -l Name -d "* [Name=Name] string	: set output filename (default=input+_Masq (string	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasqQT" -l Gama -d "* [Name=Gama] REAL	: apply gamma to imag (REAL	:)"
complete -c mm3d -n "__fish_using_command mm3d SaisieMasqQT" -l Attr -d "* [Name=Attr] string	: string to add to postfi (string	:)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ZMoy -d "Average value of Z (Def=1000.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ZInc -d "Initial uncertainty on Z (Def=1000.0) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ModeOri -d "Orientation type (GRID or RTO; Def=GRID) (string)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l Mask -d "Mask file (string)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l SzW -d "Correlation window size (Def=2, equiv 5x5) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l DefCor -d "Default Correlation in un correlated pixels (Def=0.2)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ZRegul -d "Regularization factor (Def=0.2 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ZPas -d "Quantification step (Def=0.5) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ZoomF -d "Final zoom (Def=1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l BoxClip -d "Define computation area (Def=[0,0,1,1] means full area) relative to image (Box2dr)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l BoxTer -d "Define computation area [Xmin,Ymin,Xmax,Ymax] relative to ground (Box2dr)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l ResolTerrain -d "Ground Resol (Def automatically computed) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l EZA -d "Export absolute values for Z (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l DirMEC -d "Results subdirectory (Def=MEC-Sake/) (string)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l DirOrtho -d "Orthos subdirectory if OrthoIm (Def=Ortho- (string)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l DoOrthoM -d "Compute the ortho mosaic if OrthoIm (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l NbProc -d "Number of cores used for computation (Def=MMNbProc) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Sake" -l Exe -d "Execute command (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d SBGlobBascule" -l ExpTxt -d "  * [Name=ExpTxt] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d SBGlobBascule" -l PostPlan -d "Set NONE if no plane (string)"
complete -c mm3d -n "__fish_using_command mm3d SBGlobBascule" -l DistFS -d "Distance between Ech1 and Ech2 to fix scale (if not given no scaling) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SBGlobBascule" -l Rep -d "Target coordinate system (Def = ki, ie normal is vertical) (string)"
complete -c mm3d -n "__fish_using_command mm3d SBGlobBascule" -l CPI -d "Calibration Per Image (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l YScale -d "  * [Name=YScale] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Sz -d "  * [Name=Sz] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l P0 -d "  * [Name=P0] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Type -d "Type (u_int1, int1, u_int2, int2, int4, real4, real8) (string)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Mult -d "  * [Name=Mult] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Dilate -d "  * [Name=Dilate] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l DilXY -d "  * [Name=DilXY] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Debug -d "Debug (INT)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Offset -d "  * [Name=Offset] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l Tile -d "  * [Name=Tile] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l FG -d "Force gray (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l F8B -d "Force 8 bits (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d ScaleIm" -l ModMasq -d "Mode Masq => binarize at 0.9999 threshlod  (bool)"
complete -c mm3d -n "__fish_using_command mm3d ScaleNuage" -l Sz -d "  * [Name=Sz] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d ScaleNuage" -l P0 -d "  * [Name=P0] Pt2d (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d ScaleNuage" -l Old -d "For full compatibility, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d ScaleNuage" -l InDirLoc -d "Add input directory to output , def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l HomolIn -d "Input Homol directory suffix (without |Homol|) (string)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l NbWin -d "Minimal homol points in each picture (default: 1000) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l ExeWrite -d "Execute write output homol dir, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l HomolOut -d "Output Homol directory suffix (default: _mini) (string)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l ExpTxt -d "Ascii format for in and out, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l VeryStrict -d "Be very strict with homols (remove any suspect), def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l ShowStats -d "Show Homol points stats before and after filtering, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l PoubelleName -d "Where to write suspicious pictures names, def=|Schnaps_poubelle.txt| (string)"
complete -c mm3d -n "__fish_using_command mm3d Schnaps" -l minPercentCoverage -d "Minimum % of coverage to avoid adding to poubelle, def=30 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l R -d "  * [Name=R] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l RL1 -d "Estimate Homography using L1 mode (bool)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l F -d "  * [Name=F] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l KH -d "In P PB PBR M S NB NT MMD (string)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l KCpl -d "  * [Name=KCpl] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l SzW -d "  * [Name=SzW] Pt2d (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l ModeEpip -d "If mode epip, the y displacement are forced to 0 (bool)"
complete -c mm3d -n "__fish_using_command mm3d SEL" -l SH -d "Homologue extenion for NB/NT mode (string)"
complete -c mm3d -n "__fish_using_command mm3d SetExif" -l F -d "Focal lenght (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SetExif" -l F35 -d "Focal lenght equiv 35mm (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SetExif" -l Cam -d "Camera model (string)"
complete -c mm3d -n "__fish_using_command mm3d SetExif" -l Purge -d "Purge created exiv2 command file (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l GpsVId -d "GPS Version ID ; Def=2.2.0.0 (string)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l LatRef -d "GPS Latitude Ref (string)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l LonRef -d "GPS Longitude Ref (string)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l AltRef -d "GPS Altitude Ref ; Def=0 Above Sea Level (1=Below) (bool)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l TimeStamp -d "GPS Time Stamp ; (In Dev) (string)"
complete -c mm3d -n "__fish_using_command mm3d SetGpsExif" -l Purge -d "Purge .xml & .dmp created files in Tmp-MM-Dir (bool)"
complete -c mm3d -n "__fish_using_command mm3d SimplePredict" -l ExportPolyIGN -d "Export PointeInitIm files for IGN Polygon calibration method (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d SimplePredict" -l PrefixeNomImageSize -d "Size of PrefixeNomImage in param.txt (INT)"
complete -c mm3d -n "__fish_using_command mm3d SMDM" -l TargetGeom -d "Name of Targeted geometry, Def computed by agregation of input (string)"
complete -c mm3d -n "__fish_using_command mm3d SMDM" -l Out -d "Result, Def=Fusion.xml (string)"
complete -c mm3d -n "__fish_using_command mm3d SplitMPO" -l Right -d "Right extension, def=_R (string)"
complete -c mm3d -n "__fish_using_command mm3d SplitMPO" -l Left -d "Left extension, def=_L (string)"
complete -c mm3d -n "__fish_using_command mm3d SplitMPO" -l TG -d "Tiff gray, def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l NbMed -d "  * [Name=NbMed] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l Out -d "Name of result (string)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l SousResAdd -d "  * [Name=SousResAdd] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l NbMedSsRes -d "  * [Name=NbMedSsRes] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l TolMed -d "  * [Name=TolMed] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d StackFlatField" -l ByMoy -d "Average or median (def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d StatIm" -l Sz -d "Size of rectangle (Def=[1,1]) (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l DynGray -d "  * [Name=DynGray] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l OffsetGray -d "  * [Name=OffsetGray] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l GamaGray -d "  * [Name=GamaGray] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l DynCoul -d "Colour dynamic (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l NoVal -d "  * [Name=NoVal] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l Sat -d "  * [Name=Sat] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l ShowSat -d "  * [Name=ShowSat] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l Grad -d "  * [Name=Grad] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l CDN -d "Generate level curve? (REAL)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l CoulCDN -d "Interval between level curves (Pt3dr)"
complete -c mm3d -n "__fish_using_command mm3d SupMntIm" -l Masq -d "Masq of images (string)"
complete -c mm3d -n "__fish_using_command mm3d SysCoordPolyn" -l Test -d "  * [Name=Test] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l ExpTxt -d "Export in text format (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l Out -d "Directory of Output Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l InCal -d "Directory of Input Internal Orientation (Calibration) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l InOri -d "Directory of Input External Orientation (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l DoC -d "Do Compensation (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l ForCalib -d "Is for calibration (Change def value of LMV and prop diag)? (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l Focs -d "Keep images with focal length inside range [A,B] (A,B in mm) (Def=keep all) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l VitesseInit -d "  * [Name=VitesseInit] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l PPRel -d "Principal point shift (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l Decentre -d "Principal point is shifted (Def=false) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l PropDiag -d "Hemi-spherik fisheye diameter to diagonal ratio (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l SauvAutom -d "Save intermediary results to, Set NONE if dont want any (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l ImInit -d "Force first image (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l MOI -d "MOI (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l DBF -d "Debug (internal use : DebugPbCondFaisceau=true)  (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l Debug -d "Partial file for debug (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l DegRadMax -d "Max degree of radial, default model dependent (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l DegGen -d "Max degree of general polynome, default model dependent (generally 0 or 1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LibAff -d "Free affine parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LibDec -d "Free decentric parameter, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LibPP -d "Free principal point, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LibCP -d "Free distorsion center, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LibFoc -d "Free focal, Def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l RapTxt -d "RapTxt (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l LinkPPaPPs -d "Link PPa and PPs (double) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l FrozenPoses -d "List of frozen poses (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l FreeCalibInit -d "Free calibs as soon as created (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l FrozenCalibs -d "List of frozen calibration (pattern) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l FreeCalibs -d "List of free calibration (pattern, Def=|.*|) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l SH -d "Set of Hom, Def=||, give MasqFiltered for result of HomolFilterMasq (string)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l RefineAll -d "More refinement at all step, safer and more accurate, but slower, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l ImMinMax -d "Image min and max (may avoid tricky pattern ...) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l EcMax -d "Final threshold for residual, def = 5.0  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l EcInit -d "Inital threshold for residual def = [100,5.0]  (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l CondMaxPano -d "Precaution for conditionning with Panoramic images, Def=1e4 (old was 0)  (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l SinglePos -d "Pattern of single Pos Calib to save [Pose,Calib] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l RankInitF -d "Order of focal initialisation, ref id distotion =2, Def=3  (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l RankInitPP -d "Order of Principal point initialisation, ref id distotion =2, Def=4 (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l RegulDist -d "Parameter fo RegulDist [Val,Grad,Hessian,NbCase,SeuilNb] (vector<double>)"
complete -c mm3d -n "__fish_using_command mm3d Tapas" -l MulLVM -d "Multipier Levenberg Markard (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l Zoom -d "Resolution, (Def=8, must be pow of 2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l Repere -d "Local coordinate system as created with RepLocBascule (string)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l Out -d "Directory for output (Deg=TA) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l ZMoy -d "Average value of Z (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l KNadir -d "KBest image or Nadir (when exist) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l IncMax -d "Maximum incidence of image (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tarama" -l UnUseAXC -d "Internal use for unanamorphosed ortho (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l RadiomEgal -d "Perform or not radiometric egalization (Def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l DEq -d "Degree of equalization (Def=1) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l DEqXY -d "Degree of equalization, if diff in X and Y (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l AddCste -d "Add unknown constant for equalization (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l DegRap -d "Degree of rappel to initial values, Def = 0 (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l DegRapXY -d "Degree of rappel to initial values, Def = 0 (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l RGP -d "Rappel glob on physically equalized, Def = true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l DynG -d "Global Dynamic (to correct saturation problems) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l ImPrio -d "Pattern of image with high prio, def=.* (string)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l SzV -d "Sz of Window for equalization (Def=1, means 3x3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l CorThr -d "Threshold of correlation to validate homologous (Def 0.7) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l NbPerIm -d "Average number of point per image (Def = 1e4) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l L1F -d "Do L1 Filter on couple, def=true (change when process is blocked) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l SatThresh -d "Threshold determining saturation value (pixel >SatThresh will be ignored) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tawny" -l Out -d "Name of output file (in the folder) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Out -d "Textured mesh name (def=plyName+ _textured.ply) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Bin -d "Write binary ply (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Optim -d "Graph-cut optimization (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Lambda -d "Lambda (def=0.01) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Iter -d "Optimization iteration number (def=2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Filter -d "Remove border faces (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Texture -d "Texture name (def=plyName + _UVtexture.jpg) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Sz -d "Texture max size (def=4096) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Scale -d "Z-buffer downscale factor (def=2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l QUAL -d "jpeg compression quality (def=70) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Angle -d "Threshold angle, in degree, between triangle normal and image viewing direction (def=90) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Mode -d "Mode (def = Pack) (string)"
complete -c mm3d -n "__fish_using_command mm3d Tequila" -l Crit -d "Texture choosing criterion (def = Angle) (string)"
complete -c mm3d -n "__fish_using_command mm3d TestBundleInter" -l Cam3 -d "[Cam3,x3,y3] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l Tag -d "Tag to get cam (string)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l Grid -d "Test Grid Mode (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l Out -d "To Regenerate an orientation file (string)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l ExtP -d "Detail on external parameter (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l TOC -d "Test corners (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestCam" -l TDINV -d "Test Dist Inv (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d TestCmds" -l Data_set -d "Data sets (INT)"
complete -c mm3d -n "__fish_using_command mm3d TestKey" -l Nb -d "Nb Max printed (def=10) (INT)"
complete -c mm3d -n "__fish_using_command mm3d TestKey" -l KeyAssoc -d "Key for association (string)"
complete -c mm3d -n "__fish_using_command mm3d TestNameCalib" -l Nb -d "Name of caib (def=TestNameCalib) (string)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l NbZ -d "Number of Z Layer (INT)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l NbXY -d "Number of XY layers (INT)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l SeuilRP -d "Thresols for dist reproj (REAL)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l SeuilGrad -d "Thresols for grad (REAL)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PrErr -d "Print high residual (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PlyErr -d "Make ply of high residual (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PlySXTer -d "Make ply of sign XTer (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PlySYTer -d "Make ply of sign YTer (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PlySXIm -d "Make ply of sign XIm (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestPbRPC" -l PlySYIm -d "Make ply of sign YIm (bool)"
complete -c mm3d -n "__fish_using_command mm3d TestRegEx" -l DispPat -d "Display Pattern to use in cmd line ; Def=false (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePAll" -l ExpTxt -d "Export files in text format (Def=false means binary) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePAll" -l ByP -d "By process (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePAll" -l PostFix -d "Add postfix in directory (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePAll" -l Detect -d "  * [Name=Detect] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePAll" -l Circ -d "Circular in mode Line (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l disp -d "display (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l corl_glob -d "corellation threshold for imagette global, default = 0.8 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l corl_pt -d "corellation threshold for pt interest, default = 0.9 (REAL)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l method -d "Coor, SubCoor, default=SubCoor (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l SzPtCorr -d "1->3*3,2->5*5 size of cor wind for each pt interet  default=1 (3*3) (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l SzAreaCorr -d "1->3*3,2->5*5 size of zone autour pt interet for search default=5 (11*11) (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l indTri -d "process one triangle (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l assum1er -d "always use 1er pose as img master, default=0 (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l Test -d "Test new method - fix size imagette of triangle (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l aTypeD -d "FAST, DIGEO, HOMOLINIT - default = HOMOLINIT (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l dParam -d "[param1, param2, ..] (selon detector - NO if don't have) (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l HomolOut -d "default = _Filtered (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l useExist -d "use exist homol struct - default = false (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l angleV -d "limit view angle - default = 90 (all triangle is viewable) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d TiePByMesh" -l justFil -d "just do filter. (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePLine" -l ExpTxt -d "Export files in text format (Def=false means binary) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePLine" -l ByP -d "By process (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePLine" -l PostFix -d "Add postfix in directory (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePLine" -l Detect -d "  * [Name=Detect] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePLine" -l Circ -d "Circular in mode Line (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePMS" -l ExpTxt -d "Export files in text format (Def=false means binary) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiePMS" -l ByP -d "By process (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiePMS" -l PostFix -d "Add postfix in directory (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePMS" -l Detect -d "  * [Name=Detect] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d TiePMS" -l Circ -d "Circular in mode Line (bool)"
complete -c mm3d -n "__fish_using_command mm3d TifDev" -l NbChan -d "Nb Channel (INT)"
complete -c mm3d -n "__fish_using_command mm3d TifDev" -l 16B -d "Keep in 16 Bits if possible (bool)"
complete -c mm3d -n "__fish_using_command mm3d TifDev" -l ENC -d "Exig No Compr (bool)"
complete -c mm3d -n "__fish_using_command mm3d tiff_info" -l MaxMin -d "  * [Name=MaxMin] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Pattern -d "Full Name (Dir+Pat) (string)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Out -d "Mesh name (def=plyName+ _mesh.ply) (string)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Bin -d "Write binary ply (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Depth -d "Maximum reconstruction depth for PoissonRecon (def=8) (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Rm -d "Remove intermediary Poisson mesh (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Filter -d "Filter mesh (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Mode -d "C3DC mode (def=Statue) (string)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l Scale -d "Z-buffer downscale factor (def=2) (INT)"
complete -c mm3d -n "__fish_using_command mm3d TiPunch" -l FFB -d "Filter from border (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l EcMin -d "  * [Name=EcMin] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Out -d "  * [Name=Out] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Brd -d "  * [Name=Brd] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l NbIter -d "  * [Name=NbIter] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Dyn -d "  * [Name=Dyn] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Offset -d "  * [Name=Offset] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l NewOffset -d "  * [Name=NewOffset] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Circ -d "  * [Name=Circ] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Coul -d "  * [Name=Coul] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l AdaptMinMax -d "  * [Name=AdaptMinMax] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l AdaptMin -d "  * [Name=AdaptMin] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l IS1 -d "  * [Name=IS1] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l GS1 -d "  * [Name=GS1] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l WS1 -d "  * [Name=WS1] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Type -d "Type (string)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Strip -d "  * [Name=Strip] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Compr -d "  * [Name=Compr] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l TestVals -d "  * [Name=TestVals] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Step -d "  * [Name=Step] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l VisuAff -d "  * [Name=VisuAff] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l P0Crop -d "!!!  crop in rel (between 0 & 1) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l P1Crop -d "!!!  crop in rel (between 0 & 1) (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l CropIsAbs -d " Set to true if crop is not rel  (bool)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l CanTileFile -d "  * [Name=CanTileFile] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l EqHisto -d "  * [Name=EqHisto] IN (INT)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l StepH -d "  * [Name=StepH] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l ForceMax -d "  * [Name=ForceMax] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l ForceMin -d "  * [Name=ForceMin] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l Mask -d "  * [Name=Mask] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l BoucheMask -d "  * [Name=BoucheMask] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l UseSigne -d "  * [Name=UseSigne] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d to8Bits" -l 2XV -d "  * [Name=2XV] boo (bool)"
complete -c mm3d -n "__fish_using_command mm3d TripleSec" -l OutReportXML -d "XML report file (Def=GlobTest.xml) (string)"
complete -c mm3d -n "__fish_using_command mm3d TripleSec" -l OutErrorsXML -d "XML errors file (Def=ErrorsReport.xml) (string)"
complete -c mm3d -n "__fish_using_command mm3d TripleSec" -l InRefDir -d "Input Reference Directory (Def=TNR-Ref-Name) (string)"
complete -c mm3d -n "__fish_using_command mm3d TripleSec" -l Purge -d "Purge Exe directory (Def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Undist" -l UseMkF -d "Can use make file for parallelization, def=true (bool)"
complete -c mm3d -n "__fish_using_command mm3d Undist" -l XX@ABB_InternalCall -d "Internal use (bool)"
complete -c mm3d -n "__fish_using_command mm3d vic" -l editor -d "  * [Name=editor] strin (string)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l SzW -d "size of window (Pt2di)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l Bilin -d "Bilinear mode (bool)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l SZG -d "Speed Zoom Grab (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l SZM -d "Speed Zoom Molette (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l WS -d "Width Scroller (INT)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l Dyn -d "Max Min value for dynamic (Pt2dr)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l Gray -d "Force gray images (def=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l IsMnt -d "Display altitude if true, def exist of Mnt Meta data (bool)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l FileMnt -d "Default toto.tif -> toto.xml (string)"
complete -c mm3d -n "__fish_using_command mm3d Vino" -l ClipCh -d "Param 4 Clip Chantier [PatClip,OriClip] (vector<std::string>)"
complete -c mm3d -n "__fish_using_command mm3d VisuRedHom" -l SH -d "Set Homologue (string)"
complete -c mm3d -n "__fish_using_command mm3d Vodka" -l Out -d "Output folder (Defaut=Vignette) (string)"
complete -c mm3d -n "__fish_using_command mm3d Vodka" -l InTxt -d "True if homologous points have been exported in txt (Defaut=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d Vodka" -l InCal -d "Name of folder with vignette calibration tif file (if previously computed) (string)"
complete -c mm3d -n "__fish_using_command mm3d Vodka" -l DoCor -d "Use the computed parameters to correct images (Defaut=false) (bool)"
complete -c mm3d -n "__fish_using_command mm3d VV" -l Rate -d "Number of images / sec (Def=4) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d VV" -l SzS -d "Size Sift, (Def=-1 max resol) (INT)"
complete -c mm3d -n "__fish_using_command mm3d VV" -l LineS -d "Line Sift (Def=8) (INT)"
complete -c mm3d -n "__fish_using_command mm3d VV" -l Teta -d "Angle done (Def=180) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Txt" -l OutTxtFile -d "Def file created : 'GpsCoordinatesFromExif.txt'  (string)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Txt" -l Sys -d "System to express output coordinates : WGS84_deg/WGS84_rad/GeoC ; Def=WGS84_deg (string)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Txt" -l DefZ -d "  * [Name=DefZ] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Xml" -l DoRTL -d "Do Local Tangent RTL (def=true) (bool)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Xml" -l RTL -d "Name RTL (string)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Xml" -l SysCo -d "System of coordinates, by default RTL created (RTLFromExif.xml) (string)"
complete -c mm3d -n "__fish_using_command mm3d XifGps2Xml" -l DefZ -d "  * [Name=DefZ] REA (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l MasqSup -d "Supplementary mask (string)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l CorrelIm -d "Use correl image as a mask (string)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l CorrelThr -d "Correl Threshold for acceptance (def=0.02) (REAL)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l OriginIm -d "Original image (used only with OriginImMinVal) (string)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l OriginImMinVal -d "Minimal value for origin image (used only with OriginIm) (INT)"
complete -c mm3d -n "__fish_using_command mm3d Zlimit" -l DEM -d "Output masked DEM (def=true) (bool)"
